% License  
% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~----------
% 
% RawDog Source Code Copyright (c) 2014 Gergely Kajtr.
% 
%  -----------------------------------------
% 
%    RawDog Source Code is copyleft. If you redistribute it, you must freely redistribute it with any modification under this license, you must provide information about the modification (if any), you must credit the developer and the source of the code. 
% 
%    RawDog Source Code is distributed in the hope that it will be useful, but without any warranty; without even the implied warranty of merchantability or fitness for a particular purpose. 
% 
% ------------------------------------------
%   
% 
% Gergely Kajtr 


function varargout = RAWDOG(varargin)
% RAWDOG MATLAB code for RAWDOG.fig
%
%
%
% Last Modified by GUIDE v2.5 24-Feb-2014 11:39:20

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @RAWDOG_OpeningFcn, ...
    'gui_OutputFcn',  @RAWDOG_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

function RAWDOG_OpeningFcn(hObject, ~, handles, ~)

handles.version = '1.4.Final';
handles.username = '';
handles.fullversion = 0;

handles.fileEPS = '';
handles.fileMU = '';
handles.web = 'rawdogapp.weebly.com/donate';
handles.web2 =  'rawdogapp.weebly.com';

handles.output = hObject;
addpath(genpath(pwd));
beep on;
set(0,'ShowHiddenHandles','off');

sid = '';
ni = java.net.NetworkInterface.getNetworkInterfaces;
while ni.hasMoreElements
    addr = ni.nextElement.getHardwareAddress;
    if ~isempty(addr)
        addrStr = dec2hex(int16(addr)+128);
        sid = [sid, '.', reshape(addrStr,1,2*length(addr))];
    end
end
handles.hardwarekey = dec2hex(hex2dec(sid(2:13)) + 34717413147241);    %   kluc miestneho pouzivatela

set(findobj(0,'-property', 'BackgroundColor'),'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));

% Update handles structure
guidata(hObject, handles);

function varargout = RAWDOG_OutputFcn(hObject, ~, handles)

uniqids =  {'F661261992A5','5E33A09F3647','AA2793166120','9367E6956803','92F6895B316A'};
usernames = {'Gergely Kajtar - FEI','Gergely Kajtar','Juraj Chlpik - chlpik@gmail.com','Gergely Kajtar FORTH','Juraj Chlpik 2 - chlpik@gmail.com'};

%[fullversion, username] = ismember(handles.hardwarekey,uniqids);
fullversion = 1; %%% UNLOCKED FULL VERSION

if fullversion == 0
    handles.fullversion = 0;
    guidata(hObject, handles);
    msgbox({'This is the free version of RawDog. Automatic saves do not work. Please consider a donation for the full version. :)';['Visit ' handles.web ' for more info.'];'';...
        ['This is your hardware identity: ' handles.hardwarekey];'';...
        'After you have donated, please send your hardware identity with your request for the full version to gregmaster777@gmail.com'},'RawDog Free','modal')
    set(handles.editoutput,'enable','off')
else
    handles.fullversion = 1;
    handles.username = 'free user';  %usernames{username};
    guidata(hObject, handles);
    set(handles.editoutput,'enable','on')
end

varargout{1} = handles.output;

%%%  correct values and other functions
function correctposvalue(corrvalue,handle)

if isnan(corrvalue)
    errordlg('Enter a positive number, please!','Please correct your input','modal')
    set(handle, 'string',1);
    uicontrol(handle)
    return
elseif corrvalue < 0
    errordlg('Enter a positive number, please!','Please correct your input','modal')
    set(handle, 'string',1);
    uicontrol(handle)
    return
end
function correctcompvalue(corrvalue,handle)

if isnan(corrvalue)
    errordlg('Enter a complex number, please!','Please correct your input','modal')
    set(handle, 'string',1);
    uicontrol(handle)
    return
elseif imag(corrvalue) < 0
    errordlg('Imaginary part can not be negative!','Please correct your input','modal')
    set(handle, 'string',1);
    uicontrol(handle)
    return
end
function correctanglevalue(corrvalue,handle)

if isnan(corrvalue)
    errordlg('Enter a number between -180 and 180, please!','Please correct your input','modal')
    set(handle, 'string',69);
    uicontrol(handle)
    return
elseif corrvalue < -180
    errordlg('Enter a number between -180 and 180, please!','Please correct your input','modal')
    set(handle, 'string',69);
    uicontrol(handle)
    return
elseif corrvalue > 180
    errordlg('Enter a number between -180 and 180, please!','Please correct your input','modal')
    set(handle, 'string',69);
    uicontrol(handle)
    return
end
function correctfillvalue(corrvalue,handle)

if isnan(corrvalue)
    errordlg('Enter a number between 0 and 1, please!','Please correct your input','modal')
    set(handle, 'string',0.42);
    uicontrol(handle)
    return
elseif corrvalue < 0
    errordlg('Enter a number between 0 and 1, please!','Please correct your input','modal')
    set(handle, 'string',0.42);
    uicontrol(handle)
    return
elseif corrvalue > 1
    errordlg('Enter a number between 0 and 1, please!','Please correct your input','modal')
    set(handle, 'string',0.42);
    uicontrol(handle)
    return
elseif corrvalue ==0 || corrvalue ==1
    warndlg({'This structure wont be periodic in the given direction.';'Please consider choosing a different structure type for better speed.'},'Warning','modal')
    uicontrol(handle)
    return
end
function correctpositionvalue(corrvalue,handle)

if isnan(corrvalue)
    errordlg('Enter a number between 0 and 1, please!','Please correct your input','modal')
    set(handle, 'string',0.42);
    uicontrol(handle)
    return
elseif corrvalue < 0
    errordlg('Enter a number between 0 and 1, please!','Please correct your input','modal')
    set(handle, 'string',0.42);
    uicontrol(handle)
    return
elseif corrvalue > 1
    errordlg('Enter a number between 0 and 1, please!','Please correct your input','modal')
    set(handle, 'string',0.42);
    uicontrol(handle)
    return
end

%%%  Helper functions
function answ = diffangles0D(anglefi,permisup,permesup,permisub,permesub)

%%% calculates diffraction angles for periodic structures
%  ans = 101 - total reflection
%  ans = 1-90 normal reflection
%  ans = 102 - absroption

nsup = sqrt(permesup)*sqrt(permisup);
nsub = sqrt(permesub)*sqrt(permisub);

if isreal(nsub)
    if abs(asind(nsup/nsub*sind(anglefi)))>90
        answ = 101;
    else
        answ = (asind(nsup/nsub*sind(anglefi)));
    end
end

if isreal(nsub) == 0
    answ = 102;
end
function [answ, ordsup, diffasup, ordsub, diffasub] = diffangles1D(period,lambda,anglefi,angletet,eps1,mu1,eps2,mu2)

%%% calculates diffraction angles for periodic structures
%  ans = 101 - no absorption
%  ans = 102 - absroption
i = 1;
nsub = sqrt(eps2)*sqrt(mu2);
answ = 101;

fromsup = floor(period/lambda*(-sqrt(eps1*mu1)-sqrt(eps1*mu1)*sind(anglefi)*cosd(angletet)))-2;
tosup =  ceil(period/lambda*(sqrt(eps1*mu1)-sqrt(eps1*mu1)*sind(anglefi)*cosd(angletet)))+2;
fromsub = floor(period/lambda*(-sqrt(eps2*mu2)-sqrt(eps1*mu1)*sind(anglefi)*cosd(angletet)))-2;
tosub =  ceil(period/lambda*(sqrt(eps2*mu2)-sqrt(eps1*mu1)*sind(anglefi)*cosd(angletet)))+2;

ordsup = zeros(tosup-fromsup,1);
diffasup = 100*ones(tosup-fromsup,1);
ordsub = zeros(real(tosub)-real(fromsub),1);
diffasub = 100*ones(real(tosub)-real(fromsub),1);

for s = fromsup:tosup
    if abs(acosd(sqrt(eps1*mu1 - (sqrt(eps1)*sqrt(mu1)*sind(anglefi)*cosd(angletet) + lambda/period*s)^2 - (sqrt(eps1)*sqrt(mu1)*sind(anglefi)*sind(angletet)^2))/(sqrt(eps1)*sqrt(mu1)))) <= 90
        ordsup(i) = s;
        diffasup(i) = acosd(sqrt(eps1*mu1 - (sqrt(eps1)*sqrt(mu1)*sind(anglefi)*cosd(angletet) + lambda/period*s)^2 - (sqrt(eps1)*sqrt(mu1)*sind(anglefi)*sind(angletet))^2)/(sqrt(eps1)*sqrt(mu1)));
        i = i +1;
    end
end
diffasup = diffasup(diffasup <= 90);
ordsup = ordsup(diffasup <= 90);

i = 1;

if isreal(nsub) == 0
    answ = 102;
else
    for s = fromsub:tosub
        if abs(acosd(sqrt(eps2*mu2 - (sqrt(eps1)*sqrt(mu1)*sind(anglefi)*cosd(angletet) + lambda/period*s)^2 - (sqrt(eps1)*sqrt(mu1)*sind(anglefi)*sind(angletet))^2)/(sqrt(eps2)*sqrt(mu2)))) <= 90
            ordsub(i) = s;
            diffasub(i) = acosd(sqrt(eps2*mu2 - (sqrt(eps1)*sqrt(mu1)*sind(anglefi)*cosd(angletet) + lambda/period*s)^2 - (sqrt(eps1)*sqrt(mu1)*sind(anglefi)*sind(angletet))^2)/(sqrt(eps2)*sqrt(mu2)));
            i = i +1;
        end
    end
    diffasub = diffasub(diffasub <= 90);
    ordsub = ordsub(diffasub <= 90);
    
end
function [answ, ordsupx, ordsupy, diffasup, ordsubx, ordsuby, diffasub] = diffangles2D(periodx, periody,lambda,anglefi,angletet,eps1,mu1,eps2,mu2)

%%% calculates diffraction angles for periodic structures
%  ans = 101 - no absorption
%  ans = 102 - absroption
i = 1;
nsub = sqrt(eps2)*sqrt(mu2);
answ = 101;

fromsupx = floor(periodx/lambda*(-sqrt(eps1*mu1)-sqrt(eps1*mu1)*sind(anglefi)*cosd(angletet)))-2;
tosupx =  ceil(periodx/lambda*(sqrt(eps1*mu1)-sqrt(eps1*mu1)*sind(anglefi)*cosd(angletet)))+2;
fromsubx = floor(periodx/lambda*(-sqrt(eps2*mu2)-sqrt(eps1*mu1)*sind(anglefi)*cosd(angletet)))-2;
tosubx =  ceil(periodx/lambda*(sqrt(eps2*mu2)-sqrt(eps1*mu1)*sind(anglefi)*cosd(angletet)))+2;

fromsupy = floor(periody/lambda*(-sqrt(eps1*mu1)-sqrt(eps1*mu1)*sind(anglefi)*sind(angletet)))-2;
tosupy =  ceil(periody/lambda*(sqrt(eps1*mu1)-sqrt(eps1*mu1)*sind(anglefi)*sind(angletet)))+2;
fromsuby = floor(periody/lambda*(-sqrt(eps2*mu2)-sqrt(eps1*mu1)*sind(anglefi)*sind(angletet)))-2;
tosuby =  ceil(periody/lambda*(sqrt(eps2*mu2)-sqrt(eps1*mu1)*sind(anglefi)*sind(angletet)))+2;

ordsupx = zeros((tosupx-fromsupx)*(tosupy-fromsupy),1);
diffasup = 100*ones((tosupx-fromsupx)*(tosupy-fromsupy),1);
ordsupy = zeros((tosupx-fromsupx)*(tosupy-fromsupy),1);
ordsubx = zeros((real(tosubx)-real(fromsubx))*(real(tosuby)-real(fromsuby)),1);
ordsuby = zeros((real(tosubx)-real(fromsubx))*(real(tosuby)-real(fromsuby)),1);
diffasub = 100*ones((real(tosubx)-real(fromsubx))*(real(tosuby)-real(fromsuby)),1);

for s = fromsupx:tosupx
    for t = fromsupy:tosupy
        if abs(acosd(sqrt(eps1*mu1 - (sqrt(eps1)*sqrt(mu1)*sind(anglefi)*cosd(angletet) + lambda/periodx*s)^2 - (sqrt(eps1)*sqrt(mu1)*sind(anglefi)*sind(angletet) + lambda/periody*t)^2)/(sqrt(eps1)*sqrt(mu1)))) <= 90
            ordsupx(i) = s;
            ordsupy(i) = t;
            diffasup(i) = acosd(sqrt(eps1*mu1 - (sqrt(eps1)*sqrt(mu1)*sind(anglefi)*cosd(angletet) + lambda/periodx*s)^2 - (sqrt(eps1)*sqrt(mu1)*sind(anglefi)*sind(angletet) + lambda/periody*t)^2)/(sqrt(eps1)*sqrt(mu1)));
            i = i +1;
        end
    end
end
diffasup = diffasup(diffasup <= 90);
ordsupx = ordsupx(diffasup <= 90);
ordsupy = ordsupy(diffasup <= 90);

i = 1;

if isreal(nsub) == 0
    answ = 102;
else
    for s = fromsubx:tosubx
        for t = fromsuby:tosuby
            if abs(acosd(sqrt(eps2*mu2 - (sqrt(eps1)*sqrt(mu1)*sind(anglefi)*cosd(angletet) + lambda/periodx*s)^2 - (sqrt(eps1)*sqrt(mu1)*sind(anglefi)*sind(angletet) + lambda/periody*t)^2)/(sqrt(eps2)*sqrt(mu2)))) <= 90
                ordsubx(i) = s;
                ordsuby(i) = t;
                diffasub(i) = acosd(sqrt(eps2*mu2 - (sqrt(eps1)*sqrt(mu1)*sind(anglefi)*cosd(angletet) + lambda/periodx*s)^2 - (sqrt(eps1)*sqrt(mu1)*sind(anglefi)*sind(angletet) + lambda/periody*t)^2)/(sqrt(eps2)*sqrt(mu2)));
                i = i +1;
            end
        end
    end
    diffasub = diffasub(diffasub <= 90);
    ordsubx = ordsubx(diffasub <= 90);
    ordsuby = ordsuby(diffasub <= 90);
    
end
function out = degtorad(in)

out = pi .* in ./ 180;
function [NMki,elp] = orderN2(Mki,Mei)

%%%%% reorganizes eigenvalues and eigenvectors for better renormalizing

sl = size(diag(Mei));
N = (sl(1)/2-1)/2;
NMei = Mei;
NMki = Mki;

for j = 1:2*N+1
    
    if abs(Mei(j+2*N+1,j+2*N+1)) > 1
        NMei(j,j) = Mei(j+2*N+1,j+2*N+1);
        NMei(j+2*N+1,j+2*N+1) = Mei(j,j);
        NMki(:,j) = Mki(:,j+2*N+1);
        NMki(:,j+2*N+1) = Mki(:,j);
    end
    
end
h = diag(NMei);
elp = diag(h(2*N+2:2*(2*N+1)));
function [NMki,elp] = orderCon(Mki,Mei,N)

%%%%% reorganizes eigenvalues and eigenvectors for better renormalizing

NMei = Mei;
NMki = Mki;

for j = 1:2*(2*N+1)
    
    if abs((Mei(j+2*(2*N+1),j+2*(2*N+1)))) > 1;
        NMei(j,j) = Mei(j+2*(2*N+1),j+2*(2*N+1));
        NMei(j+2*(2*N+1),j+2*(2*N+1)) = Mei(j,j);
        NMki(:,j) = Mki(:,j+2*(2*N+1));
        NMki(:,j+2*(2*N+1)) = Mki(:,j);
        %     elseif abs((Mei(j+2*(2*N+1),j+2*(2*N+1)))) == 1 && imag((Mei(j+2*(2*N+1),j+2*(2*N+1)))) < 0
        %         NMei(j,j) = Mei(j+2*(2*N+1),j+2*(2*N+1));
        %         NMei(j+2*(2*N+1),j+2*(2*N+1)) = Mei(j,j);
        %         NMki(:,j) = Mki(:,j+2*(2*N+1));
        %         NMki(:,j+2*(2*N+1)) = Mki(:,j);
    end
    
end
h = diag(NMei);
elp = diag(h((2*(2*N+1)+1):2*(2*(2*N+1))));
function [NMki,elp] = order2D(Mki,eln,elp,N)

%%%%% reorganizes eigenvalues and eigenvectors for better renormalizing


Mei = [elp,zeros(2*(2*N+1)^2);zeros(2*(2*N+1)^2),eln];
NMei = Mei;
NMki = Mki;

for j = 1:2*(2*N+1)^2
    
    if abs((Mei(j+2*(2*N+1)^2,j+2*(2*N+1)^2))) >1;...- abs(real(Mei(j,j))) > 0.00
            NMei(j,j) = Mei(j+2*(2*N+1)^2,j+2*(2*N+1)^2);
        NMei(j+2*(2*N+1)^2,j+2*(2*N+1)^2) = Mei(j,j);
        NMki(:,j) = Mki(:,j+2*(2*N+1)^2);
        NMki(:,j+2*(2*N+1)^2) = Mki(:,j);
    end
    
end
h = diag(NMei);
elp = diag(h((2*(2*N+1)^2+1):2*(2*(2*N+1)^2)));
function E = outEA(e1,diff,e2,fill,m,N)

%%%%%%%%%% Fourierov rozvoj pre m RANDOM period pre AnizE.m
% e1 - rel. permitivita tycky
% e2 - rel. permitivita okolia
% fill - filling faktor
% N  - pocet modov

h = -2*N:1:2*N;
e1 = rand(1,2*m+1)*diff + e1;
L = -m:1:m;
Eh = zeros(1,4*N+1);

for j = 1:4*N+1
    
    Eh(1,j) = e2*(sinc(h(j)/(2*m+1)) - fill*sinc(h(j)*fill/(2*m+1))).*diric(h(j)*pi*2/(2*m+1),(2*m+1)) + fill/(2*m+1)*sinc(h(j)*fill/(2*m+1))*sum(e1.*exp(-1i*2*pi*L*h(j)/(2*m+1)));
    
end

E = zeros(2*N+1,2*N+1);

for i=1:2*N+1
    for s= 1:2*N+1
        E(i,s) = Eh(2*N+1-s+i);
    end
end
function y=sinc(x)
%SINC Sin(pi*x)/(pi*x) function.
%

y=ones(size(x));
i=find(x);
y(i)=sin(pi*x(i))./(pi*x(i));

%%%  Main functions
function [energy, reflectance, transmittance] = braggTE(lambda,fi,relpro1,mi1,d,epsa,mua,d2,epsl2,mul2,relpro2,mi2,K,K2,def)

k = 2*pi/lambda;    % vlnove cislo

kx = k*sqrt(relpro1*mi1)*sin(fi);    % vektor k(xs) z rovnice (3) a (13)
kx2 = kx.*kx;                                   % kx na druhej mocnine, rovnica (13)

kz1 = sqrt(relpro1*mi1*k^2 - kx2);
kz2 = sqrt(relpro2*mi2*k^2 - kx2);
kzm1 = diag(kz1);
kzm2 = diag(kz2);
ekzn2 = diag(exp(-1i*diag(kzm2)*((d+d2)*(K+K2)+def)));

M01t = [0;1];
M01 = [0,1];
M10 = [1,0];
Mk1 = [1,1;-kzm1/(mi1),kzm1/(mi1)];
Mk2 = [1,1;-kzm2/(mi2),kzm2/(mi2)];

Mii = Mk2*M01t*1i;
Pii = 1i;

for t = 1:K2    %%%% prve opakovanie
    
    C = - diag(kx2) +k^2*mul2*epsl2;            %%%%%% Prvy Layer
    
    elp = diag(exp(1i*sqrt(C)*d2));
    
    Mki = [1,1;sqrt(C)/mul2,-sqrt(C)/mul2];    % <<<< toto plati len S INVerznym trikom, bez toho toje A = E\ !!!!
    
    
    Mi =  Mki\Mii;                                       %% nova renorm.
    Bi = Mki*[1;elp*(M01*Mi)/(M10*Mi)*elp];
    Mii = Bi;
    PiX = Pii*((M10*Mi)\elp);
    Pii = PiX;
    
    C = - diag(kx2) + k^2*mua*epsa;           %%%%%%%%%%% Druhy Layer
    
    elp = diag(exp(1i*sqrt(C)*d));
    
    Mki = [1,1;sqrt(C)/mua,-sqrt(C)/mua];    % <<<< toto plati len S INVerznym trikom, bez toho toje A = E\ !!!!
    
    
    Mi =  Mki\Mii;                                       %% nova renorm.
    Bi = Mki*[1;elp*(M01*Mi)/(M10*Mi)*elp];
    Mii = Bi;
    PiX = Pii*((M10*Mi)\elp);
    Pii = PiX;
    
end

C = - diag(kx2) + k^2*mul2*epsl2;           %%%  DEFEKT

elp = diag(exp(1i*sqrt(C)*def));

Mki = [1,1;sqrt(C)/mul2,-sqrt(C)/mul2];    % <<<< toto plati len S INVerznym trikom, bez toho toje A = E\ !!!!


Mi =  Mki\Mii;                                       %% nova renorm.
Bi = Mki*[1;elp*(M01*Mi)/(M10*Mi)*elp];
Mii = Bi;
PiX = Pii*((M10*Mi)\elp);
Pii = PiX;

for s = 1:K       %%%%% Druhe Opakovanie
    
    C = - diag(kx2) + k^2*mul2*epsl2;           %%%%%% Prvy Layer
    
    elp = diag(exp(1i*sqrt(C)*d2));
    
    Mki = [1,1;sqrt(C)/mul2,-sqrt(C)/mul2];    % <<<< toto plati len S INVerznym trikom, bez toho toje A = E\ !!!!
    
    
    Mi =  Mki\Mii;                                       %% nova renorm.
    Bi = Mki*[1;elp*(M01*Mi)/(M10*Mi)*elp];
    Mii = Bi;
    PiX = Pii*((M10*Mi)\elp);
    Pii = PiX;
    
    C = - diag(kx2) + k^2*mua*epsa;           %%% Druhy layer
    
    elp = diag(exp(1i*sqrt(C)*d));
    
    Mki = [1,1;sqrt(C)/mua,-sqrt(C)/mua];    % <<<< toto plati len S INVerznym trikom, bez toho toje A = E\ !!!!
    
    
    Mi =  Mki\Mii;                                       %% nova renorm.
    Bi = Mki*[1;elp*(M01*Mi)/(M10*Mi)*elp];
    Mii = Bi;
    PiX = Pii*((M10*Mi)\elp);
    Pii = PiX;
    
end

Bi = M01/Mk1*Mii;
t = ekzn2*Pii/Bi;            % koeficienty t a r
r = (M10/Mk1)*Mii/Bi;
TT = (abs(t).*abs(t));        % amplitudove koeficienty
RR = (abs(r).*abs(r));

kzr = 0;
RRR = 0;
kzt = 0;
TTT = 0;

if isreal(kz1)
    kzr = kz1;
    RRR = RR;
end

if isreal(kz2)
    kzt = kz2;
    TTT = TT;
end

transmittance = TTT.*kzt/(k*mi2*sqrt(relpro1)/sqrt(mi1)*cos(fi));
reflectance = RRR.*kzr/(k*sqrt(relpro1)*sqrt(mi1)*cos(fi));

energy = sum(reflectance) + sum(transmittance);
function [energy, reflectance, transmittance] = braggTM(lambda,fi,relpro1,mi1,d,epsa,mua,d2,epsl2,mul2,relpro2,mi2,K,K2,def)


k = 2*pi/lambda;    % vlnove cislo

kx = k*sqrt(relpro1*mi1)*sin(fi);    % vektor k(xs) z rovnice (3) a (13)
kx2 = kx.*kx;                                   % kx na druhej mocnine, rovnica (13)

kz1 = sqrt(relpro1*mi1*k^2 - kx2);
kz2 = sqrt(relpro2*mi2*k^2 - kx2);
kzm1 = diag(kz1);
kzm2 = diag(kz2);
ekzn2 = diag(exp(-1i*diag(kzm2)*((d+d2)*(K+K2)+def)));

M01t = [0;1];
M01 = [0,1];
M10 = [1,0];
Mk1 = [1,1;-kzm1/(relpro1),kzm1/(relpro1)];
Mk2 = [1,1;-kzm2/(relpro2),kzm2/(relpro2)];

Mii = Mk2*M01t*1i;
Pii = 1i;

for t = 1:K2    %%%% prve opakovanie
    
    C = - diag(kx2) + k^2*mul2*epsl2;           %%%%%% Prvy Layer
    
    elp = diag(exp(1i*sqrt(C)*d2));
    
    Mki = [1,1;sqrt(C)/epsl2,-sqrt(C)/epsl2];    % <<<< toto plati len S INVerznym trikom, bez toho toje A = E\ !!!!
    
    
    Mi =  Mki\Mii;                                       %% nova renorm.
    Bi = Mki*[1;elp*(M01*Mi)/(M10*Mi)*elp];
    Mii = Bi;
    PiX = Pii*((M10*Mi)\elp);
    Pii = PiX;
    
    C = - diag(kx2) + k^2*mua*epsa;           %%%%%%%%%%% Druhy Layer
    
    elp = diag(exp(1i*sqrt(C)*d));
    
    Mki = [1,1;sqrt(C)/epsa,-sqrt(C)/epsa];    % <<<< toto plati len S INVerznym trikom, bez toho toje A = E\ !!!!
    
    
    Mi =  Mki\Mii;                                       %% nova renorm.
    Bi = Mki*[1;elp*(M01*Mi)/(M10*Mi)*elp];
    Mii = Bi;
    PiX = Pii*((M10*Mi)\elp);
    Pii = PiX;
    
end

C = - diag(kx2) + k^2*mul2*epsl2;           %%%  DEFEKT

elp = diag(exp(1i*sqrt(C)*def));

Mki = [1,1;sqrt(C)/epsl2,-sqrt(C)/epsl2];    % <<<< toto plati len S INVerznym trikom, bez toho toje A = E\ !!!!


Mi =  Mki\Mii;                                       %% nova renorm.
Bi = Mki*[1;elp*(M01*Mi)/(M10*Mi)*elp];
Mii = Bi;
PiX = Pii*((M10*Mi)\elp);
Pii = PiX;

for s = 1:K       %%%%% Druhe Opakovanie
    
    C = - diag(kx2) + k^2*mul2*epsl2;           %%%%%% Prvy Layer
    
    elp = diag(exp(1i*sqrt(C)*d2));
    
    Mki = [1,1;sqrt(C)/epsl2,-sqrt(C)/epsl2];    % <<<< toto plati len S INVerznym trikom, bez toho toje A = E\ !!!!
    
    
    Mi =  Mki\Mii;                                       %% nova renorm.
    Bi = Mki*[1;elp*(M01*Mi)/(M10*Mi)*elp];
    Mii = Bi;
    PiX = Pii*((M10*Mi)\elp);
    Pii = PiX;
    
    C = - diag(kx2) + k^2*mua*epsa;           %%% Druhy layer
    
    elp = diag(exp(1i*sqrt(C)*d));
    
    Mki = [1,1;sqrt(C)/epsa,-sqrt(C)/epsa];    % <<<< toto plati len S INVerznym trikom, bez toho toje A = E\ !!!!
    
    
    Mi =  Mki\Mii;                                       %% nova renorm.
    Bi = Mki*[1;elp*(M01*Mi)/(M10*Mi)*elp];
    Mii = Bi;
    PiX = Pii*((M10*Mi)\elp);
    Pii = PiX;
    
end

Bi = M01/Mk1*Mii;
t = ekzn2*Pii/Bi;            % koeficienty t a r
r = (M10/Mk1)*Mii/Bi;
TT = (abs(t).*abs(t));        % amplitudove koeficienty
RR = (abs(r).*abs(r));

% vylucime koeficienty evanescentnych modov
kzr = 0;
RRR = 0;
kzt = 0;
TTT = 0;

if isreal(kz1)
    kzr = kz1;
    RRR = RR;
end

if isreal(kz2)
    kzt = kz2;
    TTT = TT;
end


transmittance = TTT.*kzt/(k*relpro2*sqrt(mi1/relpro1)*cos(fi));
reflectance = RRR.*kzr/(k*sqrt(relpro1*mi1)*cos(fi));

energy = sum(reflectance) + sum(transmittance);
function [energy, reflectance, transmittance] = SoTE(N,p,lambda,fi,relpro1,mi1,d,fill,rels,relperm,mis,mip,drels,epsl2,mil2,relpro2,mi2,K,K2,def)

% N pocet Fourierovych radov
% w pocet vrstiev je w-1
% p peri�da mriezky
% lambda vlnova dlzka
% fi uhol dopadu
% d hrubka mriezky
% Q filling faktor
% relperm relativna permitivita mriezky
% rels  relativna permitivita superstratu
% relpro1 relativna permitivita prostredia c.1
% relpro2 relativna permitivita prostredia c.2
% mi1 relativna permeabilita prostredia c. 1
% q filling faktor (nepouzivame pokial mriezka je harmonicka)
% drels hrubka homogennej casti bunky - defektu
% v pocet podvrstiev homogennej casti
% K pocet buniek

dd = d;           % hrubka jednej podvrstvy
ddrels = drels;
k = 2*pi/lambda; 	% vlnove cislo
h = -N:1:N;         % vektor h z rovnice (1) a (1.1)

ep = toeplitz(0:2*N,0:-1:-2*N);
kx = k*sqrt(relpro1*mi1)*sin(fi) + h*2*pi/p;    % vektor k(xs) z rovnice (3) a (13)
kx2 = kx.*kx;                                   % kx na druhej mocnine, rovnica (13)

o = zeros(2*N+1,1);
o(N+1) = 1;                                     % vektor o ma same nuly okrem v strede, to je potrebne k pociatocnej podmienke
kz1 = sqrt(relpro1*mi1*k^2 - kx2);
kz2 = sqrt(relpro2*mi2*k^2 - kx2);
kzm1 = diag(kz1);
kzm2 = diag(kz2);
ekzn2 = diag(exp(-1i*diag(kzm2)*((d+drels)*(K+K2)+def)));

M01t = [zeros(2*N+1);eye(2*N+1)];
M01 = [zeros(2*N+1),eye(2*N+1)];
M10 = [eye(2*N+1),zeros(2*N+1)];
Mk1 = [eye(2*N+1),eye(2*N+1);-kzm1/(mi1),kzm1/(mi1)];
Mk2 = [eye(2*N+1),eye(2*N+1);-kzm2/(mi2),kzm2/(mi2)];

Mii = Mk2*M01t*1i;
Pii = eye(2*N+1)*1i;

for t = 1:K2
    
    q = 0;
    
    E = (relperm-rels)*q*sinc(ep*q) + epsl2*sinc(ep);
    MI = (mip-mis)*q*sinc(ep*q) + mil2*sinc(ep);
    IM = (1/mip-1/mis)*q*sinc(ep*q) + 1/mil2*sinc(ep);
    
    C = - inv(IM)*diag(kx)/MI*diag(kx) + k^2*E/IM;
    [Q,L] = eig(C);
    
    Mki = [Q,Q;IM*Q*sqrt(L),-IM*Q*sqrt(L)];
    elp = diag(exp(1i*diag(sqrt(L))*ddrels));
    eln = diag(exp(-1i*diag(sqrt(L))*ddrels));
    Mei = [eln,zeros(2*N+1);zeros(2*N+1),elp];
    
    [Mki,elp] = orderN2(Mki,Mei);
    
    Mi =  Mki\Mii;
    Bi = Mki*[eye(2*N+1);elp*(M01*Mi)/(M10*Mi)*elp];
    Mii = Bi;
    Pi = Pii*((M10*Mi)\elp);
    Pii = Pi;
    
    q = fill;
    
    E = (relperm-rels)*q*sinc(ep*q) + rels*sinc(ep);
    
    MI = (mip-mis)*q*sinc(ep*q) + mis*sinc(ep);
    IM = (1/mip-1/mis)*q*sinc(ep*q) + 1/mis*sinc(ep);
    
    C = - inv(IM)*diag(kx)/MI*diag(kx) + IM\E*(k^2);         %%%%%%% INVERZ TRIK
    [Q,L] = eig(C);
    
    elp = diag(exp(1i*diag(sqrt(L))*dd));
    eln = diag(exp(-1i*diag(sqrt(L))*dd));
    
    Mki = [Q,Q;IM*Q*sqrt(L),-IM*Q*sqrt(L)];
    Mei = [eln,zeros(2*N+1);zeros(2*N+1),elp];
    
    [Mki,elp] = orderN2(Mki,Mei);
    
    Mi =  Mki\Mii;
    Bi = Mki*[eye(2*N+1);elp*(M01*Mi)/(M10*Mi)*elp];
    Mii = Bi;
    Pi = Pii*((M10*Mi)\elp);
    Pii = Pi;
    

    
end

q = 0;

E = (relperm-rels)*q*sinc(ep*q) + epsl2*sinc(ep);
MI = (mip-mis)*q*sinc(ep*q) + mil2*sinc(ep);
IM = (1/mip-1/mis)*q*sinc(ep*q) + 1/mil2*sinc(ep);

C = - inv(IM)*diag(kx)/MI*diag(kx) + k^2*E/IM;
[Q,L] = eig(C);

Mki = [Q,Q;IM*Q*sqrt(L),-IM*Q*sqrt(L)];
elp = diag(exp(1i*diag(sqrt(L))*def));
eln = diag(exp(-1i*diag(sqrt(L))*def));
Mei = [eln,zeros(2*N+1);zeros(2*N+1),elp];

[Mki,elp] = orderN2(Mki,Mei);

Mi =  Mki\Mii;
Bi = Mki*[eye(2*N+1);elp*(M01*Mi)/(M10*Mi)*elp];
Mii = Bi;
Pi = Pii*((M10*Mi)\elp);
Pii = Pi;

for t = 1:K
    
    q = 0;
    
    E = (relperm-rels)*q*sinc(ep*q) + epsl2*sinc(ep);
    MI = (mip-mis)*q*sinc(ep*q) + mil2*sinc(ep);
    IM = (1/mip-1/mis)*q*sinc(ep*q) + 1/mil2*sinc(ep);
    
    C = - inv(IM)*diag(kx)/MI*diag(kx) + k^2*E/IM;
    [Q,L] = eig(C);
    
    Mki = [Q,Q;IM*Q*sqrt(L),-IM*Q*sqrt(L)];
    elp = diag(exp(1i*diag(sqrt(L))*ddrels));
    eln = diag(exp(-1i*diag(sqrt(L))*ddrels));
    Mei = [eln,zeros(2*N+1);zeros(2*N+1),elp];
    
    [Mki,elp] = orderN2(Mki,Mei);
    
    Mi =  Mki\Mii;
    Bi = Mki*[eye(2*N+1);elp*(M01*Mi)/(M10*Mi)*elp];
    Mii = Bi;
    Pi = Pii*((M10*Mi)\elp);
    Pii = Pi;   
        
    q = fill;
    
    E = (relperm-rels)*q*sinc(ep*q) + rels*sinc(ep);
    MI = (mip-mis)*q*sinc(ep*q) + mis*sinc(ep);
    IM = (1/mip-1/mis)*q*sinc(ep*q) + 1/mis*sinc(ep);
    
    C = - inv(IM)*diag(kx)/MI*diag(kx) + k^2*E/IM;         %%%%%%% INVERZ TRIK
    [Q,L] = eig(C);
    
    elp = diag(exp(1i*diag(sqrt(L))*dd));
    eln = diag(exp(-1i*diag(sqrt(L))*dd));
    
    Mki = [Q,Q;IM*Q*sqrt(L),-IM*Q*sqrt(L)];
    Mei = [eln,zeros(2*N+1);zeros(2*N+1),elp];
    
    [Mki,elp] = orderN2(Mki,Mei);
    
    Mi =  Mki\Mii;
    Bi = Mki*[eye(2*N+1);elp*(M01*Mi)/(M10*Mi)*elp];
    Mii = Bi;
    Pi = Pii*((M10*Mi)\elp);
    Pii = Pi;
    
end

Bi = M01/Mk1*Mii;
t = ekzn2*Pii/Bi*o;            % koeficienty t a r
r = (M10/Mk1)*Mii/Bi*o;
TT = (abs(t).*abs(t));        % amplitudove koeficienty
RR = (abs(r).*abs(r));

% vylucime koeficienty evanescentnych modov
kzr = zeros(1,2*N+1);
RRR = zeros(1,2*N+1);
kzt = zeros(1,2*N+1);
TTT = zeros(1,2*N+1);

for s = 1:2*N+1
    
    if isreal(kz1(s))
        kzr(s) = kz1(s);
        RRR(s) = RR(s);
    end
    
    if isreal(kz2(s))
        kzt(s) = kz2(s);
        TTT(s) = TT(s);
    end
    
end

transmittance = TTT.*kzt/(k*mi2*sqrt(relpro1/mi1)*cos(fi));
reflectance = RRR.*kzr/(k*sqrt(relpro1*mi1)*cos(fi));

energy = sum(reflectance) + sum(transmittance);
function [energy, reflectance, transmittance] = SoTM(N,p,lambda,fi,relpro1,mi1,d,fill,rels,relperm,mis,mip,drels,epsl2,mil2,relpro2,mi2,K,K2,def)

% N pocet Fourierovych radov
% w pocet vrstiev je w-1
% p peri�da mriezky
% lambda vlnova dlzka
% fi uhol dopadu
% d hrubka mriezky
% Q filling faktor
% relperm relativna permitivita mriezky
% rels  relativna permitivita superstratu
% relpro1 relativna permitivita prostredia c.1
% relpro2 relativna permitivita prostredia c.2
% q filling faktor (nepouzivame pokial mriezka je harmonicka)
% drels hrubka homogennej casti bunky
% v pocet podvrstiev homogennej casti
% K pocet buniek

dd = d;           % hrubka jednej podvrstvy
ddrels = drels;
k = 2*pi/lambda;    % vlnove cislo
h = -N:1:N;         % vektor h z rovnice (1) a (1.1)

ep = toeplitz(0:2*N,0:-1:-2*N);
kx = k*sqrt(relpro1*mi1)*sin(fi) + h*2*pi/p;    % vektor k(xs) z rovnice (3) a (13)
kx2 = kx.*kx;                                   % kx na druhej mocnine, rovnica (13)

o = zeros(2*N+1,1);
o(N+1) = 1;                % vektor o ma same nuly okrem v strede, to je potrebne k pociatocnej podmienke
kz1 = sqrt(relpro1*mi1*k^2 - kx2);
kz2 = sqrt(relpro2*mi2*k^2 - kx2);
kzm1 = diag(kz1);
kzm2 = diag(kz2);
ekzn2 = diag(exp(-1i*diag(kzm2)*((dd+ddrels)*(K+K2)+def)));

M01t = [zeros(2*N+1);eye(2*N+1)];
M01 = [zeros(2*N+1),eye(2*N+1)];
M10 = [eye(2*N+1),zeros(2*N+1)];
Mk1 = [eye(2*N+1),eye(2*N+1);-kzm1/(relpro1),kzm1/(relpro1)];
Mk2 = [eye(2*N+1),eye(2*N+1);-kzm2/(relpro2),kzm2/(relpro2)];

Mii = Mk2*M01t*1i;
Pii = eye(2*N+1)*1i;

for t = 1:K2

    q = 0;
    
    E = (relperm-rels)*q*sinc(ep*q) + epsl2*sinc(ep);
    A = (1/relperm-1/rels)*q*sinc(ep*q) + 1/epsl2*sinc(ep);
    MI = (mip-mis)*q*sinc(ep*q) + mil2*sinc(ep);
    
    C =  - inv(A)*diag(kx)/E*diag(kx) + A\MI*k^2;           %%%%%%%%%%% INVERZ TRIK
    
    [Q,L] = eig(C);
    
    elp = diag(exp(1i*diag(sqrt(L))*ddrels));
    eln = diag(exp(-1i*diag(sqrt(L))*ddrels));
    
    Mei = [eln,zeros(2*N+1);zeros(2*N+1),elp];
    Mki = [Q,Q;A*Q*sqrt(L),-A*Q*sqrt(L)];    % <<<< toto plati len S INVerznym trikom, bez toho toje A = E\ !!!!
    
    [Mki,elp] = orderN2(Mki,Mei);                   %% reordering
    
    Mi =  Mki\Mii;                                       %% nova renorm.
    Bi = Mki*[eye(2*N+1);elp*(M01*Mi)/(M10*Mi)*elp];
    Mii = Bi;
    PiX = Pii*((M10*Mi)\elp);
    Pii = PiX;
    
    q = fill;
    
    E = (relperm-rels)*q*sinc(ep*q) + rels*sinc(ep);
    A = (1/relperm-1/rels)*q*sinc(ep*q) + 1/rels*sinc(ep);
    MI = (mip-mis)*q*sinc(ep*q) + mis*sinc(ep);
    
    C = - inv(A)*diag(kx)/E*diag(kx)  + k^2*MI/A;     %%%%%%%%%%% INVERZ TRIK
    [Q,L] = eig(C);
    
    elp = diag(exp(1i*diag(sqrt(L))*dd));
    eln = diag(exp(-1i*diag(sqrt(L))*dd));
    
    Mei = [eln,zeros(2*N+1);zeros(2*N+1),elp];
    Mki = [Q,Q;A*Q*sqrt(L),-A*Q*sqrt(L)];    % <<<< toto plati len S INVerznym trikom, bez toho toje A = E\ !!!!
    
    [Mki,elp] = orderN2(Mki,Mei);                   %% reordering
    
    Mi =  Mki\Mii;                                       %% nova renorm.
    Bi = Mki*[eye(2*N+1);elp*(M01*Mi)/(M10*Mi)*elp];
    Mii = Bi;
    PiX = Pii*((M10*Mi)\elp);
    Pii = PiX;
    
end

q = 0;

E = (relperm-rels)*q*sinc(ep*q) + epsl2*sinc(ep);
A = (1/relperm-1/rels)*q*sinc(ep*q) + 1/epsl2*sinc(ep);
MI = (mip-mis)*q*sinc(ep*q) + mil2*sinc(ep);

C = - inv(A)*diag(kx)/E*diag(kx) + k^2*MI/A;           %%%%%%%%%%% INVERZ TRIK

[Q,L] = eig(C);

elp = diag(exp(1i*diag(sqrt(L))*def));
eln = diag(exp(-1i*diag(sqrt(L))*def));

Mei = [eln,zeros(2*N+1);zeros(2*N+1),elp];
Mki = [Q,Q;A*Q*sqrt(L),-A*Q*sqrt(L)];    % <<<< toto plati len S INVerznym trikom, bez toho toje A = E\ !!!!

[Mki,elp] = orderN2(Mki,Mei);                   %% reordering

Mi =  Mki\Mii;                                       %% nova renorm.
Bi = Mki*[eye(2*N+1);elp*(M01*Mi)/(M10*Mi)*elp];
Mii = Bi;
PiX = Pii*((M10*Mi)\elp);
Pii = PiX;

for t = 1:K
    
    q = 0;
    
    E = (relperm-rels)*q*sinc(ep*q) + epsl2*sinc(ep);
    A = (1/relperm-1/rels)*q*sinc(ep*q) + 1/epsl2*sinc(ep);
    MI = (mip-mis)*q*sinc(ep*q) + mil2*sinc(ep);
    
    C = - inv(A)*diag(kx)/E*diag(kx) + k^2*MI/A;           %%%%%%%%%%% INVERZ TRIK
    
    [Q,L] = eig(C);
    
    elp = diag(exp(1i*diag(sqrt(L))*ddrels));
    eln = diag(exp(-1i*diag(sqrt(L))*ddrels));
    
    Mei = [eln,zeros(2*N+1);zeros(2*N+1),elp];
    Mki = [Q,Q;A*Q*sqrt(L),-A*Q*sqrt(L)];    % <<<< toto plati len S INVerznym trikom, bez toho toje A = E\ !!!!
    
    [Mki,elp] = orderN2(Mki,Mei);                   %% reordering
    
    Mi =  Mki\Mii;                                       %% nova renorm.
    Bi = Mki*[eye(2*N+1);elp*(M01*Mi)/(M10*Mi)*elp];
    Mii = Bi;
    PiX = Pii*((M10*Mi)\elp);
    Pii = PiX;
    
    q = fill;
    
    E = (relperm-rels)*q*sinc(ep*q) + rels*sinc(ep);
    A = (1/relperm-1/rels)*q*sinc(ep*q) + 1/rels*sinc(ep);
    MI = (mip-mis)*q*sinc(ep*q) + mis*sinc(ep);
    
    C = - inv(A)*diag(kx)/E*diag(kx) + k^2*MI/A;           %%%%%%%%%%% INVERZ TRIK
    [Q,L] = eig(C);
    
    elp = diag(exp(1i*diag(sqrt(L))*dd));
    eln = diag(exp(-1i*diag(sqrt(L))*dd));
    
    Mei = [eln,zeros(2*N+1);zeros(2*N+1),elp];
    Mki = [Q,Q;A*Q*sqrt(L),-A*Q*sqrt(L)];    % <<<< toto plati len S INVerznym trikom, bez toho toje A = E\ !!!!
    
    [Mki,elp] = orderN2(Mki,Mei);                   %% reordering
    
    Mi =  Mki\Mii;                                       %% nova renorm.
    Bi = Mki*[eye(2*N+1);elp*(M01*Mi)/(M10*Mi)*elp];
    Mii = Bi;
    PiX = Pii*((M10*Mi)\elp);
    Pii = PiX;
    
end

Bi = M01/Mk1*Mii;
t = ekzn2*Pii/Bi*o;            % koeficienty t a r
r = (M10/Mk1)*Mii/Bi*o;
TT = (abs(t).*abs(t));        % amplitudove koeficienty
RR = (abs(r).*abs(r));
% vylucime koeficienty evanescentnych modov
kzr = zeros(1,2*N+1);
RRR = zeros(1,2*N+1);
kzt = zeros(1,2*N+1);
TTT = zeros(1,2*N+1);

for s = 1:2*N+1
    
    if isreal(kz1(s))
        kzr(s) = kz1(s);
        RRR(s) = RR(s);
    end
    
    if isreal(kz2(s))
        kzt(s) = kz2(s);
        TTT(s) = TT(s);
    end
    
end

transmittance = TTT.*kzt/(k*relpro2*sqrt(mi1/relpro1)*cos(fi));
reflectance = RRR.*kzr/(k*sqrt(relpro1*mi1)*cos(fi));

energy = sum(reflectance) + sum(transmittance);
function [energy, ref, trans] = Scon(N,px,lambda,fi,psi,tet,d,q,relpro1,rels,relperm,relpro2,mi1,mis,mip,mi2,permK,miK,dK,K)

% N pocet Fourierovych radov
% w pocet vrstiev je w-1
% px peri�da mriezky x -ovej osi
% lambda vlnova dlzka
% fi uhol dopadu
% psi uhol polarizacie
% tet uhol medzi dopadovou rovinou a osou x
% d hrubka mriezky
% relperm relativna permitivita mriezky
% rels  relativna permitivita superstratu
% relpro1 relativna permitivita prostredia c.1
% relpro2 relativna permitivita prostredia c.2
% fillx filling faktor v smere x
% energy - musi rovnat jednej

%%%%%%%%%%%%%  (Nugrowati style recomposed)  S INVERZNYM TRIKOM +
%%%%%%%%%%%%%  RENORMALIZACIA - Rv je diagonalna (predpoklad)

if  dK == 0   %%% stabilitu pre vyssie rady dava...
    permK = 2;
end


k = 2*pi/lambda;     % vlnove cislo
hx = -N:1:N;
ep = toeplitz(0:2*N,0:-1:-2*N);

kx = k*sqrt(relpro1*mi1)*sin(fi)*cos(tet) + hx*2*pi/px;
ky = k*sqrt(relpro1*mi1)*sin(fi)*sin(tet);

kz1 = sqrt(relpro1*mi1*k^2 - ky*ky - kx.*kx);
kz2 = sqrt(relpro2*mi2*k^2 - ky*ky - kx.*kx);
kzm1 = diag(kz1);
kzm2 = diag(kz2);
kx2 = kx.*kx;
ky2 = ky.*ky;
kxm = diag(kx);
kym = ky;

ekzn2 = diag(exp(-1i*kz2*(d+dK)*K));

E = (relperm-rels)*q*sinc(ep*q) + rels*sinc(ep);
A = (1/relperm-1/rels)*q*sinc(ep*q) + 1/rels*sinc(ep);
MI = (mip-mis)*q*sinc(ep*q) + mis*sinc(ep);
IM = (1/mip-1/mis)*q*sinc(ep*q) + 1/mis*sinc(ep);

e = E; E = (eye((2*N+1)))/(A); A = (eye((2*N+1)))/(e);           %%INVERZ TRIK
mm = MI; MI = (eye((2*N+1)))/(IM); IM = (eye((2*N+1)))/(mm);          %%INVERZ TRIK

oxE = zeros((2*N+1),1);
oyE = zeros((2*N+1),1);
oxE(N+1) = - cos(psi)*sin(tet) + sin(psi)*cos(fi)*cos(tet);   % vektor o ma same nuly okrem v strede, to je potrebne k pociatocnej podmienke
oyE(N+1) = cos(psi)*cos(tet) + sin(psi)*cos(fi)*sin(tet);
oE = [oxE;oyE];

C11E = k^2*mm*E - eye(2*N+1)*ky2 - diag(kx)*A*diag(kx)*E;
C12E = zeros(2*N+1);
C21E = MI*diag(kx)*IM*ky - ky*A*diag(kx)*E;
C22E = k^2*MI*e - MI*diag(kx)*IM*diag(kx) - ky2*eye(2*N+1);

CE = [C11E, C12E; C21E, C22E];
[QE,LE] = eig(CE);

C11H = k^2*e*MI - diag(kx)*IM*diag(kx)*MI  - ky2*eye(2*N+1);
C12H = zeros(2*N+1);
C21H = - ky*IM*diag(kx)*MI + E*diag(kx)*A*ky;
C22H = k^2*E*mm - ky2*eye(2*N+1)  - E*diag(kx)*A*diag(kx);

CH = [C11H, C12H; C21H, C22H];
[QH,LH] = eig(CH);

% [QE,LE]= sortem(QE,LE);
% [QH,LH]= sortem(QH,LH);

QEx = QE(1:(2*N+1),1:2*(2*N+1));
QEy = QE((2*N+1)+1:2*(2*N+1),1:2*(2*N+1));

elpE = diag(exp(1i*diag(sqrt(LE))*d));
elnE = diag(exp(-1i*diag(sqrt(LE))*d));
Mei = [elnE,zeros(2*(2*N+1));zeros(2*(2*N+1)),elpE];

C11EK = k^2*eye((2*N+1))*permK*miK - ky2*eye(2*N+1) - diag(kx2);  %%% HOMOGENNA VRSTVA
C12EK = zeros(2*N+1);
C21EK = zeros(2*N+1);
C22EK = k^2*eye((2*N+1))*permK*miK - diag(kx2) - ky2*eye(2*N+1);

CEK = [C11EK, C12EK; C21EK, C22EK];
[QEK,LEK] = eig(CEK);

C11HK = k^2*eye((2*N+1))*permK*miK - diag(kx2)  - ky2*eye(2*N+1);
C12HK = zeros(2*N+1);
C21HK = zeros(2*N+1);
C22HK = k^2*eye((2*N+1))*permK*miK - ky2*eye(2*N+1)  - diag(kx2);

CHK = [C11HK, C12HK; C21HK, C22HK];
[QHK,LHK] = eig(CHK);

% [QEK,LEK]= sortem(QEK,LEK);
% [QHK,LHK]= sortem(QHK,LHK);

QExK = QEK(1:(2*N+1),1:2*(2*N+1));
QEyK = QEK((2*N+1)+1:2*(2*N+1),1:2*(2*N+1));

elpEK = diag(exp(1i*diag(sqrt(LEK))*dK));
elnEK = diag(exp(-1i*diag(sqrt(LEK))*dK));
MeKi = [elpEK,zeros(2*(2*N+1));zeros(2*(2*N+1)),elnEK];

Rr = relpro1*[kxm*kym/(kzm1*relpro1*mi1*k^2), eye((2*N+1))/kzm1 - kxm*kxm/(kzm1*relpro1*mi1*k^2);...
    -eye((2*N+1))/kzm1+kym*kym*eye((2*N+1))/(kzm1*relpro1*mi1*k^2),- kxm*kym/(kzm1*relpro1*mi1*k^2)];

Ro = relpro1*[-kxm*kym/(kzm1*relpro1*mi1*k^2), -eye((2*N+1))/kzm1 + kxm*kxm/(kzm1*relpro1*mi1*k^2);...
    eye((2*N+1))/kzm1 - kym*kym*eye((2*N+1))/(kzm1*relpro1*mi1*k^2),kxm*kym/(kzm1*relpro1*mi1*k^2)];

Rt = relpro2*[-kxm*kym/(kzm2*relpro2*mi2*k^2), -eye((2*N+1))/kzm2 + kxm*kxm/(kzm2*relpro2*mi2*k^2);...
    eye((2*N+1))/kzm2 - kym*kym*eye((2*N+1))/(kzm2*relpro2*mi2*k^2),kxm*kym/(kzm2*relpro2*mi2*k^2)];

Rv1 = -(QH*sqrt(LH))\[e*QEy - kxm*IM*kxm/k^2*QEy + kxm*IM*kym/k^2*QEx; -E*QEx + kym*IM*kym*eye((2*N+1))/k^2*QEx - kxm*IM*kym/k^2*QEy];...
Rv1K = (QHK*sqrt(LHK))\[permK*QEyK - kxm*kxm/k^2*QEyK/miK + kxm*kym/k^2*QExK/miK; - permK*QExK + kym*kym*eye((2*N+1))/k^2*QExK/miK - kxm*kym/k^2*QEyK/miK];

M01t = [zeros(2*(2*N+1)); eye(2*(2*N+1))];
M01 = [zeros(2*(2*N+1)), eye(2*(2*N+1))];
M10 = [eye(2*(2*N+1)), zeros(2*(2*N+1))];
Mk1 = [eye(2*(2*N+1)), eye(2*(2*N+1)); Rr, Ro];
Mk2 = [zeros(2*(2*N+1)), eye(2*(2*N+1)); zeros(2*(2*N+1)), Rt];

Mii = Mk2*M01t;
Pii = eye(2*(2*N+1));

for kk = 1:K
    
    Mki = [QEK, QEK; QHK*Rv1K, -QHK*Rv1K];
    [Mki,elpEK] = orderCon(Mki,MeKi,N);
    
    Mi =  Mki\Mii;
    Bi = Mki*[eye(2*(2*N+1));elpEK*(M01*Mi)/(M10*Mi)*elpEK];
    Mii = Bi;
    Pi = Pii*((M10*Mi)\elpEK);
    Pii = Pi;
    
    Mki = [QE, QE; QH*Rv1, -QH*Rv1];
    [Mki,elpE] = orderCon(Mki,Mei,N);
    
    Mi =  Mki\Mii;
    Bi = Mki*[eye(2*(2*N+1));elpE*(M01*Mi)/(M10*Mi)*elpE];
    Mii = Bi;
    Pi = Pii*((M10*Mi)\elpE);
    Pii = Pi;
end

Bi = M01/Mk1*Mii;
tE = [ekzn2,zeros((2*N+1));zeros((2*N+1)),ekzn2]*Pii/Bi*oE;                % koeficienty t a r
rE = (M10/Mk1)*Mii/Bi*oE;
rxE(1:(2*N+1),1) = rE(1:(2*N+1),1);
ryE(1:(2*N+1),1) = rE((2*N+1)+1:2*(2*N+1),1);
txE(1:(2*N+1),1) = tE(1:(2*N+1),1);
tyE(1:(2*N+1),1) = tE((2*N+1)+1:2*(2*N+1),1);

rzE = - transpose(kx./kz1).*rxE - transpose(ky./kz1).*ryE;
tzE = - transpose(kx./kz2).*txE - transpose(ky./kz2).*tyE;

TTxE = (abs(txE).*abs(txE));
RRxE = (abs(rxE).*abs(rxE));
TTyE = (abs(tyE).*abs(tyE));
RRyE = (abs(ryE).*abs(ryE));
TTzE = (abs(tzE).*abs(tzE));
RRzE = (abs(rzE).*abs(rzE));

RRRxE = zeros(1,(2*N+1));
TTTxE = zeros(1,(2*N+1));
RRRyE = zeros(1,(2*N+1));
TTTyE = zeros(1,(2*N+1));
RRRzE = zeros(1,(2*N+1));
TTTzE = zeros(1,(2*N+1));

kzr = zeros(1,(2*N+1));
kzt = zeros(1,(2*N+1));

for s = 1:(2*N+1)               % vylucime koeficienty evanescentnych modov
    
    if isreal(kz1(s))
        kzr(s) = kz1(s);
        RRRxE(s) = RRxE(s);
        RRRyE(s) = RRyE(s);
        RRRzE(s) = RRzE(s);
    end
    
    if isreal(kz2(s))
        kzt(s) = kz2(s);
        TTTxE(s) = TTxE(s);
        TTTyE(s) = TTyE(s);
        TTTzE(s) = TTzE(s);
    end
    
end

ref = (RRRxE + RRRyE + RRRzE).*(kzr)/(cos(fi)*sqrt(mi1*relpro1)*k);
trans = (TTTxE + TTTyE + TTTzE).*(kzt)/(cos(fi)*mi2*sqrt(relpro1/mi1)*k);

energy = sum(ref) + sum(trans);
function [energy, ref, trans] = Doub(N,px,py,lambda,fi,psi,tet,d,fillx,filly,relpro1,rels,relperm,relpro2,mi1,mis,mip,mi2,permK,miK,dK,K)

% N pocet Fourierovych radov
% w pocet vrstiev je w-1
% px peri�da mriezky x -ovej osi
% py perioda mriezky y -ovej osi
% lambda vlnova dlzka
% fi uhol dopadu
% psi uhol polarizacie
% tet uhol medzi dopadovou rovinou a osou x
% d hrubka mriezky
% relperm relativna permitivita mriezky
% rels  relativna permitivita superstratu
% relpro1 relativna permitivita prostredia c.1
% relpro2 relativna permitivita prostredia c.2
% fillx filling faktor v smere x
% filly filling faktor v smere y
% energy - musi rovnat jednej
% refx transx refy transy jednotliv� transimtancie a reflektancie

%%%%%%%%%%%%%  (Nugrowati style recomposed)  S INVERZNYM TRIKOM +
%%%%%%%%%%%%%  RENORMALIZACIA - Rv je diagonalna (predpoklad)

if fi == 0 && fillx == filly   %% stabilitu zvysuje, ked je system symetricky
    fi = 0.0001;
end
if  dK == 0   %%% stabilitu pre vyssie rady dava...
    permK = 2;
end

k = 2*pi/lambda;     % vlnove cislo
hx = zeros(1,(2*N+1)^2);
hy = repmat(-N:1:N,1,2*N+1);

for i = -N:N            %vektor hx
    
    hx(1,(i+N)*(2*N+1)+1:1:(i+N+1)*(2*N+1)) = i;
    
end

ep = toeplitz(0:2*N,0:-1:-2*N);

kx = k*sqrt(relpro1*mi1)*sin(fi)*cos(tet) + hx*2*pi/px;
ky = k*sqrt(relpro1*mi1)*sin(fi)*sin(tet) + hy*2*pi/py;

kz1 = sqrt(relpro1*mi1*k^2 - ky.*ky - kx.*kx);
kz2 = sqrt(relpro2*mi2*k^2 - ky.*ky - kx.*kx);
kzm1 = diag(kz1);
kzm2 = diag(kz2);
kx2 = kx.*kx;
ky2 = ky.*ky;
kxm = diag(kx);
kym = diag(ky);
ekzn2 = diag(exp(-1i*kz2*(d+dK)*K));

E = zeros((2*N+1)^2);
A = zeros((2*N+1)^2);
MI = zeros((2*N+1)^2);
IM = zeros((2*N+1)^2);

for s = 1:2*N+1         % matice E a A
    
    for i = 1:2*N+1
        
        E((2*N+1)*(s-1)+1:(2*N+1)*s,(2*N+1)*(i-1)+1:(2*N+1)*i) = (relperm-rels)*fillx*filly*sinc(ep(s,i)*fillx)*sinc(ep*filly)+rels*sinc(ep(s,i))*sinc(ep);
        A((2*N+1)*(s-1)+1:(2*N+1)*s,(2*N+1)*(i-1)+1:(2*N+1)*i) = (1/relperm-1/rels)*fillx*filly*sinc(ep(s,i)*fillx)*sinc(ep*filly)+1/rels*sinc(ep(s,i))*sinc(ep);
        
    end
    
end

for s = 1:2*N+1         % matice MI a IM
    
    for i = 1:2*N+1
        
        MI((2*N+1)*(s-1)+1:(2*N+1)*s,(2*N+1)*(i-1)+1:(2*N+1)*i) = (mip-mis)*fillx*filly*sinc(ep(s,i)*fillx)*sinc(ep*filly)+mis*sinc(ep(s,i))*sinc(ep);
        IM((2*N+1)*(s-1)+1:(2*N+1)*s,(2*N+1)*(i-1)+1:(2*N+1)*i) = (1/mip-1/mis)*fillx*filly*sinc(ep(s,i)*fillx)*sinc(ep*filly)+1/mis*sinc(ep(s,i))*sinc(ep);
        
    end
    
end

e = E; E = (eye((2*N+1)^2))/(A); A = (eye((2*N+1)^2))/(e);          %%INVERZ TRIK
mm = MI; MI = (eye((2*N+1)^2))/(IM); IM = (eye((2*N+1)^2))/(mm);          %%INVERZ TRIK


oxE = zeros((2*N+1)^2,1);
oyE = zeros((2*N+1)^2,1);
oxE(2*N*(N+1)+1) = - cos(psi)*sin(tet) + sin(psi)*cos(fi)*cos(tet);   % vektor o ma same nuly okrem v strede, to je potrebne k pociatocnej podmienke
oyE(2*N*(N+1)+1) = cos(psi)*cos(tet) + sin(psi)*cos(fi)*sin(tet);
oE = [oxE;oyE];

C11E = k^2*MI*E - MI*diag(ky)*IM*diag(ky) - diag(kx)*A*diag(kx)*E;  % nugrowati (unorig 1)
C12E = MI*diag(ky)*IM*diag(kx) - diag(kx)*A*diag(ky)*E;
C21E = MI*diag(kx)*IM*diag(ky) - diag(ky)*A*diag(kx)*E;
C22E = k^2*MI*E - MI*diag(kx)*IM*diag(kx) - diag(ky)*A*diag(ky)*E;

CE = [C11E, C12E; C21E, C22E];
[QE,LE] = eig(CE);

C11H = k^2*E*MI - diag(kx)*IM*diag(kx)*MI  - E*diag(ky)*A*diag(ky);
C12H = - diag(kx)*IM*diag(ky)*MI + E*diag(ky)*A*diag(kx);
C21H = - diag(ky)*IM*diag(kx)*MI + E*diag(kx)*A*diag(ky);
C22H = k^2*E*MI - diag(ky)*IM*diag(ky)*MI  - E*diag(kx)*A*diag(kx);

CH = [C11H, C12H; C21H, C22H];
[QH,LH] = eig(CH);

% [QE,LE]= sortem(QE,LE);
% [QH,LH]= sortem(QH,LH);

QEx = QE(1:(2*N+1)^2,1:2*(2*N+1)^2);
QEy = QE((2*N+1)^2+1:2*(2*N+1)^2,1:2*(2*N+1)^2);

elpE = diag(exp(1i*diag(sqrt(LE))*d));
elnE = diag(exp(-1i*diag(sqrt(LE))*d));

C11EK = k^2*eye((2*N+1)^2)*permK*miK - diag(ky2) - diag(kx2);  %%% HOMOGENNA VRSTVA
C12EK = zeros((2*N+1)^2);
C21EK = zeros((2*N+1)^2);
C22EK = k^2*eye((2*N+1)^2)*permK*miK - diag(kx2) - diag(ky2);

CEK = [C11EK, C12EK; C21EK, C22EK];
[QEK,LEK] = eig(CEK);

C11HK = k^2*eye((2*N+1)^2)*permK*miK - diag(kx2)  - diag(ky2);
C12HK = zeros((2*N+1)^2);
C21HK = zeros((2*N+1)^2);
C22HK = k^2*eye((2*N+1)^2)*permK*miK - diag(ky2)  - diag(kx2);

CHK = [C11HK, C12HK; C21HK, C22HK];
[QHK,LHK] = eig(CHK);

% [QEK,LEK]= sortem(QEK,LEK);
% [QHK,LHK]= sortem(QHK,LHK);

QExK = QEK(1:(2*N+1)^2,1:2*(2*N+1)^2);
QEyK = QEK((2*N+1)^2+1:2*(2*N+1)^2,1:2*(2*N+1)^2);

elpEK = diag(exp(1i*diag(sqrt(LEK))*dK));
elnEK = diag(exp(-1i*diag(sqrt(LEK))*dK));

Rr = relpro1*[kxm*kym/(kzm1*relpro1*mi1*k^2), eye((2*N+1)^2)/kzm1 - kxm*kxm/(kzm1*relpro1*mi1*k^2);...
    -eye((2*N+1)^2)/kzm1+kym*kym/(kzm1*relpro1*mi1*k^2),- kxm*kym/(kzm1*relpro1*mi1*k^2)];

Ro = relpro1*[-kxm*kym/(kzm1*relpro1*mi1*k^2), -eye((2*N+1)^2)/kzm1 + kxm*kxm/(kzm1*relpro1*mi1*k^2);...
    eye((2*N+1)^2)/kzm1 - kym*kym/(kzm1*relpro1*mi1*k^2),kxm*kym/(kzm1*relpro1*mi1*k^2)];

Rt = relpro2*[-kxm*kym/(kzm2*relpro2*mi2*k^2), -eye((2*N+1)^2)/kzm2 + kxm*kxm/(kzm2*relpro2*mi2*k^2);...
    eye((2*N+1)^2)/kzm2 - kym*kym/(kzm2*relpro2*mi2*k^2),kxm*kym/(kzm2*relpro2*mi2*k^2)];

Rv1 = (QH*sqrt(LH))\[E*QEy - kxm*IM*kxm/k^2*QEy + kym*IM*kxm/k^2*QEx; - E*QEx + kym*IM*kym/k^2*QEx - kxm*IM*kym/k^2*QEy];...
    Rv1K = ((QHK*sqrt(LHK))\[permK*QEyK - kxm*kxm/k^2*QEyK/miK + kym*kxm/k^2*QExK/miK; - permK*QExK + kym*kym/k^2*QExK/miK - kxm*kym/k^2*QEyK/miK]);

M01t = [zeros(2*(2*N+1)^2); eye(2*(2*N+1)^2)];
M01 = [zeros(2*(2*N+1)^2), eye(2*(2*N+1)^2)];
M10 = [eye(2*(2*N+1)^2), zeros(2*(2*N+1)^2)];
Mk1 = [eye(2*(2*N+1)^2), eye(2*(2*N+1)^2); Rr, Ro];
Mk2 = [zeros(2*(2*N+1)^2), eye(2*(2*N+1)^2); zeros(2*(2*N+1)^2), Rt];

Mii = Mk2*M01t;
Pii = eye(2*(2*N+1)^2);

for kk = 1:K
    
    Mki = [QEK, QEK; QHK*Rv1K, -QHK*Rv1K];
    [Mki,elpEK] = order2D(Mki,elnEK,elpEK,N);
    
    Mi =  Mki\Mii;
    Bi = Mki*[eye(2*(2*N+1)^2);elpEK*(M01*Mi)/(M10*Mi)*elpEK];
    Mii = Bi;
    Pi = Pii*((M10*Mi)\elpEK);
    Pii = Pi;
    
    Mki = [QE, QE; QH*Rv1, -QH*Rv1];
    [Mki,elpE] = order2D(Mki,elnE,elpE,N);
    
    Mi =  Mki\Mii;
    Bi = Mki*[eye(2*(2*N+1)^2);elpE*(M01*Mi)/(M10*Mi)*elpE];
    Mii = Bi;
    Pi = Pii*((M10*Mi)\elpE);
    Pii = Pi;
end

Bi = M01/Mk1*Mii;
tE = [ekzn2,zeros((2*N+1)^2);zeros((2*N+1)^2),ekzn2]*Pii/Bi*oE;                % koeficienty t a r
rE = (M10/Mk1)*Mii/Bi*oE;
rxE(1:(2*N+1)^2,1) = rE(1:(2*N+1)^2,1);
ryE(1:(2*N+1)^2,1) = rE((2*N+1)^2+1:2*(2*N+1)^2,1);
txE(1:(2*N+1)^2,1) = tE(1:(2*N+1)^2,1);
tyE(1:(2*N+1)^2,1) = tE((2*N+1)^2+1:2*(2*N+1)^2,1);

rzE = - transpose(kx./kz1).*rxE - transpose(ky./kz1).*ryE;
tzE = - transpose(kx./kz2).*txE - transpose(ky./kz2).*tyE;

TTxE = (abs(txE).*abs(txE));
RRxE = (abs(rxE).*abs(rxE));
TTyE = (abs(tyE).*abs(tyE));
RRyE = (abs(ryE).*abs(ryE));
TTzE = (abs(tzE).*abs(tzE));
RRzE = (abs(rzE).*abs(rzE));

RRRxE = zeros(1,(2*N+1)^2);
TTTxE = zeros(1,(2*N+1)^2);
RRRyE = zeros(1,(2*N+1)^2);
TTTyE = zeros(1,(2*N+1)^2);
RRRzE = zeros(1,(2*N+1)^2);
TTTzE = zeros(1,(2*N+1)^2);

kzr = zeros(1,(2*N+1)^2);
kzt = zeros(1,(2*N+1)^2);

for s = 1:(2*N+1)^2               % vylucime koeficienty evanescentnych modov
    
    if isreal(kz1(s))
        kzr(s) = kz1(s);
        RRRxE(s) = RRxE(s);
        RRRyE(s) = RRyE(s);
        RRRzE(s) = RRzE(s);
    end
    
    if isreal(kz2(s))
        kzt(s) = kz2(s);
        TTTxE(s) = TTxE(s);
        TTTyE(s) = TTyE(s);
        TTTzE(s) = TTzE(s);
    end
    
end

ref = (RRRxE + RRRyE + RRRzE).*(kzr)/(cos(fi)*sqrt(mi1*relpro1)*k);
trans = (TTTxE + TTTyE + TTTzE).*(kzt)/(cos(fi)*mi2*sqrt(relpro1/mi1)*k);

energy = sum(ref) + sum(trans);
function [energy, ref, trans] = DHex(N,px,py,lambda,fi,psi,tet,d,qx1,qy1,qx2,qy2,dx,dy,relpro1,e1,e2,relpro2,mi1,m1,m2,mi2,permK,miK,dK,K)

% N pocet Fourierovych radov
% w pocet vrstiev je w-1
% px peri�da mriezky x -ovej osi
% py perioda mriezky y -ovej osi
% lambda vlnova dlzka
% fi uhol dopadu
% psi uhol polarizacie
% tet uhol medzi dopadovou rovinou a osou x
% d hrubka mriezky
% relperm relativna permitivita mriezky
% rels  relativna permitivita superstratu
% relpro1 relativna permitivita prostredia c.1
% relpro2 relativna permitivita prostredia c.2
% fillx filling faktor v smere x
% filly filling faktor v smere y
% energy - musi rovnat jednej
% refx transx refy transy jednotliv� transimtancie a reflektancie

%%%%%%%%%%%%%  (Nugrowati style recomposed)  S INVERZNYM TRIKOM +
%%%%%%%%%%%%%  RENORMALIZACIA - Rv je diagonalna (predpoklad)

if fi == 0 && qx1 == qy1 && qx2 == qy2   %% stabilitu zvysuje
    fi = 0.0001;
end
if  dK == 0   %%% stabilitu pre vyssie rady dava...
    permK = 2;
end
e2 = e2 + 0.000001*1i;    %%%  tiez stabilita


k = 2*pi/lambda;     % vlnove cislo
hx = zeros(1,(2*N+1)^2);
hy = repmat(-N:1:N,1,2*N+1);

for i = -N:N            %vektor hx
    
    hx(1,(i+N)*(2*N+1)+1:1:(i+N+1)*(2*N+1)) = i;
    
end

ep = toeplitz(0:2*N,0:-1:-2*N);

kx = k*sqrt(relpro1*mi1)*sin(fi)*cos(tet) + hx*2*pi/px;
ky = k*sqrt(relpro1*mi1)*sin(fi)*sin(tet) + hy*2*pi/py;

kz1 = sqrt(relpro1*mi1*k^2 - ky.*ky - kx.*kx);
kz2 = sqrt(relpro2*mi2*k^2 - ky.*ky - kx.*kx);
kzm1 = diag(kz1);
kzm2 = diag(kz2);
kx2 = kx.*kx;
ky2 = ky.*ky;
kxm = diag(kx);
kym = diag(ky);
ekzn2 = diag(exp(-1i*kz2*(d+dK)*K));

E = zeros((2*N+1)^2);
A = zeros((2*N+1)^2);
MI = zeros((2*N+1)^2);
IM = zeros((2*N+1)^2);

for s = 1:2*N+1         % matice E a A
    
    for i = 1:2*N+1
        
        E((2*N+1)*(s-1)+1:(2*N+1)*s,(2*N+1)*(i-1)+1:(2*N+1)*i) = (e2-e1)*qx1*qy1*sinc(ep(s,i)*qx1)*sinc(ep*qy1)+e1*sinc(ep(s,i))*sinc(ep) + ((e2-e1)*qx2*qy2*sinc(ep(s,i)*qx2)*sinc(ep*qy2)).*exp(1i*2*pi*dx*ep(s,i)).*exp(1i*2*pi*dy*ep);
        A((2*N+1)*(s-1)+1:(2*N+1)*s,(2*N+1)*(i-1)+1:(2*N+1)*i) = (1/e2-1/e1)*qx1*qy1*sinc(ep(s,i)*qx1)*sinc(ep*qy1)+1/e1*sinc(ep(s,i))*sinc(ep) + ((1/e2-1/e1)*qx2*qy2*sinc(ep(s,i)*qx2)*sinc(ep*qy2)).*exp(1i*2*pi*dx*ep(s,i)).*exp(1i*2*pi*dy*ep);
        
    end
    
end

for s = 1:2*N+1         % matice MI a IM
    
    for i = 1:2*N+1
        
        MI((2*N+1)*(s-1)+1:(2*N+1)*s,(2*N+1)*(i-1)+1:(2*N+1)*i) = (m2-m1)*qx1*qy1*sinc(ep(s,i)*qx1)*sinc(ep*qy1)+m1*sinc(ep(s,i))*sinc(ep) + ((m2-m1)*qx2*qy2*sinc(ep(s,i)*qx2)*sinc(ep*qy2)).*exp(1i*2*pi*dx*ep(s,i)).*exp(1i*2*pi*dy*ep);
        IM((2*N+1)*(s-1)+1:(2*N+1)*s,(2*N+1)*(i-1)+1:(2*N+1)*i) = (1/m2-1/m1)*qx1*qy1*sinc(ep(s,i)*qx1)*sinc(ep*qy1)+1/m1*sinc(ep(s,i))*sinc(ep) + ((1/m2-1/m1)*qx2*qy2*sinc(ep(s,i)*qx2)*sinc(ep*qy2)).*exp(1i*2*pi*dx*ep(s,i)).*exp(1i*2*pi*dy*ep);
        
    end
    
end

e = E; E = (eye((2*N+1)^2))/(A); A = (eye((2*N+1)^2))/(e);          %%INVERZ TRIK
mm = MI; MI = (eye((2*N+1)^2))/(IM); IM = (eye((2*N+1)^2))/(mm);          %%INVERZ TRIK


oxE = zeros((2*N+1)^2,1);
oyE = zeros((2*N+1)^2,1);
oxE(2*N*(N+1)+1) = - cos(psi)*sin(tet) + sin(psi)*cos(fi)*cos(tet);   % vektor o ma same nuly okrem v strede, to je potrebne k pociatocnej podmienke
oyE(2*N*(N+1)+1) = cos(psi)*cos(tet) + sin(psi)*cos(fi)*sin(tet);
oE = [oxE;oyE];

C11E = k^2*MI*E - MI*diag(ky)*IM*diag(ky) - diag(kx)*A*diag(kx)*E;  % nugrowati (unorig 1)
C12E = MI*diag(ky)*IM*diag(kx) - diag(kx)*A*diag(ky)*E;
C21E = MI*diag(kx)*IM*diag(ky) - diag(ky)*A*diag(kx)*E;
C22E = k^2*MI*E - MI*diag(kx)*IM*diag(kx) - diag(ky)*A*diag(ky)*E;

CE = [C11E, C12E; C21E, C22E];
[QE,LE] = eig(CE);

C11H = k^2*E*MI - diag(kx)*IM*diag(kx)*MI  - E*diag(ky)*A*diag(ky);
C12H = - diag(kx)*IM*diag(ky)*MI + E*diag(ky)*A*diag(kx);
C21H = - diag(ky)*IM*diag(kx)*MI + E*diag(kx)*A*diag(ky);
C22H = k^2*E*MI - diag(ky)*IM*diag(ky)*MI  - E*diag(kx)*A*diag(kx);

CH = [C11H, C12H; C21H, C22H];
[QH,LH] = eig(CH);

% [QE,LE]= sortem(QE,LE);
% [QH,LH]= sortem(QH,LH);

QEx = QE(1:(2*N+1)^2,1:2*(2*N+1)^2);
QEy = QE((2*N+1)^2+1:2*(2*N+1)^2,1:2*(2*N+1)^2);

elpE = diag(exp(1i*diag(sqrt(LE))*d));
elnE = diag(exp(-1i*diag(sqrt(LE))*d));

C11EK = k^2*eye((2*N+1)^2)*permK*miK - diag(ky2) - diag(kx2);  %%% HOMOGENNA VRSTVA
C12EK = zeros((2*N+1)^2);
C21EK = zeros((2*N+1)^2);
C22EK = k^2*eye((2*N+1)^2)*permK*miK - diag(kx2) - diag(ky2);

CEK = [C11EK, C12EK; C21EK, C22EK];
[QEK,LEK] = eig(CEK);

C11HK = k^2*eye((2*N+1)^2)*permK*miK - diag(kx2)  - diag(ky2);
C12HK = zeros((2*N+1)^2);
C21HK = zeros((2*N+1)^2);
C22HK = k^2*eye((2*N+1)^2)*permK*miK - diag(ky2)  - diag(kx2);

CHK = [C11HK, C12HK; C21HK, C22HK];
[QHK,LHK] = eig(CHK);

% [QEK,LEK]= sortem(QEK,LEK);
% [QHK,LHK]= sortem(QHK,LHK);

QExK = QEK(1:(2*N+1)^2,1:2*(2*N+1)^2);
QEyK = QEK((2*N+1)^2+1:2*(2*N+1)^2,1:2*(2*N+1)^2);

elpEK = diag(exp(1i*diag(sqrt(LEK))*dK));
elnEK = diag(exp(-1i*diag(sqrt(LEK))*dK));

Rr = relpro1*[kxm*kym/(kzm1*relpro1*mi1*k^2), eye((2*N+1)^2)/kzm1 - kxm*kxm/(kzm1*relpro1*mi1*k^2);...
    -eye((2*N+1)^2)/kzm1+kym*kym/(kzm1*relpro1*mi1*k^2),- kxm*kym/(kzm1*relpro1*mi1*k^2)];

Ro = relpro1*[-kxm*kym/(kzm1*relpro1*mi1*k^2), -eye((2*N+1)^2)/kzm1 + kxm*kxm/(kzm1*relpro1*mi1*k^2);...
    eye((2*N+1)^2)/kzm1 - kym*kym/(kzm1*relpro1*mi1*k^2),kxm*kym/(kzm1*relpro1*mi1*k^2)];

Rt = relpro2*[-kym*kxm/(kzm2*relpro2*mi2*k^2), -eye((2*N+1)^2)/kzm2 + kxm*kxm/(kzm2*relpro2*mi2*k^2);...
    eye((2*N+1)^2)/kzm2 - kym*kym/(kzm2*relpro2*mi2*k^2),kxm*kym/(kzm2*relpro2*mi2*k^2)];

Rv1 = ((QH*sqrt(LH))\[E*QEy - kxm*IM*kxm/k^2*QEy + kxm*IM*kym/k^2*QEx; - E*QEx + kym*IM*kym/k^2*QEx - kxm*IM*kym/k^2*QEy]);
Rv1K = ((QHK*sqrt(LHK))\[permK*QEyK - kxm*kxm/k^2*QEyK/miK + kxm*kym/k^2*QExK/miK; - permK*QExK + kym*kym/k^2*QExK/miK - kxm*kym/k^2*QEyK/miK]);

M01t = [zeros(2*(2*N+1)^2); eye(2*(2*N+1)^2)];
M01 = [zeros(2*(2*N+1)^2), eye(2*(2*N+1)^2)];
M10 = [eye(2*(2*N+1)^2), zeros(2*(2*N+1)^2)];
Mk1 = [eye(2*(2*N+1)^2), eye(2*(2*N+1)^2); Rr, Ro];
Mk2 = [zeros(2*(2*N+1)^2), eye(2*(2*N+1)^2); zeros(2*(2*N+1)^2), Rt];

Mii = Mk2*M01t;
Pii = eye(2*(2*N+1)^2);

for kk = 1:K
    
    Mki = [QEK, QEK; QHK*Rv1K, -QHK*Rv1K];
    [Mki,elpEK] = order2D(Mki,elnEK,elpEK,N);
    
    Mi =  Mki\Mii;
    Bi = Mki*[eye(2*(2*N+1)^2);elpEK*(M01*Mi)/(M10*Mi)*elpEK];
    Mii = Bi;
    Pi = Pii*((M10*Mi)\elpEK);
    Pii = Pi;

    Mki = [QE, QE; QH*Rv1, -QH*Rv1];
    [Mki,elpE] = order2D(Mki,elnE,elpE,N);
    
    Mi =  Mki\Mii;
    Bi = Mki*[eye(2*(2*N+1)^2);elpE*(M01*Mi)/(M10*Mi)*elpE];
    Mii = Bi;
    Pi = Pii*((M10*Mi)\elpE);
    Pii = Pi;
end

Bi = M01/Mk1*Mii;
tE = [ekzn2,zeros((2*N+1)^2);zeros((2*N+1)^2),ekzn2]*Pii/Bi*oE;                % koeficienty t a r
rE = (M10/Mk1)*Mii/Bi*oE;
rxE(1:(2*N+1)^2,1) = rE(1:(2*N+1)^2,1);
ryE(1:(2*N+1)^2,1) = rE((2*N+1)^2+1:2*(2*N+1)^2,1);
txE(1:(2*N+1)^2,1) = tE(1:(2*N+1)^2,1);
tyE(1:(2*N+1)^2,1) = tE((2*N+1)^2+1:2*(2*N+1)^2,1);

rzE = - transpose(kx./kz1).*rxE - transpose(ky./kz1).*ryE;
tzE = - transpose(kx./kz2).*txE - transpose(ky./kz2).*tyE;

TTxE = (abs(txE).*abs(txE));
RRxE = (abs(rxE).*abs(rxE));
TTyE = (abs(tyE).*abs(tyE));
RRyE = (abs(ryE).*abs(ryE));
TTzE = (abs(tzE).*abs(tzE));
RRzE = (abs(rzE).*abs(rzE));

RRRxE = zeros(1,(2*N+1)^2);
TTTxE = zeros(1,(2*N+1)^2);
RRRyE = zeros(1,(2*N+1)^2);
TTTyE = zeros(1,(2*N+1)^2);
RRRzE = zeros(1,(2*N+1)^2);
TTTzE = zeros(1,(2*N+1)^2);

kzr = zeros(1,(2*N+1)^2);
kzt = zeros(1,(2*N+1)^2);

for s = 1:(2*N+1)^2               % vylucime koeficienty evanescentnych modov
    
    if isreal(kz1(s))
        kzr(s) = kz1(s);
        RRRxE(s) = RRxE(s);
        RRRyE(s) = RRyE(s);
        RRRzE(s) = RRzE(s);
    end
    
    if isreal(kz2(s))
        kzt(s) = kz2(s);
        TTTxE(s) = TTxE(s);
        TTTyE(s) = TTyE(s);
        TTTzE(s) = TTzE(s);
    end
    
end

ref = (RRRxE + RRRyE + RRRzE).*(kzr)/(cos(fi)*sqrt(mi1*relpro1)*k);
trans = (TTTxE + TTTyE + TTTzE).*(kzt)/(cos(fi)*mi2*sqrt(relpro1/mi1)*k);

energy = sum(ref) + sum(trans);
function [energy, ref, trans, refTE, refTM, transTE, transTM] = AnizE(N,p,lambda,fi,psi,d,m,drels,K,Exx,Exy,Eyy,ez)

% N pocet Fourierovych radov
% w pocet vrstiev je w-1
% px perida mriezky x -ovej osi
% lambda vlnova dlzka
% fi uhol dopadu
% psi uhol polarizacie
% d hrubka mriezky
% relperm relativna permitivita mriezky
% rels  relativna permitivita superstratu
% relpro1 relativna permitivita prostredia c.1
% relpro2 relativna permitivita prostredia c.2
% fillx filling faktor v smere x
% energy - musi rovnat jednej
% refx transx refy transy jednotliv transimtancie a reflektancie
% ez - zetova zlozka tensora permitivity

p = (2*m+1)*p;
k = 2*pi/lambda;     % vlnove cislo
h = -N:1:N;

kx = k*sin(fi) + h*2*pi/p;
kz1 = sqrt(k^2 - kx.*kx);
kz2 = sqrt(k^2 - kx.*kx);
kzm1 = diag(kz1);
kzm2 = diag(kz2);
kx2 = kx.*kx;
kxm = diag(kx);
ekzn2 = diag(exp(-1i*kz2*(d+drels)*K));

oxE = zeros(2*N+1,1);
oyE = zeros(2*N+1,1);
oxE(N+1) = cos(fi)*sin(psi);
oyE(N+1) = cos(psi);
oE = [oxE;oyE];

Rr = [zeros(2*N+1), 		eye(2*N+1)/kzm1 - kxm*kxm/(kzm1*k^2);...
    -eye(2*N+1)/kzm1,		zeros(2*N+1)];

Ro = -[zeros(2*N+1), 		eye(2*N+1)/kzm1 - kxm*kxm/(kzm1*k^2);...
    -eye(2*N+1)/kzm1,		zeros(2*N+1)];

Rt = -[zeros(2*N+1), 		eye(2*N+1)/kzm2 - kxm*kxm/(kzm2*k^2);...
    -eye(2*N+1)/kzm2,		zeros(2*N+1)];

M01t = [zeros(2*(2*N+1)); eye(2*(2*N+1))];
M01 = [zeros(2*(2*N+1)), eye(2*(2*N+1))];
M10 = [eye(2*(2*N+1)), zeros(2*(2*N+1))];
Mk1 = [eye(2*(2*N+1)), eye(2*(2*N+1)); Rr, Ro];
Mk2 = [zeros(2*(2*N+1)), eye(2*(2*N+1)); zeros(2*(2*N+1)), Rt];
Mii = Mk2*M01t;
Pii = eye(2*(2*N+1));

C11Ehom = k^2*eye(2*N+1) - diag(kx2);
C12Ehom = zeros(2*N+1);
C21Ehom = zeros(2*N+1);
C22Ehom = k^2*eye(2*N+1) - diag(kx2);
CEhom = [C11Ehom, C12Ehom; C21Ehom, C22Ehom];
[QEhom,LEhom] = eig(CEhom);
QExhom = QEhom(1:(2*N+1),1:2*(2*N+1));
QEyhom = QEhom(2*N+1+1:2*(2*N+1),1:2*(2*N+1));
C11Hhom = k^2*eye(2*N+1) - diag(kx2);
C12Hhom = zeros(2*N+1);
C21Hhom = zeros(2*N+1);
C22Hhom = k^2*eye(2*N+1) - diag(kx2);
CHhom = [C11Hhom, C12Hhom; C21Hhom, C22Hhom];
[QHhom,LHhom] = eig(CHhom);
Rv1hom = -((QHhom*sqrt(LHhom))\[QEyhom - kxm*kxm/k^2*QEyhom; - QExhom]);

for t = 1:K
    
    C11E = k^2*Exx(:,:,t) - diag(kx2)/ez*Exx(:,:,t);
    C12E = k^2*Exy(:,:,t) - diag(kx2)/ez*Exy(:,:,t);
    C21E = k^2*Exy(:,:,t);
    C22E = k^2*Eyy(:,:,t) - diag(kx2);
    
    CE = [C11E, C12E; C21E, C22E];
    [QE,LE] = eig(CE);
    
    C11H = k^2*Eyy(:,:,t) - diag(kx2);
    C12H = -k^2*Exy(:,:,t) + Exy(:,:,t)*diag(kx2)/ez;
    C21H = -k^2*Exy(:,:,t);
    C22H = k^2*Exx(:,:,t) - Exx(:,:,t)*diag(kx2)/ez;
    
    CH = [C11H, C12H; C21H, C22H];
    [QH,LH] = eig(CH);
    
    QEx = QE(1:(2*N+1),1:2*(2*N+1));
    QEy = QE(2*N+1+1:2*(2*N+1),1:2*(2*N+1));
    
    elpE = diag(exp(1i*diag(sqrt(LE))*d));
    elnE = diag(exp(-1i*diag(sqrt(LE))*d));
    Mei = [elnE,zeros(2*(2*N+1));zeros(2*(2*N+1)),elpE];
    
    Rv1 = -((QH*sqrt(LH))\[Exy(:,:,t)*QEx + Eyy(:,:,t)*QEy - kxm*kxm/k^2*QEy; - Exx(:,:,t)*QEx - Exy(:,:,t)*QEy])*eye(2*(2*N+1));
    
    % renormalizacia x&y of E
    
    Mki = [QE, QE; QH*Rv1, -QH*Rv1];
    [Mki,elpE] = orderN2(Mki,Mei);
    
    Mi =  Mki\Mii;
    Bi = Mki*[eye(2*(2*N+1));elpE*(M01*Mi)/(M10*Mi)*elpE];
    Mii = Bi;
    Pi = Pii*((M10*Mi)\elpE);
    Pii = Pi;
    
    elpE = diag(exp(1i*diag(sqrt(LEhom))*drels));
    Mki= [QEhom, QEhom; QHhom*Rv1hom, -QHhom*Rv1hom];
    
    elnE = diag(exp(-1i*diag(sqrt(LEhom))*drels));
    Mei = [elnE,zeros(2*(2*N+1));zeros(2*(2*N+1)),elpE];
    [Mki,elpE] = orderN2(Mki,Mei);
    
    
    Mi =  Mki\Mii;
    Bi = Mki*[eye(2*(2*N+1));elpE*(M01*Mi)/(M10*Mi)*elpE];
    Mii = Bi;
    Pi = Pii*((M10*Mi)\elpE);
    Pii = Pi;
    
end

Bi = M01/Mk1*Mii;
tE = [ekzn2,zeros((2*N+1));zeros((2*N+1)),ekzn2]*Pii/Bi*oE;
rE = (M10/Mk1)*Mii/Bi*oE;
rxE(1:(2*N+1),1) = rE(1:(2*N+1),1);
ryE(1:(2*N+1),1) = rE((2*N+1)+1:2*(2*N+1),1);
txE(1:(2*N+1),1) = tE(1:(2*N+1),1);
tyE(1:(2*N+1),1) = tE((2*N+1)+1:2*(2*N+1),1);

rzE = - transpose(kx./kz1).*rxE;
tzE = - transpose(kx./kz2).*txE;

TTxE = (abs(txE).*abs(txE));
RRxE = (abs(rxE).*abs(rxE));
TTyE = (abs(tyE).*abs(tyE));
RRyE = (abs(ryE).*abs(ryE));
TTzE = (abs(tzE).*abs(tzE));
RRzE = (abs(rzE).*abs(rzE));

RRRxE = zeros(1,(2*N+1));
TTTxE = zeros(1,(2*N+1));
RRRyE = zeros(1,(2*N+1));
TTTyE = zeros(1,(2*N+1));
RRRzE = zeros(1,(2*N+1));
TTTzE = zeros(1,(2*N+1));

kzr = zeros(1,(2*N+1));
kzt = zeros(1,(2*N+1));

for s = 1:(2*N+1)              % vylucime koeficienty evanescentnych modov
    
    if isreal(kz1(s))
        kzr(s) = kz1(s);
        RRRxE(s) = RRxE(s);
        RRRyE(s) = RRyE(s);
        RRRzE(s) = RRzE(s);
    end
    
    if isreal(kz2(s))
        kzt(s) = kz2(s);
        TTTxE(s) = TTxE(s);
        TTTyE(s) = TTyE(s);
        TTTzE(s) = TTzE(s);
    end
    
end

ref = (RRRxE + RRRyE + RRRzE).*(kzr)/(cos(fi)*k);
trans = (TTTxE + TTTyE + TTTzE).*(kzt)/(cos(fi)*k);

energy = sum(ref) + sum(trans);

transTE = TTTyE.*(kzt)/(cos(fi)*k);
transTM = (TTTxE + TTTzE).*(kzt)/(cos(fi)*k);
refTE = RRRyE.*(kzt)/(cos(fi)*k);
refTM = (RRRxE + RRRzE).*(kzt)/(cos(fi)*k);


%%%%%%%%%%%%%%%%%%%%%%%   INCIDENT WAVE   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function selectgrating_Callback(hObject, ~, handles)

switch get(hObject,'value')
    
    case 1
        set(handles.editFourier,'string',0);
        set(handles.editFourier,'visible','off');
        set(handles.textFourier,'visible','off');
        set(handles.textanglemount,'visible','off');
        set(handles.editanglemount,'visible','off');
        set(handles.textdegree3,'visible','off');
        set(handles.textXdirection,'visible','off');
        set(handles.textPeriod,'visible','off');
        set(handles.textFillingA,'visible','off');
        set(handles.textFillingAA,'visible','off');
        set(handles.textPosA,'visible','off');
        set(handles.textYdirection,'visible','off');
        set(handles.textau2,'visible','off');
        set(handles.textau3,'visible','off');
        set(handles.editPeriodx,'visible','off');
        set(handles.editPeriody,'visible','off');
        set(handles.editFillAx,'visible','off');
        set(handles.editFillAy,'visible','off');
        set(handles.editFillAAx,'visible','off');
        set(handles.editFillAAy,'visible','off');
        set(handles.editPosAx,'visible','off');
        set(handles.editPosAy,'visible','off');
        set(handles.textelementa,'visible','off');
        set(handles.textelementb,'visible','off');
        set(handles.editpermielementb,'visible','off');
        set(handles.editpermielementa,'visible','on');
        set(handles.editorder,'enable','off');
        set(handles.editorder2,'enable','off');
        set(handles.editorder,'string','0');
        set(handles.editorder2,'string','0');
        set(handles.textperme,'visible','on')
        set(handles.editpermesup,'visible','on')
        set(handles.editpermeelementa,'visible','on')
        set(handles.editpermeelementb,'visible','off');
        set(handles.editpermelayer2,'visible','on')
        set(handles.editpermesub,'visible','on')
        set(handles.editwave,'enable','on')
        set(handles.editanglepol,'enable','on')
        set(handles.editanglei,'enable','on')
        set(handles.textnumberofrods,'visible','off')
        set(handles.editnumberofrods,'visible','off')
        set(handles.editepszz,'visible','off')
        set(handles.textepszz,'visible','off')
        set(handles.editepsxx,'visible','off')
        set(handles.editepsxxm,'visible','off')
        set(handles.editepsxx2,'visible','off')
        set(handles.textepsxy,'visible','off')
        set(handles.editepsxy,'visible','off')
        set(handles.editepsxym,'visible','off')
        set(handles.editepsxy2,'visible','off')
        set(handles.textepsyy,'visible','off')
        set(handles.editepsyy,'visible','off')
        set(handles.editepsyym,'visible','off')
        set(handles.editepsyy2,'visible','off')
        set(handles.textepsxx,'visible','off')
        set(handles.pushfourier,'visible','off')
        set(handles.textfrom,'visible','off')
        set(handles.editfrom,'visible','off')
        set(handles.textto,'visible','off')
        set(handles.editto,'visible','off')
        set(handles.editpoints,'string','1')
        set(handles.editpoints,'enable','off')
        set(handles.editReps2,'visible','on')
        set(handles.textdefect,'visible','on')
        set(handles.textau6,'visible','on')
        set(handles.editdefect,'visible','on')
        set(handles.editthick1,'enable','on')
        set(handles.popupversus,'value',1)
        set(handles.popupversus,'string',{'Single value'; 'Wavelength'; 'Normalized frequency'; 'Angle of polarization'; 'Angle of incidence'; 'Thickness of Layer 1';'Frequency vs. angle of inc.'})
        set(handles.paneladvanced,'visible','on')
        set(handles.menuindex,'enable','on')
        
    case 2
        set(handles.editFourier,'enable','on');
        set(handles.editFourier,'string',13);
        set(handles.editFourier,'visible','on');
        set(handles.textFourier,'visible','on');
        set(handles.textanglemount,'visible','off');
        set(handles.editanglemount,'visible','off');
        set(handles.editanglemount,'enable','off');
        set(handles.editanglemount,'string',0);
        set(handles.textdegree3,'visible','off');
        set(handles.textXdirection,'visible','on');
        set(handles.textPeriod,'visible','on');
        set(handles.textFillingA,'visible','on');
        set(handles.textFillingAA,'visible','off');
        set(handles.textPosA,'visible','off');
        set(handles.textYdirection,'visible','off');
        set(handles.textau2,'visible','on');
        set(handles.textau3,'visible','off');
        set(handles.editPeriodx,'visible','on');
        set(handles.editPeriody,'visible','off');
        set(handles.editFillAx,'visible','on');
        set(handles.editFillAy,'visible','off');
        set(handles.editFillAAx,'visible','off');
        set(handles.editFillAAy,'visible','off');
        set(handles.editPosAx,'visible','off');
        set(handles.editPosAy,'visible','off');
        set(handles.textelementa,'visible','on');
        set(handles.textelementb,'visible','on');
        set(handles.editpermielementb,'visible','on');
        set(handles.editpermielementa,'visible','on');
        set(handles.editorder,'enable','on');
        set(handles.editorder2,'enable','off');
        set(handles.editorder,'string','0');
        set(handles.editorder2,'string','0');
        set(handles.textperme,'visible','on')
        set(handles.editpermesup,'visible','on')
        set(handles.editpermeelementa,'visible','on')
        set(handles.editpermeelementb,'visible','on')
        set(handles.editpermelayer2,'visible','on')
        set(handles.editpermesub,'visible','on')
        set(handles.editwave,'enable','on')
        set(handles.editanglepol,'enable','on')
        set(handles.editanglei,'enable','on')
        set(handles.textnumberofrods,'visible','off')
        set(handles.editnumberofrods,'visible','off')
        set(handles.editepszz,'visible','off')
        set(handles.textepszz,'visible','off')
        set(handles.editepsxx,'visible','off')
        set(handles.editepsxxm,'visible','off')
        set(handles.editepsxx2,'visible','off')
        set(handles.textepsxy,'visible','off')
        set(handles.editepsxy,'visible','off')
        set(handles.editepsxym,'visible','off')
        set(handles.editepsxy2,'visible','off')
        set(handles.textepsyy,'visible','off')
        set(handles.editepsyy,'visible','off')
        set(handles.editepsyym,'visible','off')
        set(handles.editepsyy2,'visible','off')
        set(handles.textepsxx,'visible','off')
        set(handles.pushfourier,'visible','on')
        set(handles.textfrom,'visible','off')
        set(handles.editfrom,'visible','off')
        set(handles.textto,'visible','off')
        set(handles.editto,'visible','off')
        set(handles.editpoints,'string','1')
        set(handles.editpoints,'enable','off')
        set(handles.editReps2,'visible','on')
        set(handles.textdefect,'visible','on')
        set(handles.textau6,'visible','on')
        set(handles.editdefect,'visible','on')
        set(handles.editthick1,'enable','on')
        set(handles.editFillAx,'enable','on')
        set(handles.popupversus,'value',1)
        set(handles.popupversus,'string',{'Single value'; 'Normalized frequency'; 'Wavelength'; 'Number of modes'; 'Angle of polarization'; 'Angle of incidence'; 'Filling factor A'; 'Thickness of Layer 1'; 'Frequency vs. angle of inc.'})
        set(handles.paneladvanced,'visible','on')
        set(handles.menuindex,'enable','on')
        
    case 3
        set(handles.editFourier,'enable','on');
        set(handles.editFourier,'string',23);
        set(handles.editFourier,'visible','on');
        set(handles.textFourier,'visible','on');
        set(handles.textanglemount,'visible','on');
        set(handles.editanglemount,'visible','on');
        set(handles.editanglemount,'enable','on');
        set(handles.editanglemount,'string',69);
        set(handles.editanglei,'string',69);
        set(handles.textdegree3,'visible','on');
        set(handles.textXdirection,'visible','on');
        set(handles.textPeriod,'visible','on');
        set(handles.textFillingA,'visible','on');
        set(handles.textFillingAA,'visible','off');
        set(handles.textPosA,'visible','off');
        set(handles.textYdirection,'visible','off');
        set(handles.textau2,'visible','on');
        set(handles.textau3,'visible','off');
        set(handles.editPeriodx,'visible','on');
        set(handles.editPeriody,'visible','off');
        set(handles.editFillAx,'visible','on');
        set(handles.editFillAy,'visible','off');
        set(handles.editFillAAx,'visible','off');
        set(handles.editFillAAy,'visible','off');
        set(handles.editPosAx,'visible','off');
        set(handles.editPosAy,'visible','off');
        set(handles.textelementa,'visible','on');
        set(handles.textelementb,'visible','on');
        set(handles.editpermielementb,'visible','on');
        set(handles.editpermielementa,'visible','on');
        set(handles.editorder,'enable','on');
        set(handles.editorder2,'enable','off');
        set(handles.editorder,'string','0');
        set(handles.editorder2,'string','0');
        set(handles.textperme,'visible','on')
        set(handles.editpermesup,'visible','on')
        set(handles.editpermeelementa,'visible','on')
        set(handles.editpermeelementb,'visible','on')
        set(handles.editpermelayer2,'visible','on')
        set(handles.editpermesub,'visible','on')
        set(handles.editwave,'enable','on')
        set(handles.editanglepol,'enable','on')
        set(handles.editanglei,'enable','on')
        set(handles.textnumberofrods,'visible','off')
        set(handles.editnumberofrods,'visible','off')
        set(handles.editepszz,'visible','off')
        set(handles.textepszz,'visible','off')
        set(handles.editepsxx,'visible','off')
        set(handles.editepsxxm,'visible','off')
        set(handles.editepsxx2,'visible','off')
        set(handles.textepsxy,'visible','off')
        set(handles.editepsxy,'visible','off')
        set(handles.editepsxym,'visible','off')
        set(handles.editepsxy2,'visible','off')
        set(handles.textepsyy,'visible','off')
        set(handles.editepsyy,'visible','off')
        set(handles.editepsyym,'visible','off')
        set(handles.editepsyy2,'visible','off')
        set(handles.textepsxx,'visible','off')
        set(handles.pushfourier,'visible','on')
        set(handles.textfrom,'visible','off')
        set(handles.editfrom,'visible','off')
        set(handles.textto,'visible','off')
        set(handles.editto,'visible','off')
        set(handles.editpoints,'string','1')
        set(handles.editpoints,'enable','off')
        set(handles.editReps2,'visible','off')
        set(handles.textdefect,'visible','off')
        set(handles.textau6,'visible','off')
        set(handles.editdefect,'visible','off')
        set(handles.editthick1,'enable','on')
        set(handles.editFillAx,'enable','on')
        set(handles.popupversus,'value',1)
        set(handles.popupversus,'string',{'Single value'; 'Normalized frequency'; 'Wavelength'; 'Number of modes'; 'Angle of polarization'; 'Angle of incidence'; 'Angle of plane of inc.'; 'Filling factor A'; 'Thickness of Layer 1'})
        set(handles.paneladvanced,'visible','on')
        set(handles.menuindex,'enable','on')
        
    case 4
        set(handles.editFourier,'enable','on');
        set(handles.editFourier,'string',7);
        set(handles.editFourier,'visible','on');
        set(handles.textFourier,'visible','on');
        set(handles.textanglemount,'visible','on');
        set(handles.editanglemount,'visible','on');
        set(handles.editanglemount,'enable','on');
        set(handles.textdegree3,'visible','on');
        set(handles.textXdirection,'visible','on');
        set(handles.textPeriod,'visible','on');
        set(handles.textFillingA,'visible','on');
        set(handles.textFillingAA,'visible','off');
        set(handles.textPosA,'visible','off');
        set(handles.textYdirection,'visible','on');
        set(handles.textau2,'visible','on');
        set(handles.textau3,'visible','on');
        set(handles.editPeriodx,'visible','on');
        set(handles.editPeriody,'visible','on');
        set(handles.editFillAx,'visible','on');
        set(handles.editFillAy,'visible','on');
        set(handles.editFillAAx,'visible','off');
        set(handles.editFillAAy,'visible','off');
        set(handles.editPosAx,'visible','off');
        set(handles.editPosAy,'visible','off');
        set(handles.textelementa,'visible','on');
        set(handles.textelementb,'visible','on');
        set(handles.editpermielementb,'visible','on');
        set(handles.editpermielementa,'visible','on');
        set(handles.editorder,'enable','on');
        set(handles.editorder2,'enable','on');
        set(handles.editorder,'string','0');
        set(handles.editorder2,'string','0');
        set(handles.textperme,'visible','on')
        set(handles.editpermesup,'visible','on')
        set(handles.editpermeelementa,'visible','on')
        set(handles.editpermeelementb,'visible','on')
        set(handles.editpermelayer2,'visible','on')
        set(handles.editpermesub,'visible','on')
        set(handles.editwave,'enable','on')
        set(handles.editanglepol,'enable','on')
        set(handles.editanglei,'enable','on')
        set(handles.textnumberofrods,'visible','off')
        set(handles.editnumberofrods,'visible','off')
        set(handles.editepszz,'visible','off')
        set(handles.textepszz,'visible','off')
        set(handles.editepsxx,'visible','off')
        set(handles.editepsxxm,'visible','off')
        set(handles.editepsxx2,'visible','off')
        set(handles.textepsxy,'visible','off')
        set(handles.editepsxy,'visible','off')
        set(handles.editepsxym,'visible','off')
        set(handles.editepsxy2,'visible','off')
        set(handles.textepsyy,'visible','off')
        set(handles.editepsyy,'visible','off')
        set(handles.editepsyym,'visible','off')
        set(handles.editepsyy2,'visible','off')
        set(handles.textepsxx,'visible','off')
        set(handles.pushfourier,'visible','on')
        set(handles.textfrom,'visible','off')
        set(handles.editfrom,'visible','off')
        set(handles.textto,'visible','off')
        set(handles.editto,'visible','off')
        set(handles.editpoints,'string','1')
        set(handles.editpoints,'enable','off')
        set(handles.editReps2,'visible','off')
        set(handles.textdefect,'visible','off')
        set(handles.textau6,'visible','off')
        set(handles.editdefect,'visible','off')
        set(handles.editthick1,'enable','on')
        set(handles.editFillAx,'enable','on')
        set(handles.popupversus,'value',1)
        set(handles.popupversus,'string',{'Single value'; 'Normalized frequency'; 'Wavelength'; 'Number of modes'; 'Angle of polarization'; 'Angle of incidence'; 'Angle of plane of inc.'; 'Filling factor A'; 'Thickness of Layer 1';'Frequency vs. angle of inc.'})
        set(handles.paneladvanced,'visible','on')
        set(handles.menuindex,'enable','on')
        
    case 5
        set(handles.editFourier,'enable','on');
        set(handles.editFourier,'string',7);
        set(handles.editFourier,'visible','on');
        set(handles.textFourier,'visible','on');
        set(handles.textanglemount,'visible','on');
        set(handles.editanglemount,'visible','on');
        set(handles.editanglemount,'enable','on');
        set(handles.textdegree3,'visible','on');
        set(handles.textXdirection,'visible','on');
        set(handles.textPeriod,'visible','on');
        set(handles.textFillingA,'visible','on');
        set(handles.textFillingAA,'visible','on');
        set(handles.textPosA,'visible','on');
        set(handles.textYdirection,'visible','on');
        set(handles.textau2,'visible','on');
        set(handles.textau3,'visible','on');
        set(handles.editPeriodx,'visible','on');
        set(handles.editPeriody,'visible','on');
        set(handles.editFillAx,'visible','on');
        set(handles.editFillAy,'visible','on');
        set(handles.editFillAAx,'visible','on');
        set(handles.editFillAAy,'visible','on');
        set(handles.editPosAx,'visible','on');
        set(handles.editPosAy,'visible','on');
        set(handles.textelementa,'visible','on');
        set(handles.textelementb,'visible','on');
        set(handles.editpermielementb,'visible','on');
        set(handles.editpermielementa,'visible','on');
        set(handles.editorder,'enable','on');
        set(handles.editorder2,'enable','on');
        set(handles.editorder,'string','0');
        set(handles.editorder2,'string','0');
        set(handles.textperme,'visible','on')
        set(handles.editpermesup,'visible','on')
        set(handles.editpermeelementa,'visible','on')
        set(handles.editpermeelementb,'visible','on')
        set(handles.editpermelayer2,'visible','on')
        set(handles.editpermesub,'visible','on')
        set(handles.editwave,'enable','on')
        set(handles.editanglepol,'enable','on')
        set(handles.editanglei,'enable','on')
        set(handles.textnumberofrods,'visible','off')
        set(handles.editnumberofrods,'visible','off')
        set(handles.editepszz,'visible','off')
        set(handles.textepszz,'visible','off')
        set(handles.editepsxx,'visible','off')
        set(handles.editepsxxm,'visible','off')
        set(handles.editepsxx2,'visible','off')
        set(handles.textepsxy,'visible','off')
        set(handles.editepsxy,'visible','off')
        set(handles.editepsxym,'visible','off')
        set(handles.editepsxy2,'visible','off')
        set(handles.textepsyy,'visible','off')
        set(handles.editepsyy,'visible','off')
        set(handles.editepsyym,'visible','off')
        set(handles.editepsyy2,'visible','off')
        set(handles.textepsxx,'visible','off')
        set(handles.pushfourier,'visible','on')
        set(handles.textfrom,'visible','off')
        set(handles.editfrom,'visible','off')
        set(handles.textto,'visible','off')
        set(handles.editto,'visible','off')
        set(handles.editpoints,'string','1')
        set(handles.editpoints,'enable','off')
        set(handles.editReps2,'visible','off')
        set(handles.textdefect,'visible','off')
        set(handles.textau6,'visible','off')
        set(handles.editdefect,'visible','off')
        set(handles.editthick1,'enable','on')
        set(handles.editFillAx,'enable','on')
        set(handles.popupversus,'value',1)
        set(handles.popupversus,'string',{'Single value'; 'Normalized frequency'; 'Wavelength'; 'Number of modes'; 'Angle of polarization'; 'Angle of incidence'; 'Angle of plane of inc.'; 'Filling factors'; 'Thickness of Layer 1'})
        set(handles.paneladvanced,'visible','on')
        set(handles.menuindex,'enable','on')
        
    case 6
        set(handles.editFourier,'enable','on');
        set(handles.editFourier,'string',111);
        set(handles.editFourier,'visible','on');
        set(handles.textFourier,'visible','on');
        set(handles.textanglemount,'visible','off');
        set(handles.editanglemount,'visible','off');
        set(handles.editanglemount,'enable','off');
        set(handles.editanglemount,'string',0);
        set(handles.textdegree3,'visible','off');
        set(handles.textXdirection,'visible','on');
        set(handles.textPeriod,'visible','on');
        set(handles.textFillingA,'visible','on');
        set(handles.textFillingAA,'visible','off');
        set(handles.textPosA,'visible','off');
        set(handles.textYdirection,'visible','off');
        set(handles.textau2,'visible','on');
        set(handles.textau3,'visible','off');
        set(handles.editPeriodx,'visible','on');
        set(handles.editPeriody,'visible','off');
        set(handles.editFillAx,'visible','on');
        set(handles.editFillAy,'visible','off');
        set(handles.editFillAAx,'visible','off');
        set(handles.editFillAAy,'visible','off');
        set(handles.editPosAx,'visible','off');
        set(handles.editPosAy,'visible','off');
        set(handles.textelementa,'visible','off');
        set(handles.textelementb,'visible','off');
        set(handles.editpermielementa,'visible','off');
        set(handles.editpermielementb,'visible','off');
        set(handles.editorder,'enable','on');
        set(handles.editorder2,'enable','off');
        set(handles.editorder,'string','0');
        set(handles.editorder2,'string','0');
        set(handles.textperme,'visible','off')
        set(handles.editpermesup,'visible','off')
        set(handles.editpermeelementa,'visible','off')
        set(handles.editpermeelementb,'visible','off')
        set(handles.editpermelayer2,'visible','off')
        set(handles.editpermesub,'visible','off')
        set(handles.editwave,'enable','on')
        set(handles.editanglepol,'enable','on')
        set(handles.editanglei,'enable','on')
        set(handles.textnumberofrods,'visible','on')
        set(handles.editnumberofrods,'visible','on')
        set(handles.editepszz,'visible','on')
        set(handles.textepszz,'visible','on')
        set(handles.editepsxx,'visible','on')
        set(handles.editepsxxm,'visible','on')
        set(handles.editepsxx2,'visible','on')
        set(handles.textepsxy,'visible','on')
        set(handles.editepsxy,'visible','on')
        set(handles.editepsxym,'visible','on')
        set(handles.editepsxy2,'visible','on')
        set(handles.textepsyy,'visible','on')
        set(handles.editepsyy,'visible','on')
        set(handles.editepsyym,'visible','on')
        set(handles.editepsyy2,'visible','on')
        set(handles.textepsxx,'visible','on')
        set(handles.pushfourier,'visible','on')
        set(handles.textfrom,'visible','off')
        set(handles.editfrom,'visible','off')
        set(handles.textto,'visible','off')
        set(handles.editto,'visible','off')
        set(handles.editpoints,'string','1')
        set(handles.editpoints,'enable','off')
        set(handles.editReps2,'visible','off')
        set(handles.textdefect,'visible','off')
        set(handles.textau6,'visible','off')
        set(handles.editdefect,'visible','off')
        set(handles.editthick1,'enable','on')
        set(handles.editFillAx,'enable','on')
        set(handles.popupversus,'value',1)
        set(handles.popupversus,'string',{'Single value'; 'Normalized frequency'; 'Wavelength'; 'Different structures'; 'Number of modes'})
        set(handles.paneladvanced,'visible','off')
        set(handles.menuindex,'enable','off')
        
end

function selectgrating_CreateFcn(hObject, ~, ~)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function radioTE_Callback(~ , ~, handles)

set(handles.radioTM,'Value',0);
set(handles.radioTE,'Value',1);
set(handles.editanglepol,'string',0);

function radioTM_Callback(~, ~, handles)

set(handles.radioTE,'Value',0);
set(handles.radioTM,'Value',1);
set(handles.editanglepol,'string',90);


function editwave_Callback(hObject, ~, ~)

correctposvalue(str2double(get(hObject,'string')),hObject);

function editwave_CreateFcn(hObject, ~, ~)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editFourier_Callback(hObject, ~, handles)

correctposvalue(str2double(get(hObject,'string')),hObject);
set(hObject,'string',num2str(floor(str2double(get(hObject,'string')))));
set(handles.editorder,'string',0);
set(handles.editorder,'string',0);

lambda = str2double(get(handles.editwave,'string'));
periodx = str2double(get(handles.editPeriodx,'string'));
periody = str2double(get(handles.editPeriody,'string'));
eps1 = str2double(get(handles.editpermisup,'string'));
mu1 = str2double(get(handles.editpermesup,'string'));
eps2 = str2double(get(handles.editpermisub,'string'));
mu2 = str2double(get(handles.editpermesub,'string'));
anglefi = str2double(get(handles.editanglei,'string'));
angletet = str2double(get(handles.editanglemount,'string'));

switch get(handles.selectgrating,'value')
    
    case {2,6}
        [~, ordsup, ~, ordsub, ~] = diffangles1D(periodx,lambda,anglefi,0,eps1,mu1,eps2,mu2);
        if ismember(str2double(get(hObject,'string')),abs(ordsup)) == 1 || ismember(str2double(get(hObject,'string')),abs(ordsub)) == 1
            set(handles.textoutput,'string','WARNING! Number of Fourier modes should exceed the largest diffraction order. Check "Info" for diffraction orders.')
            beep
        end
        
    case 3
        [~, ordsup, ~, ordsub, ~] = diffangles1D(periodx,lambda,anglefi,angletet,eps1,mu1,eps2,mu2);
        if ismember(str2double(get(hObject,'string')),abs(ordsup)) == 1 || ismember(str2double(get(hObject,'string')),abs(ordsub)) == 1
            set(handles.textoutput,'string','WARNING! Number of Fourier modes should exceed the largest diffraction order. Check "Info" for diffraction orders.')
            beep
        end
        
    case {4,5}
        [~, ordsupx, ordsupy, ~, ordsubx, ordsuby, ~] = diffangles2D(periodx,periody,lambda,anglefi,0,eps1,mu1,eps2,mu2);
        if ismember(str2double(get(hObject,'string')),abs(ordsupx)) == 1 || ismember(str2double(get(hObject,'string')),abs(ordsubx)) == 1 || ismember(str2double(get(hObject,'string')),ordsupy) == 1 || ismember(str2double(get(hObject,'string')),ordsuby) == 1
            set(handles.textoutput,'string','WARNING! Number of Fourier modes should exceed the largest diffraction order. Check "Info" for diffraction orders.')
            beep
        end
end


function editFourier_CreateFcn(hObject, ~, ~)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editanglepol_Callback(hObject, ~, handles)

correctanglevalue(str2double(get(hObject,'string')),hObject);

if str2double(get(hObject,'string')) == 90
    set(handles.radioTM,'value',1);
    set(handles.radioTE,'value',0);
elseif str2double(get(hObject,'string')) == 0;
    set(handles.radioTM,'value',0);
    set(handles.radioTE,'value',1);
else
    set(handles.radioTM,'value',0);
    set(handles.radioTE,'value',0);
end

function editanglepol_CreateFcn(hObject, ~, ~)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editanglei_Callback(hObject, ~, handles)

if abs(str2double(get(hObject,'string'))) == 90
    errordlg('Incident wave is parallel with the surface. Enter smaller angle than 90, please','Please correct your input','modal')
    set(hObject,'string',69);
    uicontrol(hObject)
    return
end

if isnan(str2double(get(hObject,'string')))
    errordlg('Enter a number between 0 and 90, please!','Please correct your input','modal')
    set(hObject, 'string',69);
    uicontrol(hObject)
    return
elseif str2double(get(hObject,'string')) < 0
    errordlg('Enter a number between 0 and 90, please!','Please correct your input','modal')
    set(hObject, 'string',69);
    uicontrol(hObject)
    return
elseif str2double(get(hObject,'string')) > 90
    errordlg('Enter a number between 0 and 90, please!','Please correct your input','modal')
    set(hObject, 'string',69);
    uicontrol(hObject)
    return
end

if str2double(get(hObject,'string')) == 0
    set(handles.editanglemount,'string',0);
end

if str2double(get(handles.editanglemount,'string')) == 0 && get(handles.selectgrating,'value') == 3
    warndlg({'It seems your mounting is orthogonal. Please consider choosing';'"Single period multilayer structure with orthogonal mounting"';'structure type for better speed.'},'Warning','modal')
    uicontrol(hObject)
    return
end

function editanglei_CreateFcn(hObject, ~, ~)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editanglemount_Callback(hObject, ~, handles)

correctanglevalue(str2double(get(hObject,'string')),hObject);

if strcmp(get(handles.editanglei,'string'),'0') == 1
    set(hObject,'string',0);
end
if strcmp(get(hObject,'string'),'0')==1 && get(handles.selectgrating,'value') == 3
    warndlg({'It seems your mounting is orthogonal. Please consider choosing';'"Single period multilayer structure with orthogonal mounting"';'structure type for better speed.'},'Warning','modal')
    uicontrol(hObject)
    return
end

function editanglemount_CreateFcn(hObject, ~, ~)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function pushbuttonQH1_Callback(~, ~, ~)
open('Quick help 2.pdf')

%%%%%%%%%%%%%%%%%%%%%%   GRATING PARAMETERS  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function editPeriodx_Callback(hObject, ~, ~)

correctposvalue(str2double(get(hObject,'string')),hObject)

function editPeriodx_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editPeriody_Callback(hObject, ~, ~)

correctposvalue(str2double(get(hObject,'string')),hObject)

function editPeriody_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editFillAx_Callback(hObject, ~, ~)

correctfillvalue(str2double(get(hObject,'string')),hObject)

function editFillAx_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editFillAy_Callback(hObject, ~, ~)

correctfillvalue(str2double(get(hObject,'string')),hObject)

function editFillAy_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editpermisup_Callback(hObject, ~, ~)

correctcompvalue(str2double(get(hObject,'string')),hObject);

function editpermisup_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editpermesup_Callback(hObject, ~, ~)

correctcompvalue(str2double(get(hObject,'string')),hObject);

function editpermesup_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editpermielementa_Callback(hObject, ~, ~)

correctcompvalue(str2double(get(hObject,'string')),hObject);

function editpermielementa_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editpermielementb_Callback(hObject, ~, ~)

correctcompvalue(str2double(get(hObject,'string')),hObject);


function editpermielementb_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editpermilayer2_Callback(hObject, ~, ~)

correctcompvalue(str2double(get(hObject,'string')),hObject);

function editpermilayer2_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editpermisub_Callback(hObject, ~, ~)

correctcompvalue(str2double(get(hObject,'string')),hObject);

function editpermisub_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editpermeelementa_Callback(hObject, ~, ~)

correctcompvalue(str2double(get(hObject,'string')),hObject);

function editpermeelementa_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editpermeelementb_Callback(hObject, ~, ~)

correctcompvalue(str2double(get(hObject,'string')),hObject);

function editpermeelementb_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editpermelayer2_Callback(hObject, ~, ~)

correctcompvalue(str2double(get(hObject,'string')),hObject);

function editpermelayer2_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editpermesub_Callback(hObject, ~, ~)

correctcompvalue(str2double(get(hObject,'string')),hObject);

function editpermesub_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editthick1_Callback(hObject, ~, ~)

correctposvalue(str2double(get(hObject,'string')),hObject);

function editthick1_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editthick2_Callback(hObject, ~, ~)

correctposvalue(str2double(get(hObject,'string')),hObject);

function editthick2_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editReps_Callback(hObject, ~, ~)

if strcmp(get(hObject,'string'),'0') == 1
    errordlg('This number must be at least 1.','Please correct your input','modal')
    set(hObject, 'string',1);
    uicontrol(hObject)
    return
end
correctposvalue(str2double(get(hObject,'string')),hObject);
set(hObject,'string',num2str(floor(str2double(get(hObject,'string')))));

function editReps_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function pushbuttonQH2_Callback(~, ~, ~)
open('Quick help 3.pdf')

function editFillAAx_Callback(hObject, ~, ~)

correctfillvalue(str2double(get(hObject,'string')),hObject)

function editFillAAx_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editFillAAy_Callback(hObject, ~, ~)

correctfillvalue(str2double(get(hObject,'string')),hObject)

function editFillAAy_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editPosAx_Callback(hObject, ~, ~)

correctpositionvalue(str2double(get(hObject,'string')),hObject);

function editPosAx_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editPosAy_Callback(hObject, ~, ~)

correctpositionvalue(str2double(get(hObject,'string')),hObject);

function editPosAy_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editReps2_Callback(hObject, ~, ~)

correctposvalue(str2double(get(hObject,'string')),hObject);
set(hObject,'string',num2str(floor(str2double(get(hObject,'string')))));

function editReps2_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editdefect_Callback(hObject, ~, ~)

correctposvalue(str2double(get(hObject,'string')),hObject);

function editdefect_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function pushfourier_Callback(~, ~, handles)

switch get(handles.selectgrating,'value')
    case {2,3}
        
        p = str2double(get(handles.editPeriodx,'string'));
        N =  str2double(get(handles.editFourier,'string'));
        fill = str2double(get(handles.editFillAx,'string'));
        e1 = str2double(get(handles.editpermielementa,'string'));
        e2 = str2double(get(handles.editpermielementb,'string'));
        points = 1000;
        i = 1;
        
        h = -N:1:N;
        Eh = (e1-e2)*fill*sinc(h*fill)+e2*sinc(h);
        eps = zeros(1,points);
        X = zeros(1,points);
        
        for s = -.5*p:p/points:.5*p
            eps(i) = exp(1i*2*pi/p*s*h)*transpose(Eh);
            X(i) = s;
            i = i+1;
        end
        
        figure;
        plot(X,real(eps),'-');
        xlabel('One Period [a. u.]');
        ylabel('Relative permittivity (real part) of Layer 1');
        
    case 4
        
        px = str2double(get(handles.editPeriodx,'string'));
        py = str2double(get(handles.editPeriody,'string'));
        N =  str2double(get(handles.editFourier,'string'));
        fillx = str2double(get(handles.editFillAx,'string'));
        filly = str2double(get(handles.editFillAy,'string'));
        e1 = str2double(get(handles.editpermielementa,'string'));
        e2 = str2double(get(handles.editpermielementb,'string'));
        bod = 150;
        
        hx = zeros(1,(2*N+1)^2);
        hy = repmat(-N:1:N,1,2*N+1);
        
        for i = -N:N            %vektor hx
            
            hx(1,(i+N)*(2*N+1)+1:1:(i+N+1)*(2*N+1)) = i;
            
        end
        
        Eh = (e1-e2)*fillx*filly*sinc(hx*fillx).*sinc(hy*filly)+e2*sinc(hx).*sinc(hy);
        j = 1;
        
        eps = zeros(bod,bod);
        
        for s = -.5*px:px/bod:.5*px
            i = 1;
            for t =  -.5*py:py/bod:.5*py
                eps(i,j) = sum(exp(1i*2*pi/px*s*hx).*exp(1i*2*pi/py*t*hy).*Eh);
                i = i+1;
            end
            j = j+1;
        end
        
        figure;
        
        [~,n]=contourf(-.5*px:px/bod:.5*px,-.5*py:py/bod:.5*py,real(eps),100);
        set(n, 'LineStyle', 'none');
        colormap jet;
        colorbar;
        xlabel('Period X');
        ylabel('Period Y');
        
    case 5
        
        px = str2double(get(handles.editPeriodx,'string'));
        py = str2double(get(handles.editPeriody,'string'));
        N =  str2double(get(handles.editFourier,'string'));
        qx1 = str2double(get(handles.editFillAx,'string'));
        qx2 = str2double(get(handles.editFillAAx,'string'));
        qy1 = str2double(get(handles.editFillAy,'string'));
        qy2 = str2double(get(handles.editFillAAy,'string'));
        dx = str2double(get(handles.editPosAx,'string'));
        dy = str2double(get(handles.editPosAy,'string'));
        e1 = str2double(get(handles.editpermielementa,'string'));
        e2 = str2double(get(handles.editpermielementb,'string'));
        bod = 150;
        
        hx = zeros(1,(2*N+1)^2);
        hy = repmat(-N:1:N,1,2*N+1);
        
        for i = -N:N            %vektor hx
            
            hx(1,(i+N)*(2*N+1)+1:1:(i+N+1)*(2*N+1)) = i;
            
        end
        
        Eh = (e1-e2)*qx1*qy1*sinc(hx*qx1).*sinc(hy*qy1)+e2*sinc(hx).*sinc(hy) + ((e1-e2)*qx2*qy2*sinc(hx*qx2).*sinc(hy*qy2)).*exp(1i*2*pi*dx*hx).*exp(1i*2*pi*dy*hy);
        j = 1;
        
        eps = zeros(bod,bod);
        
        for s = -.5*px:px/bod:.5*px
            i = 1;
            for t =  -.5*py:py/bod:.5*py
                eps(i,j) = sum(exp(1i*2*pi/px*s*hx).*exp(1i*2*pi/py*t*hy).*Eh);
                i = i+1;
            end
            j = j+1;
        end
        
        figure;
        
        [~,n]=contourf(-.5*px:px/bod:.5*px,-.5*py:py/bod:.5*py,real(eps),100);
        set(n, 'LineStyle', 'none');
        colormap jet;
        colorbar;
        xlabel('Period X');
        ylabel('Period Y');
        
    case 6
        
        p = str2double(get(handles.editPeriodx,'string'));
        N =  str2double(get(handles.editFourier,'string'));
        fill = str2double(get(handles.editFillAx,'string'));
        e1 = str2double(get(handles.editepsxx,'string'));
        diff = str2double(get(handles.editepsxxm,'string'));
        e2 = str2double(get(handles.editepsxx2,'string'));
        m = str2double(get(handles.editnumberofrods,'string'));
        
        bod = 1000;
        i = 1;
        
        step = p/bod;
        h = -2*N:1:2*N;
        p = (2*m+1)*p;
        e1 = rand(1,2*m+1)*diff + e1;
        L = -m:1:m;
        Eh = zeros(1,4*N+1);
        
        for j = 1:4*N+1
            Eh(1,j) = e2*(sinc(h(j)/(2*m+1)) - fill*sinc(h(j)*fill/(2*m+1))).*diric(h(j)*pi*2/(2*m+1),(2*m+1)) + fill/(2*m+1)*sinc(h(j)*fill/(2*m+1))*sum(e1.*exp(-1i*2*pi*L*h(j)/(2*m+1)));
        end
        
        eps = zeros(1,bod);
        
        for s = -.5*p:step:.5*p
            eps(1,i) = exp(1i*2*pi/p*s*h)*transpose(Eh);
            i = i+1;
        end
        
        figure;
        plot(-.5*p:step:.5*p,real(eps),'-');
        xlabel('Elementary period [a. u.]');
        ylabel('Eps_{xx} (real part)');
        
end


function editepsxx_Callback(hObject, ~, ~)

correctcompvalue(str2double(get(hObject,'string')),hObject);

function editepsxx_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editepsxy_Callback(hObject, ~, ~)

correctcompvalue(str2double(get(hObject,'string')),hObject);

function editepsxy_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editepsyy_Callback(hObject, ~, ~)

correctcompvalue(str2double(get(hObject,'string')),hObject);

function editepsyy_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editepsxxm_Callback(hObject, ~, ~)

correctcompvalue(str2double(get(hObject,'string')),hObject);

function editepsxxm_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editepsxx2_Callback(hObject, ~, ~)

correctcompvalue(str2double(get(hObject,'string')),hObject);

function editepsxx2_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editepsxym_Callback(hObject, ~, ~)

correctcompvalue(str2double(get(hObject,'string')),hObject);

function editepsxym_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editepsxy2_Callback(hObject, ~, ~)

correctcompvalue(str2double(get(hObject,'string')),hObject);

function editepsxy2_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editepsyym_Callback(hObject, ~, ~)

correctcompvalue(str2double(get(hObject,'string')),hObject);

function editepsyym_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editepsyy2_Callback(hObject, ~, ~)

correctcompvalue(str2double(get(hObject,'string')),hObject);

function editepsyy2_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editepszz_Callback(hObject, ~, ~)

correctcompvalue(str2double(get(hObject,'string')),hObject);

function editepszz_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editnumberofrods_Callback(hObject, ~, ~)

correctposvalue(str2double(get(hObject,'string')),hObject);
set(hObject,'string',num2str(floor(str2double(get(hObject,'string')))));

function editnumberofrods_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%%%%%%%%%%%%%%%%%%%%   Calculations  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function checkrefl_Callback(~, ~, handles)

if get(handles.checkrefl,'value') == 0 && get(handles.checktrans,'value') == 0 && get(handles.checkabsorption,'value') == 0
    set(handles.textoutput,'string','You should check at least one quantity (reflectance, transmittance or absorptance).')
    beep
end

versusstring = get(handles.popupversus,'string');
if strcmp(versusstring{get(handles.popupversus,'value')},'Frequency vs. angle of inc.')
    if get(handles.checktrans,'value') + get(handles.checkabsorption,'value') + get(handles.checkrefl,'value') > 1
        set(handles.textoutput,'string','Chceck only one dependent variable for this plot, please!')
        set(handles.checkrefl,'value',1)
        set(handles.checktrans,'value',0)
        set(handles.checkabsorption,'value',0)
        beep
    end
end

function checktrans_Callback(~, ~, handles)

if get(handles.checkrefl,'value') == 0 && get(handles.checktrans,'value') == 0 && get(handles.checkabsorption,'value') == 0
    set(handles.textoutput,'string','You should check at least one quantity (reflectance, transmittance or absorptance).')
    beep
end

versusstring = get(handles.popupversus,'string');
if strcmp(versusstring{get(handles.popupversus,'value')},'Frequency vs. angle of inc.')
    if get(handles.checktrans,'value') + get(handles.checkabsorption,'value') + get(handles.checkrefl,'value') > 1
        set(handles.textoutput,'string','Chceck only one dependent variable for this plot, please!')
        set(handles.checkrefl,'value',0)
        set(handles.checktrans,'value',1)
        set(handles.checkabsorption,'value',0)
        beep
    end
end

function checkabsorption_Callback(~, ~, handles)

if get(handles.checkrefl,'value') == 0 && get(handles.checktrans,'value') == 0 && get(handles.checkabsorption,'value') == 0
    set(handles.textoutput,'string','You should check at least one quantity (reflectance, transmittance or absorptance).')
    beep
end

versusstring = get(handles.popupversus,'string');
if strcmp(versusstring{get(handles.popupversus,'value')},'Frequency vs. angle of inc.')
    if get(handles.checktrans,'value') + get(handles.checkabsorption,'value') + get(handles.checkrefl,'value') > 1
        set(handles.textoutput,'string','Chceck only one dependent variable for this plot, please!')
        set(handles.checkrefl,'value',0)
        set(handles.checktrans,'value',0)
        set(handles.checkabsorption,'value',1)
        beep
    end
end

function popupversus_Callback(~, ~, handles)

versusstring = get(handles.popupversus,'string');
switch versusstring{get(handles.popupversus,'value')}
    case 'Single value'
        set(handles.textfrom,'visible','off');
        set(handles.editfrom,'visible','off');
        set(handles.textto,'visible','off');
        set(handles.editto,'visible','off');
        set(handles.editpoints,'enable','off');
        set(handles.editpoints,'string',1);
        
        set(handles.editwave,'enable','on')
        set(handles.editanglei,'enable','on')
        set(handles.editanglepol,'enable','on')
        set(handles.editanglemount,'enable','on');
        set(handles.editFourier,'enable','on')
        set(handles.editthick1,'enable','on')
        set(handles.editFillAx,'enable','on')
        set(handles.editFillAy,'enable','on')
        
    case 'Normalized frequency'
        set(handles.editfrom,'string',0.001)
        set(handles.editto,'string',1.1)
        set(handles.textfrom,'visible','on');
        set(handles.editfrom,'visible','on');
        set(handles.textto,'visible','on');
        set(handles.editto,'visible','on');
        set(handles.editpoints,'enable','on');
        set(handles.editpoints,'string',100);
        
        set(handles.editwave,'enable','off')
        set(handles.editanglei,'enable','on')
        set(handles.editanglepol,'enable','on')
        set(handles.editanglemount,'enable','on')
        set(handles.editFourier,'enable','on')
        set(handles.editthick1,'enable','on')
        set(handles.editFillAx,'enable','on')
        set(handles.editFillAy,'enable','on')
        
    case 'Number of modes'
        set(handles.editfrom,'string',1)
        set(handles.editto,'string',55)
        set(handles.textfrom,'visible','on');
        set(handles.editfrom,'visible','on');
        set(handles.textto,'visible','on');
        set(handles.editto,'visible','on');
        set(handles.editpoints,'enable','on');
        set(handles.editpoints,'string',55);
        set(handles.editpoints,'enable','off');
        set(handles.editorder,'string','0');
        set(handles.editorder2,'string','0');
        
        set(handles.editwave,'enable','on')
        set(handles.editanglei,'enable','on')
        set(handles.editanglepol,'enable','on')
        set(handles.editanglemount,'enable','on');
        set(handles.editFourier,'enable','off')
        set(handles.editthick1,'enable','on')
        set(handles.editFillAx,'enable','on')
        set(handles.editFillAy,'enable','on')
        
    case 'Wavelength'
        set(handles.editfrom,'string',444)
        set(handles.editto,'string',888)
        set(handles.textfrom,'visible','on');
        set(handles.editfrom,'visible','on');
        set(handles.textto,'visible','on');
        set(handles.editto,'visible','on');
        set(handles.editpoints,'enable','on');
        set(handles.editpoints,'string',100);
        
        set(handles.editwave,'enable','off')
        set(handles.editanglei,'enable','on')
        set(handles.editanglepol,'enable','on')
        set(handles.editanglemount,'enable','on');
        set(handles.editFourier,'enable','on')
        set(handles.editthick1,'enable','on')
        set(handles.editFillAx,'enable','on')
        set(handles.editFillAy,'enable','on')
        
    case 'Angle of polarization'
        set(handles.editfrom,'string',0)
        set(handles.editto,'string',90)
        set(handles.textfrom,'visible','on');
        set(handles.editfrom,'visible','on');
        set(handles.textto,'visible','on');
        set(handles.editto,'visible','on');
        set(handles.editpoints,'enable','on');
        set(handles.editpoints,'string',90);
        
        set(handles.editwave,'enable','on')
        set(handles.editanglei,'enable','on')
        set(handles.editanglepol,'enable','off')
        set(handles.editanglemount,'enable','on');
        set(handles.editFourier,'enable','on')
        set(handles.editthick1,'enable','on')
        set(handles.editFillAx,'enable','on')
        set(handles.editFillAy,'enable','on')
        
    case 'Angle of plane of inc.'
        set(handles.editfrom,'string',0)
        set(handles.editto,'string',90)
        set(handles.textfrom,'visible','on');
        set(handles.editfrom,'visible','on');
        set(handles.textto,'visible','on');
        set(handles.editto,'visible','on');
        set(handles.editpoints,'enable','on');
        set(handles.editpoints,'string',90);
        
        set(handles.editwave,'enable','on')
        set(handles.editanglei,'enable','on')
        set(handles.editanglepol,'enable','on')
        set(handles.editanglemount,'enable','off');
        set(handles.editFourier,'enable','on')
        set(handles.editthick1,'enable','on')
        set(handles.editFillAx,'enable','on')
        set(handles.editFillAy,'enable','on')
        
    case 'Angle of incidence'
        set(handles.editfrom,'string',0)
        set(handles.editto,'string',89.9)
        set(handles.textfrom,'visible','on');
        set(handles.editfrom,'visible','on');
        set(handles.textto,'visible','on');
        set(handles.editto,'visible','on');
        set(handles.editpoints,'enable','on');
        set(handles.editpoints,'string',90);
        
        set(handles.editwave,'enable','on')
        set(handles.editanglei,'enable','off')
        set(handles.editanglepol,'enable','on')
        set(handles.editanglemount,'enable','on')
        set(handles.editFourier,'enable','on')
        set(handles.editthick1,'enable','on')
        set(handles.editFillAx,'enable','on')
        set(handles.editFillAy,'enable','on')
        
    case 'Filling factor A'
        set(handles.editfrom,'string',0)
        set(handles.editto,'string',1)
        set(handles.textfrom,'visible','on');
        set(handles.editfrom,'visible','on');
        set(handles.textto,'visible','on');
        set(handles.editto,'visible','on');
        set(handles.editpoints,'enable','on');
        set(handles.editpoints,'string',100);
        
        set(handles.editwave,'enable','on')
        set(handles.editanglei,'enable','on')
        set(handles.editanglepol,'enable','on')
        set(handles.editanglemount,'enable','on')
        set(handles.editFourier,'enable','on')
        set(handles.editthick1,'enable','on')
        set(handles.editFillAx,'enable','off')
        set(handles.editFillAy,'enable','off')
        
    case 'Thickness of Layer 1'
        set(handles.editfrom,'string',10)
        set(handles.editto,'string',1000)
        set(handles.textfrom,'visible','on');
        set(handles.editfrom,'visible','on');
        set(handles.textto,'visible','on');
        set(handles.editto,'visible','on');
        set(handles.editpoints,'enable','on');
        set(handles.editpoints,'string',100);
        
        set(handles.editwave,'enable','on')
        set(handles.editanglei,'enable','on')
        set(handles.editanglepol,'enable','on')
        set(handles.editanglemount,'enable','on');
        set(handles.editFourier,'enable','on')
        set(handles.editthick1,'enable','off')
        set(handles.editFillAx,'enable','on')
        set(handles.editFillAy,'enable','on')
        
    case 'Different structures'
        set(handles.editfrom,'string',0)
        set(handles.editto,'string',100)
        set(handles.textfrom,'visible','on');
        set(handles.editfrom,'visible','on');
        set(handles.textto,'visible','on');
        set(handles.editto,'visible','on');
        set(handles.editpoints,'string',101);
        set(handles.editpoints,'enable','off');
        
        set(handles.editwave,'enable','on')
        set(handles.editanglei,'enable','on')
        set(handles.editanglepol,'enable','on')
        set(handles.editanglemount,'enable','on');
        set(handles.editFourier,'enable','on')
        set(handles.editthick1,'enable','on')
        set(handles.editFillAx,'enable','on')
        set(handles.editFillAy,'enable','on')
        
    case 'Frequency vs. angle of inc.'
        set(handles.editfrom,'string',0.001)
        set(handles.editto,'string',1.1)
        set(handles.textfrom,'visible','on');
        set(handles.editfrom,'visible','on');
        set(handles.textto,'visible','on');
        set(handles.editto,'visible','on');
        set(handles.editpoints,'enable','on');
        set(handles.editpoints,'string',101);
        
        set(handles.editwave,'enable','off')
        set(handles.editanglei,'enable','off')
        set(handles.editanglepol,'enable','on')
        set(handles.editanglemount,'enable','on');
        set(handles.editFourier,'enable','on')
        set(handles.editthick1,'enable','on')
        set(handles.editFillAx,'enable','on')
        set(handles.editFillAy,'enable','on')
        
        set(handles.checkrefl,'value',0)
        set(handles.checktrans,'value',1)
        set(handles.checkabsorption,'value',0)
end

function popupversus_CreateFcn(hObject, ~, ~)

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editfrom_Callback(hObject, ~, handles)

versusstring = get(handles.popupversus,'string');
switch versusstring{get(handles.popupversus,'value')}
    
    case {'Wavelength', 'Thickness of Layer 1','Frequency vs. angle of inc.','Normalized frequency'}
        correctposvalue(str2double(get(hObject,'string')),hObject);
        if str2double(get(hObject,'string')) >= str2double(get(handles.editto,'string'))
            set(handles.textoutput,'string','"from" value must be smaller than "to" value!')
            beep
            return
        end
        
    case 'Number of modes'
        correctposvalue(str2double(get(hObject,'string')),hObject);
        set(hObject,'string',num2str(floor(str2double(get(hObject,'string')))));
        if str2double(get(hObject,'string')) < str2double(get(handles.editorder,'string'))
            set(handles.textoutput,'string','Minimum Fourier mode has to be at least the given diffraction orders.')
            set(hObject,'string',get(handles.editorder,'string'))
            beep
        end
        if str2double(get(hObject,'string')) < str2double(get(handles.editorder2,'string'))
            set(handles.textoutput,'string','Minimum Fourier mode has to be at least the given diffraction orders.')
            set(hObject,'string',get(handles.editorder2,'string'))
            beep
        end
        if str2double(get(hObject,'string')) >= str2double(get(handles.editto,'string'))
            set(handles.textoutput,'string','"from" value must be smaller than "to" value!')
            beep
            return
        end
        set(handles.editpoints,'string',num2str(str2double(get(handles.editto,'string')) - str2double(get(handles.editfrom,'string')) + 1));
        
    case 'Filling factor A'
        correctpositionvalue(str2double(get(hObject,'string')),hObject);
        if str2double(get(hObject,'string')) >= str2double(get(handles.editto,'string'))
            errordlg('This value must be smaller than the final value.','Please correct your input','modal')
            set(hObject,'string',0);
            beep
            return
        end
        
    case {'Angle of incidence', 'Angle of polarization', 'Angle of plane of incidence'}
        correctanglevalue(str2double(get(hObject,'string')),hObject);
        if str2double(get(hObject,'string')) >= str2double(get(handles.editto,'string'))
            set(handles.textoutput,'string','"from" value must be smaller than "to" value!')
            beep
            return
        end
        
    case 'Different structure'
        correctposvalue(str2double(get(hObject,'string')),hObject);
        set(hObject,'string',num2str(floor(str2double(get(hObject,'string')))));
        if str2double(get(hObject,'string')) >= str2double(get(handles.editto,'string'))
            set(handles.textoutput,'string','"from" value must be smaller than "to" value!')
            beep
            return
        end
        set(handles.editpoints,'string',num2str(str2double(get(handles.editto,'string')) - str2double(get(handles.editfrom,'string')) + 1));
        
end

function editfrom_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editto_Callback(hObject, ~, handles)

versusstring = get(handles.popupversus,'string');
switch versusstring{get(handles.popupversus,'value')}
    
    case {'Wavelength', 'Thickness of Layer 1','Normalized frequency','Frequency vs. angle of inc.'}
        correctposvalue(str2double(get(hObject,'string')),hObject);
        if str2double(get(hObject,'string')) <= str2double(get(handles.editfrom,'string'))
            set(handles.textoutput,'string','"to" value must be larger than "from" value!')
            beep
            return
        end
        
    case 'Different structures'
        correctposvalue(str2double(get(hObject,'string')),hObject);
        set(hObject,'string',num2str(floor(str2double(get(hObject,'string')))));
        if str2double(get(hObject,'string')) <= str2double(get(handles.editfrom,'string'))
            set(handles.textoutput,'string','"to" value must be larger than "from" value!')
            beep
            return
        end
        set(handles.editpoints,'string',num2str(str2double(get(handles.editto,'string')) - str2double(get(handles.editfrom,'string')) + 1));
        
    case 'Filling factor A'
        correctpositionvalue(str2double(get(hObject,'string')),hObject);
        if str2double(get(hObject,'string')) <= str2double(get(handles.editfrom,'string'))
            set(handles.textoutput,'string','"to" value must be larger than "from" value!')
            beep
            return
        end
        
    case {'Angle of incidence', 'Angle of polarization', 'Angle of plane of incidence'}
        correctanglevalue(str2double(get(hObject,'string')),hObject);
        if str2double(get(hObject,'string')) <= str2double(get(handles.editfrom,'string'))
            set(handles.textoutput,'string','"to" value must be larger than "from" value!')
            beep
            return
        end
        
    case 'Number of modes'
        correctposvalue(str2double(get(hObject,'string')),hObject);
        set(hObject,'string',num2str(floor(str2double(get(hObject,'string')))));
        if str2double(get(hObject,'string')) <= str2double(get(handles.editfrom,'string'))
            set(handles.textoutput,'string','"to" value must be larger than "from" value!')
            beep
            return
        end
        set(handles.editpoints,'string',num2str(str2double(get(handles.editto,'string')) - str2double(get(handles.editfrom,'string')) + 1));
        
end

function editto_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function pushQH3_Callback(~, ~, ~)
open('Quick help 4.pdf')


function pushcheck_Callback(~, ~, handles)

lambda = str2double(get(handles.editwave,'string'));
periodx = str2double(get(handles.editPeriodx,'string'));
periody = str2double(get(handles.editPeriody,'string'));
eps1 = str2double(get(handles.editpermisup,'string'));
mu1 = str2double(get(handles.editpermesup,'string'));
eps2 = str2double(get(handles.editpermisub,'string'));
mu2 = str2double(get(handles.editpermesub,'string'));
anglefi = str2double(get(handles.editanglei,'string'));
angletet = str2double(get(handles.editanglemount,'string'));

switch get(handles.selectgrating,'value')
    
    case 1
        answ = diffangles0D(anglefi,eps1,mu1,eps2,mu2);
        if answ < 90
            msgbox({'The following non-evanescent diffraction orders are present:','',...
                ['Superstrate: zeroth order under ' num2str(anglefi) ' degrees'],'', ['Substrate: zeroth order under ' num2str(answ) ' degrees']...
                },'Info','modal');
        elseif answ == 90
            msgbox({'The following non-evanescent diffraction orders are present:','',...
                ['Superstrate: zeroth order under ' num2str(anglefi) ' degrees'],'', ['Substrate: zeroth order under ' num2str(answ) ' degrees'],'','WARNING! Transmitted wave is propagating parallel to the structure. This will cause numerical instabilities. You should change parameters a little bit!'...
                },'Info','modal');
        elseif answ == 102
            msgbox({'The following non-evanescent diffraction orders are present:','',...
                ['Superstrate: zeroth order under ' num2str(anglefi) ' degrees'],'', 'Substrate: no transmitted energy, substrate is absorbing.'...
                },'Info','modal');
        elseif answ == 101
            msgbox({'The following non-evanescent diffraction orders are present:','',...
                ['Superstrate: zeroth order under ' num2str(anglefi) ' degrees'],'', 'Substrate: no transmitted energy, total reflection occurs.'...
                },'Info','modal');
        end
        
    case {2,6}
        [answ, ordsup, diffasup, ordsub, diffasub] = diffangles1D(periodx, lambda,anglefi,0,eps1,mu1,eps2,mu2);
        if answ == 102
            if ismember(90,diffasup)
                sep1 = repmat(' ........ ',length(ordsup),1);
                msgbox({'The following non-evanescent diffraction orders are present:','',...
                    'Superstrate:','','order ... angle (degree)', [num2str(ordsup) sep1 num2str(diffasup)],'', 'Substrate: no energy is transmitted, because substrate is absorbing.','',...
                    'WARNING! Diffracted order(s) is propagating parallel to the structure. This will cause numerical instabilities. You should change parameters a little bit!'},'Info','modal');
            else
                sep1 = repmat(' ........ ',length(ordsup),1);
                msgbox({'The following non-evanescent diffraction orders are present:','',...
                    'Superstrate:','','order ... angle (degree)', [num2str(ordsup) sep1 num2str(diffasup)],'', 'Substrate: no energy is transmitted, because substrate is absorbing.'},'Info','modal');
            end
        elseif isempty(diffasub)
            if ismember(90,diffasup)
                sep1 = repmat(' ........ ',length(ordsup),1);
                msgbox({'The following non-evanescent diffraction orders are present:','',...
                    'Superstrate:','','order ... angle (degree)', [num2str(ordsup) sep1 num2str(diffasup)],'', 'Substrate: no energy is transmitted, becasue total reflection occurs.','',...
                    'WARNING! Diffracted order(s) is propagating parallel to the structure. This will cause numerical instabilities. You should change parameters a little bit!'},'Info','modal');
            else
                sep1 = repmat(' ........ ',length(ordsup),1);
                msgbox({'The following non-evanescent diffraction orders are present:','',...
                    'Superstrate:','','order ... angle (degree)', [num2str(ordsup) sep1 num2str(diffasup)], '','Substrate: no energy is transmitted, because total reflection occurs.'},'Info','modal');
            end
        elseif ismember(90,diffasup) || ismember(90,diffasub)
            sep1 = repmat(' ........ ',length(ordsup),1);
            sep2 = repmat(' ........ ',length(ordsub),1);
            msgbox({'The following non-evanescent diffraction orders are present:','',...
                'Superstrate:','','order ... angle (degree)', [num2str(ordsup) sep1 num2str(diffasup)], '', 'Substrate:','','order ... angle (degree)',[num2str(ordsub) sep2 num2str(diffasub)],'',...
                'WARNING! Diffracted order(s) is propagating parallel to the structure. This will cause numerical instabilities. You should change parameters a little bit!'},'Info','modal');
        else
            sep1 = repmat(' ........ ',length(ordsup),1);
            sep2 = repmat(' ........ ',length(ordsub),1);
            msgbox({'The following non-evanescent diffraction orders are present:','',...
                'Superstrate:','','order ... angle (degree)', [num2str(ordsup) sep1 num2str(diffasup)],'', 'Substrate:','','order ... angle (degree)',[num2str(ordsub) sep2 num2str(diffasub)]},'Info','modal');
        end
        
    case 3
        [answ, ordsup, diffasup, ordsub, diffasub] = diffangles1D(periodx, lambda,anglefi,angletet,eps1,mu1,eps2,mu2);
        if answ == 102
            if ismember(90,diffasup)
                sep1 = repmat(' ........ ',length(ordsup),1);
                msgbox({'The following non-evanescent diffraction orders are present:','',...
                    'Superstrate:','','order ... angle (degree)', [num2str(ordsup) sep1 num2str(diffasup)],'', 'Substrate: no energy is transmitted, because substrate is absorbing.','',...
                    'WARNING! Diffracted order(s) is propagating parallel to the structure. This will cause numerical instabilities. You should change parameters a little bit!'},'Info','modal');
            else
                sep1 = repmat(' ........ ',length(ordsup),1);
                msgbox({'The following non-evanescent diffraction orders are present:','',...
                    'Superstrate:','','order ... angle (degree)', [num2str(ordsup) sep1 num2str(diffasup)],'', 'Substrate: no energy is transmitted, because substrate is absorbing.'},'Info','modal');
            end
        elseif isempty(diffasub)
            if ismember(90,diffasup)
                sep1 = repmat(' ........ ',length(ordsup),1);
                msgbox({'The following non-evanescent diffraction orders are present:','',...
                    'Superstrate:','','order ... angle (degree)', [num2str(ordsup) sep1 num2str(diffasup)],'', 'Substrate: no energy is transmitted, becasue total reflection occurs.','',...
                    'WARNING! Diffracted order(s) is propagating parallel to the structure. This will cause numerical instabilities. You should change parameters a little bit!'},'Info','modal');
            else
                sep1 = repmat(' ........ ',length(ordsup),1);
                msgbox({'The following non-evanescent diffraction orders are present:','',...
                    'Superstrate:','','order ... angle (degree)', [num2str(ordsup) sep1 num2str(diffasup)], '','Substrate: no energy is transmitted, because total reflection occurs.'},'Info','modal');
            end
        elseif ismember(90,diffasup) || ismember(90,diffasub)
            sep1 = repmat(' ........ ',length(ordsup),1);
            sep2 = repmat(' ........ ',length(ordsub),1);
            msgbox({'The following non-evanescent diffraction orders are present:','',...
                'Superstrate:','','order ... angle (degree)', [num2str(ordsup) sep1 num2str(diffasup)], '', 'Substrate:','','order ... angle (degree)',[num2str(ordsub) sep2 num2str(diffasub)],'',...
                'WARNING! Diffracted order(s) is propagating parallel to the structure. This will cause numerical instabilities. You should change parameters a little bit!'},'Info','modal');
        else
            sep1 = repmat(' ........ ',length(ordsup),1);
            sep2 = repmat(' ........ ',length(ordsub),1);
            msgbox({'The following non-evanescent diffraction orders are present:','',...
                'Superstrate:','','order ... angle (degree)', [num2str(ordsup) sep1 num2str(diffasup)],'', 'Substrate:','','order ... angle (degree)',[num2str(ordsub) sep2 num2str(diffasub)]},'Info','modal');
        end
        
    case {4,5}
        [answ, ordsupx, ordsupy, diffasup, ordsubx, ordsuby, diffasub] = diffangles2D(periodx, periody,lambda,anglefi,angletet,eps1,mu1,eps2,mu2);
        if answ == 102
            if ismember(90,diffasup)
                sep1 = repmat(' ........... ',length(ordsupx),1);
                sepc = repmat(', ', length(ordsupx),1);
                msgbox({'The following non-evanescent diffraction orders are present:','',...
                    'Superstrate:','','order [x, y] ... angle (degree)', [num2str(ordsupx) sepc num2str(ordsupy) sep1 num2str(diffasup)],'', 'Substrate: no energy is transmitted, because substrate is absorbing.','',...
                    'WARNING! Diffracted order(s) is propagating parallel to the structure. This will cause numerical instabilities. You should change parameters a little bit!'},'Info','modal');
            else
                sep1 = repmat(' ........... ',length(ordsupx),1);
                sepc = repmat(', ', length(ordsupx),1);
                msgbox({'The following non-evanescent diffraction orders are present:','',...
                    'Superstrate:','','order [x, y] ... angle (degree)', [num2str(ordsupx) sepc num2str(ordsupy) sep1 num2str(diffasup)],'', 'Substrate: no energy is transmitted, because substrate is absorbing.'},'Info','modal');
            end
        elseif isempty(diffasub)
            if ismember(90,diffasup)
                sep1 = repmat(' ........... ',length(ordsupx),1);
                sepc = repmat(', ', length(ordsupx),1);
                msgbox({'The following non-evanescent diffraction orders are present:','',...
                    'Superstrate:','','order [x, y] ... angle (degree)', [num2str(ordsupx) sepc num2str(ordsupy) sep1 num2str(diffasup)],'', 'Substrate: no energy is transmitted, becasue total reflection occurs.','',...
                    'WARNING! Diffracted order(s) is propagating parallel to the structure. This will cause numerical instabilities. You should change parameters a little bit!'},'Info','modal');
            else
                sep1 = repmat(' ........... ',length(ordsupx),1);
                sepc = repmat(', ', length(ordsupx),1);
                msgbox({'The following non-evanescent diffraction orders are present:','',...
                    'Superstrate:','','order [x, y] ... angle (degree)', [num2str(ordsupx)  sepc num2str(ordsupy) sep1 num2str(diffasup)], '','Substrate: no energy is transmitted, because total reflection occurs.'},'Info','modal');
            end
        elseif ismember(90,diffasup) || ismember(90,diffasub)
            sep1 = repmat(' ........... ',length(ordsupx),1);
            sep2 = repmat(' ........... ',length(ordsubx),1);
            sepc1 = repmat(', ', length(ordsupx),1);
            sepc2 = repmat(', ', length(ordsubx),1);
            msgbox({'The following non-evanescent diffraction orders are present:','',...
                'Superstrate:','','order [x, y] ... angle (degree)', [num2str(ordsupx) sepc1 num2str(ordsupy) sep1 num2str(diffasup)], '', 'Substrate:','','order [x, y] ... angle (degree)',[num2str(ordsubx) sepc2 num2str(ordsuby) sep2 num2str(diffasub)],'',...
                'WARNING! Diffracted order(s) is propagating parallel to the structure. This will cause numerical instabilities. You should change parameters a little bit!'},'Info','modal');
        else
            sep1 = repmat(' ........... ',length(ordsupx),1);
            sep2 = repmat(' ........... ',length(ordsubx),1);
            sepc1 = repmat(', ', length(ordsupx),1);
            sepc2 = repmat(', ', length(ordsubx),1);
            msgbox({'The following non-evanescent diffraction orders are present:','',...
                'Superstrate:','','order [x, y] ... angle (degree)', [num2str(ordsupx) sepc1 num2str(ordsupy) sep1 num2str(diffasup)],'', 'Substrate:','','order [x, y] ... angle (degree)',[num2str(ordsubx) sepc2 num2str(ordsuby) sep2 num2str(diffasub)]},'Info','modal');
        end
end


function editpoints_Callback(hObject, ~, ~)

correctposvalue(str2double(get(hObject,'string')),hObject);
set(hObject,'string',num2str(floor(str2double(get(hObject,'string')))));

function editpoints_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editorder_Callback(hObject, ~, handles)

if isnan(str2double(get(hObject,'string'))) && strcmp(get(hObject,'string'),':')==0
    errordlg('Enter a number or a colon ( : ) for all diffraction orders, please!','Please correct your input','modal')
    set(hObject,'string',0);
    uicontrol(hObject)
    return
elseif isnan(str2double(get(hObject,'string'))) == 0
    set(hObject,'string',num2str(floor(str2double(get(hObject,'string')))));
end

if abs(str2double(get(hObject,'string'))) > str2double(get(handles.editFourier,'string'))
    errordlg({'Diffraction order can not be larger than the largest Fourier mode.','You can still increase number of Fourier modes.'},'Please correct your input','modal')
    set(hObject,'string',get(handles.editFourier,'string'))
    uicontrol(hObject);
    return
end

versusstring = get(handles.popupversus,'string');
if strcmp(versusstring{get(handles.popupversus,'value')},'Number of modes')
    if abs(str2double(get(hObject,'string'))) > str2double(get(handles.editfrom,'string'))
        set(handles.editfrom,'string',num2str(abs(str2double(get(hObject,'string')))))
        uicontrol(hObject);
        return
    end
end

function editorder_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editorder2_Callback(hObject, ~, handles)

if isnan(str2double(get(hObject,'string'))) && strcmp(get(hObject,'string'),char.empty(1,0))==0
    errordlg('Enter a number or leave it blank for all diffraction orders, please!','Please correct your input','modal')
    set(hObject,'string',0);
    uicontrol(hObject)
    return
elseif isnan(str2double(get(hObject,'string'))) == 0
    set(hObject,'string',num2str(floor(str2double(get(hObject,'string')))));
end

if abs(str2double(get(hObject,'string'))) > str2double(get(handles.editFourier,'string'))
    errordlg({'Diffraction order can not be larger than the largest Fourier mode.','You can still increase number of Fourier modes.'},'Please correct your input','modal')
    set(hObject,'string',get(handles.editFourier,'string'))
    uicontrol(hObject);
    return
end

versusstring = get(handles.popupversus,'string');
if strcmp(versusstring{get(handles.popupversus,'value')},'Number of modes')
    if abs(str2double(get(hObject,'string'))) > str2double(get(handles.editfrom,'string'))
        set(handles.editfrom,'string',num2str(abs(str2double(get(hObject,'string')))))
        uicontrol(hObject);
        return
    end
end

function editorder2_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%%%%%%%%%%%%%%%%%%%%%%%%%  Advanced options  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function pushQH4_Callback(~, ~, ~)
open('Quick help 5.pdf')

function popuppermi_Callback(hObject, ~, handles)

switch get(hObject,'value')
    case 1
        set(handles.editfp,'visible','off')
        set(handles.editG,'visible','off')
        set(handles.textfp,'visible','off')
        set(handles.textG,'visible','off')
        set(handles.textGHz1,'visible','off')
        set(handles.textGHz2,'visible','off')
        set(handles.editpermielementa,'enable','on')
        set(handles.showeps,'visible','off')
        
    case {2,3}
        set(handles.editfp,'visible','on')
        set(handles.editG,'visible','on')
        set(handles.textfp,'visible','on')
        set(handles.textG,'visible','on')
        set(handles.textGHz1,'visible','on')
        set(handles.textGHz2,'visible','on')
        set(handles.editpermielementa,'enable','off')
        set(handles.showeps,'visible','on')
        
    case 4
        set(handles.editfp,'visible','off')
        set(handles.editG,'visible','off')
        set(handles.textfp,'visible','off')
        set(handles.textG,'visible','off')
        set(handles.textGHz1,'visible','off')
        set(handles.textGHz2,'visible','off')
        set(handles.editpermielementa,'enable','on')
        set(handles.showeps,'visible','on')
        
        [filename,pathname] = uigetfile('*.*','Load custom dispersion');
        if isequal(filename,0)
            set(handles.textoutput,'string','Custom dispersion not set.');
            beep
            set(handles.popuppermi,'value',1)
            set(handles.showeps,'visible','off')
        else
            try
                epsfile = dlmread(fullfile(pathname,filename));
                [~,nrofcols] = size(epsfile);
                if nrofcols == 3
                    set(handles.textoutput,'string',['Dispersion of permittivity is loaded from file: ' filename]);
                    beep;
                    handles.fileEPS = fullfile(pathname,filename);
                    guidata(hObject, handles);
                else
                    set(handles.textoutput,'string',{'Dispersion of permittivity is not loaded. File must be formatted to a three-column numeric table. First column is for wavelengths, second is the real part, third is the imaginary part of permittivity.'})
                    set(handles.popuppermi,'value',1)
                    set(handles.showeps,'visible','off')
                    beep
                end
            catch
                set(handles.textoutput,'string',{'Dispersion of permittivity is not loaded. File must be formatted to a three-column numeric table. First column is for wavelengths, second is the real part, third is the imaginary part of permittivity.'})
                beep
                set(handles.popuppermi,'value',1)
                set(handles.showeps,'visible','off')
            end
        end
        
end

function popuppermi_CreateFcn(hObject, ~, ~)

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function popupperme_Callback(hObject, ~, handles)
switch get(hObject,'value')
    case 1
        set(handles.editf0,'visible','off')
        set(handles.editF,'visible','off')
        set(handles.textf0,'visible','off')
        set(handles.textF,'visible','off')
        set(handles.textGHz3,'visible','off')
        set(handles.textGHz4,'visible','off')
        set(handles.editpermeelementa,'enable','on')
        set(handles.showmi,'visible','off')
        
    case 2
        set(handles.editf0,'visible','on')
        set(handles.editF,'visible','on')
        set(handles.textf0,'visible','on')
        set(handles.textF,'visible','on')
        set(handles.textGHz3,'visible','on')
        set(handles.textGHz4,'visible','on')
        set(handles.editpermeelementa,'enable','off')
        set(handles.showmi,'visible','on')
        
    case 3
        set(handles.editf0,'visible','off')
        set(handles.editF,'visible','off')
        set(handles.textf0,'visible','off')
        set(handles.textF,'visible','off')
        set(handles.textGHz3,'visible','off')
        set(handles.textGHz4,'visible','off')
        set(handles.editpermeelementa,'enable','on')
        set(handles.showmi,'visible','on')
        
        [filename,pathname] = uigetfile('*.*','Load custom dispersion');
        if isequal(filename,0)
            set(handles.textoutput,'string','Custom dispersion not set.');
            beep
            set(handles.popupperme,'value',1)
            set(handles.showmi,'visible','off')
        else
            try
                mufile = dlmread(fullfile(pathname,filename));
                [~,nrofcols] = size(mufile);
                if nrofcols == 3
                    set(handles.textoutput,'string',['Dispersion of permeability is loaded from file: ' filename]);
                    beep;
                    handles.fileMU = fullfile(pathname,filename);
                    guidata(hObject, handles);
                else
                    set(handles.textoutput,'string',{'Dispersion of permeability is not loaded. File must be formatted to a three-column numeric table. First column is for wavelengths, second is the real part, third is the imaginary part of permeability.'})
                    set(handles.popupperme,'value',1)
                    set(handles.showmi,'visible','off')
                    beep
                end
            catch
                set(handles.textoutput,'string',{'Dispersion of permeability is not loaded. File must be formatted to a three-column numeric table. First column is for wavelengths, second is the real part, third is the imaginary part of permeability.'})
                beep
                set(handles.popupperme,'value',1)
                set(handles.showmi,'visible','off')
            end
        end
        
end

function popupperme_CreateFcn(hObject, ~, ~)

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editfp_Callback(hObject, ~, ~)

correctposvalue(str2double(get(hObject,'string')),hObject)

function editfp_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editG_Callback(hObject, ~, ~)

correctposvalue(str2double(get(hObject,'string')),hObject)

function editG_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editf0_Callback(hObject, ~, ~)

correctposvalue(str2double(get(hObject,'string')),hObject)

function editf0_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editF_Callback(hObject, ~, ~)

correctposvalue(str2double(get(hObject,'string')),hObject)

function editF_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function showeps_Callback(~, ~, handles)

versusstring = get(handles.popupversus,'string');
switch get(handles.popuppermi,'value')
    case 2
        switch versusstring{get(handles.popupversus,'value')}
            case 'Wavelength'
                
                fp = str2double(get(handles.editfp,'string'));
                gama = str2double(get(handles.editG,'string'));
                from = str2double(get(handles.editfrom,'string'));
                to = str2double(get(handles.editto,'string'));
                points = str2double(get(handles.editpoints,'string'));
                
                X = from:(to-from)/points:to;
                frek  = 299792458./X;
                epsf = 1 - fp^2./(frek.*(frek+1i*gama));
                
                figure;
                hold on;
                plot(X,real(epsf),'displayname','Real Permittivity');
                plot(X,imag(epsf),'displayname','Imaginary Permittivity');
                xlabel('Wavelength [nm]');
                ylabel('Relative permittivity of Element A');
                legend('-DynamicLegend');
                
            case 'Normalized frequency'
                
                fp = str2double(get(handles.editfp,'string'));
                gama = str2double(get(handles.editG,'string'));
                from = str2double(get(handles.editfrom,'string'));
                to = str2double(get(handles.editto,'string'));
                points = str2double(get(handles.editpoints,'string'));
                if get(handles.selectgrating,'value') == 1
                    period = str2double(get(handles.editthick1,'string'));
                else
                    period = str2double(get(handles.editPeriodx,'string'));
                end
                
                X = from:(to-from)/points:to;
                frek  = 299792458.*X/period;
                epsf = 1 - fp^2./(frek.*(frek+1i*gama));
                
                figure;
                hold on;
                plot(X,real(epsf),'displayname','Real Permittivity');
                plot(X,imag(epsf),'displayname','Imaginary Permittivity');
                if get(handles.selectgrating,'value') == 1
                    xlabel('Thickness of Layer 1 / Wavelength');
                else
                    xlabel('Period / Wavelength');
                end
                ylabel('Relative permittivity of Element A');
                legend('-DynamicLegend');
                
            otherwise
                set(handles.textoutput,'string','Please select "Wavelength" or "Normalized frequency" and set the desired interval.')
                
        end
        
    case 3
        switch versusstring{get(handles.popupversus,'value')}
            case 'Wavelength'
                
                fp = str2double(get(handles.editfp,'string'));
                gama = str2double(get(handles.editG,'string'));
                from = str2double(get(handles.editfrom,'string'));
                to = str2double(get(handles.editto,'string'));
                points = str2double(get(handles.editpoints,'string'));
                
                X = from:(to-from)/points:to;
                frek  = 299792458./X;
                epsf = 1 - (fp^2./(frek.^2+gama^2)).^2;
                
                figure;
                hold on;
                plot(X,real(epsf));
                xlabel('Wavelength [nm]');
                ylabel('Relative permittivity of Element A');
                
            case 'Normalized frequency'
                
                fp = str2double(get(handles.editfp,'string'));
                gama = str2double(get(handles.editG,'string'));
                from = str2double(get(handles.editfrom,'string'));
                to = str2double(get(handles.editto,'string'));
                points = str2double(get(handles.editpoints,'string'));
                if get(handles.selectgrating,'value') == 1
                    period = str2double(get(handles.editthick1,'string'));
                else
                    period = str2double(get(handles.editPeriodx,'string'));
                end
                
                X = from:(to-from)/points:to;
                frek  = 299792458.*X/period;
                epsf = 1 - (fp^2./(frek.^2+gama^2)).^2;
                
                figure;
                hold on;
                plot(X,real(epsf));
                if get(handles.selectgrating,'value') == 1
                    xlabel('Thickness of Layer 1 / Wavelength');
                else
                    xlabel('Period / Wavelength');
                end
                ylabel('Relative permittivity of Element A');
                
            otherwise
                set(handles.textoutput,'string','Please select "Wavelength" or "Normalized frequency" and set the desired interval.')
        end
        
    case 4
        switch versusstring{get(handles.popupversus,'value')}
            case 'Wavelength'
                
                from = str2double(get(handles.editfrom,'string'));
                to = str2double(get(handles.editto,'string'));
                points = str2double(get(handles.editpoints,'string'));
                
                X = from:(to-from)/points:to;
                
                EPS = dlmread(handles.fileEPS);
                wave = EPS(:,1);
                epsR = EPS(:,2);
                epsI = EPS(:,3);
                epsf = spline(wave,epsR,X) + 1i*spline(wave,epsI,X);
                
                figure;
                hold on;
                plot(X,real(epsf),'displayname','Real Permittivity');
                plot(X,imag(epsf),'displayname','Imaginary Permittivity');
                xlabel('Wavelength [nm]');
                ylabel('Relative permittivity of Element A');
                legend('-DynamicLegend');
                
            case 'Normalized frequency'
                
                from = str2double(get(handles.editfrom,'string'));
                to = str2double(get(handles.editto,'string'));
                points = str2double(get(handles.editpoints,'string'));
                if get(handles.selectgrating,'value') == 1
                    period = str2double(get(handles.editthick1,'string'));
                else
                    period = str2double(get(handles.editPeriodx,'string'));
                end
                
                X = from:(to-from)/points:to;
                EPS = dlmread(handles.fileEPS);
                wave = EPS(:,1);
                epsR = EPS(:,2);
                epsI = EPS(:,3);
                epsf = spline(wave,epsR,period./X) + 1i*spline(wave,epsI,period./X);
                
                figure;
                hold on;
                plot(X,real(epsf),'displayname','Real Permittivity');
                plot(X,imag(epsf),'displayname','Imaginary Permittivity');
                if get(handles.selectgrating,'value') == 1
                    xlabel('Thickness of Layer 1 / Wavelength');
                else
                    xlabel('Period / Wavelength');
                end
                ylabel('Relative permittivity of Element A');
                legend('-DynamicLegend');
                
            otherwise
                set(handles.textoutput,'string','Please select "Wavelength" or "Normalized frequency" and set the desired interval.')
                
        end
        
        
end

function showmi_Callback(~, ~, handles)

versusstring = get(handles.popupversus,'string');

switch get(handles.popupperme,'value')
    case 2
        switch versusstring{get(handles.popupversus,'value')}
            case 'Wavelength'
                
                F = str2double(get(handles.editF,'string'));
                f0 = str2double(get(handles.editf0,'string'));
                from = str2double(get(handles.editfrom,'string'));
                to = str2double(get(handles.editto,'string'));
                points = str2double(get(handles.editpoints,'string'));
                
                X = from:(to-from)/points:to;
                frek  = 299792458./X;
                epsf = 1 - F*frek.^2./(frek.^2 - f0^2);
                
                figure;
                hold on;
                plot(X,real(epsf));
                xlabel('Wavelength [nm]');
                ylabel('Relative permeability of Element A');
                
            case 'Normalized frequency'
                
                f0 = str2double(get(handles.editf0,'string'));
                F = str2double(get(handles.editF,'string'));
                from = str2double(get(handles.editfrom,'string'));
                to = str2double(get(handles.editto,'string'));
                points = str2double(get(handles.editpoints,'string'));
                if get(handles.selectgrating,'value') == 1
                    period = str2double(get(handles.editthick1,'string'));
                else
                    period = str2double(get(handles.editPeriodx,'string'));
                end
                
                X = from:(to-from)/points:to;
                frek  = 299792458.*X/period;
                epsf = 1 - F*frek.^2./(frek.^2 - f0^2);
                
                figure;
                hold on;
                plot(X,epsf);
                if get(handles.selectgrating,'value') == 1
                    xlabel('Thickness of Layer 1 / Wavelength');
                else
                    xlabel('Period / Wavelength');
                end
                ylabel('Relative permeability of Element A');
                
            otherwise
                set(handles.textoutput,'string','Please select "Wavelength" or "Normalized frequency" and set the desired interval.')
                
        end
        
    case 3
        switch versusstring{get(handles.popupversus,'value')}
            case 'Wavelength'
                
                from = str2double(get(handles.editfrom,'string'));
                to = str2double(get(handles.editto,'string'));
                points = str2double(get(handles.editpoints,'string'));
                
                X = from:(to-from)/points:to;
                
                MU = dlmread(handles.fileMU);
                wave = MU(:,1);
                muR = MU(:,2);
                muI = MU(:,3);
                muf = spline(wave,muR,X) + 1i*spline(wave,muI,X);
                
                figure;
                hold on;
                plot(X,real(muf),'displayname','Real Permeability');
                plot(X,imag(muf),'displayname','Imaginary Permeability');
                xlabel('Wavelength [nm]');
                ylabel('Relative permeability of Element A');
                legend('-DynamicLegend');
                
            case 'Normalized frequency'
                
                from = str2double(get(handles.editfrom,'string'));
                to = str2double(get(handles.editto,'string'));
                points = str2double(get(handles.editpoints,'string'));
                if get(handles.selectgrating,'value') == 1
                    period = str2double(get(handles.editthick1,'string'));
                else
                    period = str2double(get(handles.editPeriodx,'string'));
                end
                
                X = from:(to-from)/points:to;
                MU = dlmread(handles.fileMU);
                wave = MU(:,1);
                muR = MU(:,2);
                muI = MU(:,3);
                muf = spline(wave,muR,period./X) + 1i*spline(wave,muI,period./X);
                
                figure;
                hold on;
                plot(X,real(muf),'displayname','Real Permeability');
                plot(X,imag(muf),'displayname','Imaginary Permeability');
                if get(handles.selectgrating,'value') == 1
                    xlabel('Thickness of Layer 1 / Wavelength');
                else
                    xlabel('Period / Wavelength');
                end
                ylabel('Relative permeability of Element A');
                legend('-DynamicLegend');
        end
end

%%%%%%%%%%%%%%%%%%%%%%%  Results  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function togglehold_Callback(hObject, ~, ~)
if get(hObject,'value')==0
    set(hObject,'string','Hold off');
elseif get(hObject,'value')==1
    set(hObject,'string','Hold all');
end

function pushQH5_Callback(~, ~, ~)
open('Quick help 6.pdf')

function editoutput_Callback(~, ~, ~)

function editoutput_CreateFcn(hObject, ~, ~)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function pushbGo_Callback(hObject, ~, handles)     % >>>>>>>>>>>>  _GO_  <<<<<<<<<<<<<<
tic
set(hObject,'enable','off');
format long;
i = 0;                                   %%% for control sequence
hwait = waitbar(0,'Please wait...','Name','Working','CreateCancelBtn','setappdata(gcbf,''canceling'',1)');
setappdata(hwait,'canceling',0)

NF = str2double(get(handles.editFourier,'string'));
lambda = str2double(get(handles.editwave,'string'));
psi = degtorad(str2double(get(handles.editanglepol,'string')));
psio = str2double(get(handles.editanglepol,'string'));
fi = degtorad(str2double(get(handles.editanglei,'string')));
tet = degtorad(str2double(get(handles.editanglemount,'string')));
periodx = str2double(get(handles.editPeriodx,'string'));
periody = str2double(get(handles.editPeriody,'string'));
fillax = str2double(get(handles.editFillAx,'string'));
fillay = str2double(get(handles.editFillAy,'string'));
fillaax = str2double(get(handles.editFillAAx,'string'));
fillaay = str2double(get(handles.editFillAAy,'string'));
posax = str2double(get(handles.editPosAx,'string'));
posay = str2double(get(handles.editPosAy,'string'));
mrods = str2double(get(handles.editnumberofrods,'string'));
eps1 = str2double(get(handles.editpermisup,'string'));
mu1 = str2double(get(handles.editpermesup,'string'));
epsxx = str2double(get(handles.editepsxx,'string'));
epsxxm = str2double(get(handles.editepsxxm,'string'));
epsxx2 = str2double(get(handles.editepsxx2,'string'));
epsxy = str2double(get(handles.editepsxy,'string'));
epsxym = str2double(get(handles.editepsxym,'string'));
epsxy2 = str2double(get(handles.editepsxy2,'string'));
epsyy = str2double(get(handles.editepsyy,'string'));
epsyym = str2double(get(handles.editepsyym,'string'));
epsyy2 = str2double(get(handles.editepsyy2,'string'));
epszz = str2double(get(handles.editepszz,'string'));
fp = (str2double(get(handles.editfp,'string')));
G = (str2double(get(handles.editG,'string')));
f0 = (str2double(get(handles.editf0,'string')));
F = (str2double(get(handles.editF,'string')));
frek = 299792458/lambda;     %%%   ak je lambda v nm a frekvencia v GHz
switch get(handles.popuppermi,'value')
    case 1
        epsa = str2double(get(handles.editpermielementa,'string'));
    case 2
        epsa = 1 - fp^2/(frek*(frek+1i*G));
    case 3
        epsa = 1 - (fp^2/(frek^2+G^2))^2;
    case 4
        EPS = dlmread(handles.fileEPS);
        wave = EPS(:,1);
        epsR = EPS(:,2);
        epsI = EPS(:,3);
        epsa = spline(wave,epsR,lambda) + 1i*spline(wave,epsI,lambda);
end
switch get(handles.popupperme,'value')
    case 1
        mua = str2double(get(handles.editpermeelementa,'string'));
    case 2
        mua = 1 - F*frek^2/(frek^2 - f0^2);
    case 3
        MU = dlmread(handles.fileMU);
        wave = MU(:,1);
        muR = MU(:,2);
        muI = MU(:,3);
        mua = spline(wave,muR,lambda) + 1i*spline(wave,muI,lambda);
end
epsb = str2double(get(handles.editpermielementb,'string'));
mub = str2double(get(handles.editpermeelementb,'string'));
epsl2 = str2double(get(handles.editpermilayer2,'string'));
mul2 = str2double(get(handles.editpermelayer2,'string'));
eps2 = str2double(get(handles.editpermisub,'string'));
mu2 = str2double(get(handles.editpermesub,'string'));
reps1 = str2double(get(handles.editReps,'string'));
reps2= str2double(get(handles.editReps2,'string'));
d1 = str2double(get(handles.editthick1,'string'));
d2 = str2double(get(handles.editthick2,'string'));
def = str2double(get(handles.editdefect,'string'));
from = str2double(get(handles.editfrom,'string'));
to = str2double(get(handles.editto,'string'));
orderxo = str2double(get(handles.editorder,'string'));
orderyo = str2double(get(handles.editorder2,'string'));
if isnan(orderxo) || isnan(orderyo)
    orderx = ':';
elseif get(handles.selectgrating,'value') == 4 || get(handles.selectgrating,'value') == 5
    orderx = (2*NF+1)*(orderxo+NF) + orderyo + NF+1;
else
    orderx = orderxo+NF+1;
end
points = str2double(get(handles.editpoints,'string'));

versusstring = get(handles.popupversus,'string');
switch get(handles.selectgrating,'value')  %XXXXXXXXXXXXXXXXXXXXXXX MAIN switch  ---------->
    
    case 1   %%%   BRAGG  =====================================================================
        R0 = zeros(points,1);
        T0 = zeros(points,1);
        A0 = zeros(points,1);
        X = zeros(points,1);
        
        switch versusstring{get(handles.popupversus,'value')}
            
            case 'Single value'   %% Single ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                if psio == 0
                    [A,R,T] = braggTE(lambda,fi,eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                elseif psio == 90
                    [A,R,T] = braggTM(lambda,fi,eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                else
                    [Ate,Rte,Tte] = braggTE(lambda,fi,eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                    [Atm,Rtm,Ttm] = braggTM(lambda,fi,eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                    A =Ate*(cos(psi))^2 + Atm*(sin(psi))^2;
                    R = Rte*(cos(psi))^2 + Rtm*(sin(psi))^2;
                    T = Tte*(cos(psi))^2 + Ttm*(sin(psi))^2;
                end
                
                set(handles.textoutput,'string',{['R_0 = ' num2str(R)];['T_0 = ' num2str(T)];['A = ' num2str(1-A)]})
                delete(hwait);
                
            case 'Normalized frequency'  %% Normalized Frequency ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                if psio == 0
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        frek = 299792458*s/d1;     %%%   ak je lambda v nm a frekvencia v GHz
                        switch get(handles.popuppermi,'value')
                            case 1
                                epsa = str2double(get(handles.editpermielementa,'string'));
                            case 2
                                epsa = 1 - fp^2/(frek*(frek+1i*G));
                            case 3
                                epsa = 1 - (fp^2/(frek^2+G^2))^2;
                            case 4
                                epsa = spline(wave,epsR,d1/s) + 1i*spline(wave,epsI,d1/s);
                        end
                        switch get(handles.popupperme,'value')
                            case 1
                                mua = str2double(get(handles.editpermeelementa,'string'));
                            case 2
                                mua = 1 - F*frek^2/(frek^2 - f0^2);
                            case 3
                                mua = spline(wave,muR,d1/s) + 1i*spline(wave,muI,d1/s);
                        end
                        
                        [A,R,T] = braggTE(d1/s,fi,eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        X(i,1) = s;
                        R0(i,1) = R;
                        T0(i,1) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                elseif psio == 90
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        frek = 299792458*s/d1;     %%%   ak je lambda v nm a frekvencia v GHz
                        switch get(handles.popuppermi,'value')
                            case 1
                                epsa = str2double(get(handles.editpermielementa,'string'));
                            case 2
                                epsa = 1 - fp^2/(frek*(frek+1i*G));
                            case 3
                                epsa = 1 - (fp^2/(frek^2+G^2))^2;
                            case 4
                                epsa = spline(wave,epsR,d1/s) + 1i*spline(wave,epsI,d1/s);
                        end
                        switch get(handles.popupperme,'value')
                            case 1
                                mua = str2double(get(handles.editpermeelementa,'string'));
                            case 2
                                mua = 1 - F*frek^2/(frek^2 - f0^2);
                            case 3
                                mua = spline(wave,muR,d1/s) + 1i*spline(wave,muI,d1/s);
                        end
                        
                        [A,R,T] = braggTM(d1/s,fi,eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        X(i,1) = s;
                        R0(i,1) = R;
                        T0(i,1) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                else
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        frek = 299792458*s/d1;     %%%   ak je lambda v nm a frekvencia v GHz
                        switch get(handles.popuppermi,'value')
                            case 1
                                epsa = str2double(get(handles.editpermielementa,'string'));
                            case 2
                                epsa = 1 - fp^2/(frek*(frek+1i*G));
                            case 3
                                epsa = 1 - (fp^2/(frek^2+G^2))^2;
                            case 4
                                epsa = spline(wave,epsR,d1/s) + 1i*spline(wave,epsI,d1/s);
                        end
                        switch get(handles.popupperme,'value')
                            case 1
                                mua = str2double(get(handles.editpermeelementa,'string'));
                            case 2
                                mua = 1 - F*frek^2/(frek^2 - f0^2);
                            case 3
                                mua = spline(wave,muR,d1/s) + 1i*spline(wave,muI,d1/s);
                        end
                        
                        [Ate,Rte,Tte] = braggTE(d1/s,fi,eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        [Atm,Rtm,Ttm] = braggTM(d1/s,fi,eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        A =Ate*(cos(psi))^2 + Atm*(sin(psi))^2;
                        R = Rte*(cos(psi))^2 + Rtm*(sin(psi))^2;
                        T = Tte*(cos(psi))^2 + Ttm*(sin(psi))^2;
                        
                        X(i,1) = s;
                        R0(i,1) = R;
                        T0(i,1) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                end
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R0,'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R0],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value') == 1
                    plot(X,T0,'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T0],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value') == 1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Thickness of layer 1 / Wavelength');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Wavelength'  %% Wavelength::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                if psio == 0
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        frek = 299792458/s;     %%%   ak je lambda v nm a frekvencia v GHz
                        switch get(handles.popuppermi,'value')
                            case 1
                                epsa = str2double(get(handles.editpermielementa,'string'));
                            case 2
                                epsa = 1 - fp^2/(frek*(frek+1i*G));
                            case 3
                                epsa = 1 - (fp^2/(frek^2+G^2))^2;
                            case 4
                                epsa = spline(wave,epsR,s) + 1i*spline(wave,epsI,s);
                        end
                        switch get(handles.popupperme,'value')
                            case 1
                                mua = str2double(get(handles.editpermeelementa,'string'));
                            case 2
                                mua = 1 - F*frek^2/(frek^2 - f0^2);
                            case 3
                                mua = spline(wave,muR,s) + 1i*spline(wave,muI,s);
                        end
                        
                        [A,R,T] = braggTE(s,fi,eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        X(i,1) = s;
                        R0(i,1) = R;
                        T0(i,1) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                elseif psio == 90
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        frek = 299792458/s;     %%%   ak je lambda v nm a frekvencia v GHz
                        switch get(handles.popuppermi,'value')
                            case 1
                                epsa = str2double(get(handles.editpermielementa,'string'));
                            case 2
                                epsa = 1 - fp^2/(frek*(frek+1i*G));
                            case 3
                                epsa = 1 - (fp^2/(frek^2+G^2))^2;
                            case 4
                                epsa = spline(wave,epsR,s) + 1i*spline(wave,epsI,s);
                        end
                        switch get(handles.popupperme,'value')
                            case 1
                                mua = str2double(get(handles.editpermeelementa,'string'));
                            case 2
                                mua = 1 - F*frek^2/(frek^2 - f0^2);
                            case 3
                                mua = spline(wave,muR,s) + 1i*spline(wave,muI,s);
                        end
                        
                        [A,R,T] = braggTM(s,fi,eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        X(i,1) = s;
                        R0(i,1) = R;
                        T0(i,1) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                else
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        frek = 299792458/s;     %%%   ak je lambda v nm a frekvencia v GHz
                        switch get(handles.popuppermi,'value')
                            case 1
                                epsa = str2double(get(handles.editpermielementa,'string'));
                            case 2
                                epsa = 1 - fp^2/(frek*(frek+1i*G));
                            case 3
                                epsa = 1 - (fp^2/(frek^2+G^2))^2;
                            case 4
                                epsa = spline(wave,epsR,s) + 1i*spline(wave,epsI,s);
                        end
                        switch get(handles.popupperme,'value')
                            case 1
                                mua = str2double(get(handles.editpermeelementa,'string'));
                            case 2
                                mua = 1 - F*frek^2/(frek^2 - f0^2);
                            case 3
                                mua = spline(wave,muR,s) + 1i*spline(wave,muI,s);
                        end
                        
                        [Ate,Rte,Tte] = braggTE(s,fi,eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        [Atm,Rtm,Ttm] = braggTM(s,fi,eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        A =Ate*(cos(psi))^2 + Atm*(sin(psi))^2;
                        R = Rte*(cos(psi))^2 + Rtm*(sin(psi))^2;
                        T = Tte*(cos(psi))^2 + Ttm*(sin(psi))^2;
                        
                        X(i,1) = s;
                        R0(i,1) = R;
                        T0(i,1) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                end
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R0,'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R0],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T0,'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T0],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Wavelength [a. u.]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Angle of incidence'  %% Angle of incidence::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                if psio == 0
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        [A,R,T] = braggTE(lambda,degtorad(s),eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        X(i,1) = s;
                        R0(i,1) = R;
                        T0(i,1) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                elseif psio == 90
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        [A,R,T] = braggTM(lambda,degtorad(s),eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        X(i,1) = s;
                        R0(i,1) = R;
                        T0(i,1) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                else
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        [Ate,Rte,Tte] = braggTE(lambda,degtorad(s),eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        [Atm,Rtm,Ttm] = braggTM(lambda,degtorad(s),eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        A =Ate*(cos(psi))^2 + Atm*(sin(psi))^2;
                        R = Rte*(cos(psi))^2 + Rtm*(sin(psi))^2;
                        T = Tte*(cos(psi))^2 + Ttm*(sin(psi))^2;
                        
                        X(i,1) = s;
                        R0(i,1) = R;
                        T0(i,1) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                end
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R0,'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R0],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T0,'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T0],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Angle of incidence [degree]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend')
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Angle of polarization'  %% Angle of polarization::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    
                    i = i+1;
                    
                    [Ate,Rte,Tte] = braggTE(lambda,fi,eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                    [Atm,Rtm,Ttm] = braggTM(lambda,fi,eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                    A =Ate*(cos(degtorad(s)))^2 + Atm*(sin(degtorad(s)))^2;
                    R = Rte*(cos(degtorad(s)))^2 + Rtm*(sin(degtorad(s)))^2;
                    T = Tte*(cos(degtorad(s)))^2 + Ttm*(sin(degtorad(s)))^2;
                    
                    X(i,1) = s;
                    R0(i,1) = R;
                    T0(i,1) = T;
                    A0(i,1) = 1-A;
                    
                end
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R0,'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R0],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T0,'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T0],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Angle of polarization [degree]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend')
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Thickness of Layer 1'  %% Layer 1 Thickness::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                if psio == 0
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        [A,R,T] = braggTE(lambda,fi,eps1,mu1,s,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        X(i,1) = s;
                        R0(i,1) = R;
                        T0(i,1) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                elseif psio == 90
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        [A,R,T] = braggTM(lambda,fi,eps1,mu1,s,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        X(i,1) = s;
                        R0(i,1) = R;
                        T0(i,1) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                else
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        [Ate,Rte,Tte] = braggTE(lambda,fi,eps1,mu1,s,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        [Atm,Rtm,Ttm] = braggTM(lambda,fi,eps1,mu1,s,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        A =Ate*(cos(psi))^2 + Atm*(sin(psi))^2;
                        R = Rte*(cos(psi))^2 + Rtm*(sin(psi))^2;
                        T = Tte*(cos(psi))^2 + Ttm*(sin(psi))^2;
                        
                        X(i,1) = s;
                        R0(i,1) = R;
                        T0(i,1) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                end
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R0,'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R0],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T0,'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T0],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Thickness of layer 1  [a. u.]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend')
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Frequency vs. angle of inc.'   %% Frequency vs. inc. angle:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                R0 = zeros(points,91);
                T0 = zeros(points,91);
                A0 = zeros(points,91);
                X = zeros(points,1);
                
                if psio == 0
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        frek = 299792458*s/d1;     %%%   ak je lambda v nm a frekvencia v GHz
                        switch get(handles.popuppermi,'value')
                            case 1
                                epsa = str2double(get(handles.editpermielementa,'string'));
                            case 2
                                epsa = 1 - fp^2/(frek*(frek+1i*G));
                            case 3
                                epsa = 1 - (fp^2/(frek^2+G^2))^2;
                            case 4
                                epsa = spline(wave,epsR,d1/s) + 1i*spline(wave,epsI,d1/s);
                        end
                        switch get(handles.popupperme,'value')
                            case 1
                                mua = str2double(get(handles.editpermeelementa,'string'));
                            case 2
                                mua = 1 - F*frek^2/(frek^2 - f0^2);
                            case 3
                                mua = spline(wave,muR,d1/s) + 1i*spline(wave,muI,d1/s);
                        end
                        
                        j = 1;
                        for t = 0:0.999999:90       %%% angle loop
                            
                            [A,R,T] = braggTE(d1/s,t*pi/180,eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                            X(i,1) = s;
                            R0(i,j) = R;
                            T0(i,j) = T;
                            A0(i,j) = 1-A;
                            j = j+1;
                        end
                        
                    end
                    
                elseif psio == 90
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        frek = 299792458*s/d1;     %%%   ak je lambda v nm a frekvencia v GHz
                        switch get(handles.popuppermi,'value')
                            case 1
                                epsa = str2double(get(handles.editpermielementa,'string'));
                            case 2
                                epsa = 1 - fp^2/(frek*(frek+1i*G));
                            case 3
                                epsa = 1 - (fp^2/(frek^2+G^2))^2;
                            case 4
                                epsa = spline(wave,epsR,d1/s) + 1i*spline(wave,epsI,d1/s);
                        end
                        switch get(handles.popupperme,'value')
                            case 1
                                mua = str2double(get(handles.editpermeelementa,'string'));
                            case 2
                                mua = 1 - F*frek^2/(frek^2 - f0^2);
                            case 3
                                mua = spline(wave,muR,d1/s) + 1i*spline(wave,muI,d1/s);
                        end
                        
                        j = 1;
                        for t = 0:0.999999:90       %%% angle loop
                            
                            [A,R,T] = braggTM(d1/s,t*pi/180,eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                            X(i,1) = s;
                            R0(i,j) = R;
                            T0(i,j) = T;
                            A0(i,j) = 1-A;
                            j = j+1;
                        end
                        
                    end
                    
                else
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        frek = 299792458*s/d1;     %%%   ak je lambda v nm a frekvencia v GHz
                        switch get(handles.popuppermi,'value')
                            case 1
                                epsa = str2double(get(handles.editpermielementa,'string'));
                            case 2
                                epsa = 1 - fp^2/(frek*(frek+1i*G));
                            case 3
                                epsa = 1 - (fp^2/(frek^2+G^2))^2;
                            case 4
                                epsa = spline(wave,epsR,d1/s) + 1i*spline(wave,epsI,d1/s);
                        end
                        switch get(handles.popupperme,'value')
                            case 1
                                mua = str2double(get(handles.editpermeelementa,'string'));
                            case 2
                                mua = 1 - F*frek^2/(frek^2 - f0^2);
                        end
                        
                        j = 1;
                        for t = 0:0.999999:90       %%% angle loop
                            
                            [Ate,Rte,Tte] = braggTE(d1/s,t*pi/180,eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                            [Atm,Rtm,Ttm] = braggTM(d1/s,t*pi/180,eps1,mu1,d1,epsa,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                            A =Ate*(cos(psi))^2 + Atm*(sin(psi))^2;
                            R = Rte*(cos(psi))^2 + Rtm*(sin(psi))^2;
                            T = Tte*(cos(psi))^2 + Ttm*(sin(psi))^2;
                            
                            X(i,1) = s;
                            R0(i,j) = R;
                            T0(i,j) = T;
                            A0(i,j) = 1-A;
                            j = j+1;
                        end
                        
                    end
                    
                end
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    [~,n] = contourf(0:0.999999:90,X,R0,300);
                    set(n, 'LineStyle', 'none');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],R0,'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    [~,n] = contourf(0:0.999999:90,X,T0,300);
                    set(n, 'LineStyle', 'none');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],T0,'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    [~,n] = contourf(0:0.999999:90,X,A0,300);
                    set(n, 'LineStyle', 'none');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],A0,'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Angle of incidence [deg]');
                ylabel('Normalized frequency');
                colormap pink;
                colorbar;
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            otherwise
                set(handles.textoutput,'string','Selected variable is not available, please choose a different versus.');
                delete(hwait);
        end
        
    case 2   %%%   1D ORTHOGONAL ===============================================================
        R1 = zeros(points,2*NF+1);
        T1 = zeros(points,2*NF+1);
        A0 = zeros(points,1);
        R0 = zeros(points,1);
        T0 = zeros(points,1);
        X = zeros(points,1);
        
        switch versusstring{get(handles.popupversus,'value')}
            
            case 'Single value'   %% Single ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                if psio == 0
                    [A,R,T] = SoTE(NF,periodx,lambda,fi,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                elseif psio == 90
                    [A,R,T] = SoTM(NF,periodx,lambda,fi,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                else
                    [Ate,Rte,Tte] = SoTE(NF,periodx,lambda,fi,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                    [Atm,Rtm,Ttm] =SoTM(NF,periodx,lambda,fi,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                    A =Ate*(cos(psi))^2 + Atm*(sin(psi))^2;
                    R = Rte*(cos(psi))^2 + Rtm*(sin(psi))^2;
                    T = Tte*(cos(psi))^2 + Ttm*(sin(psi))^2;
                end
                
                if get(handles.checkrefl,'value')==1
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],R(1,orderx),'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],T(1,orderx),'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],1-A,'delimiter','\t','precision',12);
                    end
                end
                delete(hwait);
                
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{['R_0 = ' num2str(R(NF+1))];['T_0 = ' num2str(T(NF+1))];['A = ' num2str(1-A) '       Results of all orders are automatically saved to file ' get(handles.editoutput,'string')]})
                else
                    set(handles.textoutput,'string',{['R_0 = ' num2str(R(NF+1))];['T_0 = ' num2str(T(NF+1))];['A = ' num2str(1-A) '       Automatic saves are available in the full version only.']})
                end
                
            case 'Normalized frequency'    %% Normalized frequency ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                if psio == 0
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        frek = 299792458*s/periodx;     %%%   ak je lambda v nm a frekvencia v GHz
                        switch get(handles.popuppermi,'value')
                            case 1
                                epsa = str2double(get(handles.editpermielementa,'string'));
                            case 2
                                epsa = 1 - fp^2/(frek*(frek+1i*G));
                            case 3
                                epsa = 1 - (fp^2/(frek^2+G^2))^2;
                            case 4
                                epsa = spline(wave,epsR,periodx/s) + 1i*spline(wave,epsI,periodx/s);
                        end
                        switch get(handles.popupperme,'value')
                            case 1
                                mua = str2double(get(handles.editpermeelementa,'string'));
                            case 2
                                mua = 1 - F*frek^2/(frek^2 - f0^2);
                            case 3
                                mua = spline(wave,muR,periodx/s) + 1i*spline(wave,muI,periodx/s);
                        end
                        
                        [A,R,T] = SoTE(NF,periodx,periodx/s,fi,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        X(i,1) = s;
                        R1(i,:) = R;
                        T1(i,:) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                elseif psio == 90
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        frek = 299792458*s/periodx;     %%%   ak je lambda v nm a frekvencia v GHz
                        switch get(handles.popuppermi,'value')
                            case 1
                                epsa = str2double(get(handles.editpermielementa,'string'));
                            case 2
                                epsa = 1 - fp^2/(frek*(frek+1i*G));
                            case 3
                                epsa = 1 - (fp^2/(frek^2+G^2))^2;
                            case 4
                                epsa = spline(wave,epsR,periodx/s) + 1i*spline(wave,epsI,periodx/s);
                        end
                        switch get(handles.popupperme,'value')
                            case 1
                                mua = str2double(get(handles.editpermeelementa,'string'));
                            case 2
                                mua = 1 - F*frek^2/(frek^2 - f0^2);
                            case 3
                                mua = spline(wave,muR,periodx/s) + 1i*spline(wave,muI,periodx/s);
                        end
                        
                        [A,R,T] = SoTM(NF,periodx,periodx/s,fi,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        X(i,1) = s;
                        R1(i,:) = R;
                        T1(i,:) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                else
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        
                        i = i+1;
                        
                        frek = 299792458*s/periodx;     %%%   ak je lambda v nm a frekvencia v GHz
                        switch get(handles.popuppermi,'value')
                            case 1
                                epsa = str2double(get(handles.editpermielementa,'string'));
                            case 2
                                epsa = 1 - fp^2/(frek*(frek+1i*G));
                            case 3
                                epsa = 1 - (fp^2/(frek^2+G^2))^2;
                            case 4
                                epsa = spline(wave,epsR,periodx/s) + 1i*spline(wave,epsI,periodx/s);
                        end
                        switch get(handles.popupperme,'value')
                            case 1
                                mua = str2double(get(handles.editpermeelementa,'string'));
                            case 2
                                mua = 1 - F*frek^2/(frek^2 - f0^2);
                            case 3
                                mua = spline(wave,muR,periodx/s) + 1i*spline(wave,muI,periodx/s);
                        end
                        
                        [Ate,Rte,Tte] = SoTE(NF,periodx,periodx/s,fi,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        [Atm,Rtm,Ttm] = SoTM(NF,periodx,periodx/s,fi,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        A =Ate*(cos(psi))^2 + Atm*(sin(psi))^2;
                        R = Rte*(cos(psi))^2 + Rtm*(sin(psi))^2;
                        T = Tte*(cos(psi))^2 + Ttm*(sin(psi))^2;
                        X(i,1) = s;
                        R1(i,:) = R;
                        T1(i,:) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                end
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R1(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T1(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Period / Wavelength');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Wavelength'   %% Wavelength :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                if psio == 0
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        frek = 299792458/s;     %%%   ak je lambda v nm a frekvencia v GHz
                        switch get(handles.popuppermi,'value')
                            case 1
                                epsa = str2double(get(handles.editpermielementa,'string'));
                            case 2
                                epsa = 1 - fp^2/(frek*(frek+1i*G));
                            case 3
                                epsa = 1 - (fp^2/(frek^2+G^2))^2;
                            case 4
                                epsa = spline(wave,epsR,s) + 1i*spline(wave,epsI,s);
                        end
                        switch get(handles.popupperme,'value')
                            case 1
                                mua = str2double(get(handles.editpermeelementa,'string'));
                            case 2
                                mua = 1 - F*frek^2/(frek^2 - f0^2);
                            case 3
                                mua = spline(wave,muR,s) + 1i*spline(wave,muI,s);
                        end
                        
                        [A,R,T] = SoTE(NF,periodx,s,fi,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        X(i,1) = s;
                        R1(i,:) = R;
                        T1(i,:) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                elseif psio == 90
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        frek = 299792458/s;     %%%   ak je lambda v nm a frekvencia v GHz
                        switch get(handles.popuppermi,'value')
                            case 1
                                epsa = str2double(get(handles.editpermielementa,'string'));
                            case 2
                                epsa = 1 - fp^2/(frek*(frek+1i*G));
                            case 3
                                epsa = 1 - (fp^2/(frek^2+G^2))^2;
                            case 4
                                epsa = spline(wave,epsR,s) + 1i*spline(wave,epsI,s);
                        end
                        switch get(handles.popupperme,'value')
                            case 1
                                mua = str2double(get(handles.editpermeelementa,'string'));
                            case 2
                                mua = 1 - F*frek^2/(frek^2 - f0^2);
                            case 3
                                mua = spline(wave,muR,s) + 1i*spline(wave,muI,s);
                        end
                        
                        [A,R,T] = SoTM(NF,periodx,s,fi,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        X(i,1) = s;
                        R1(i,:) = R;
                        T1(i,:) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                else
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        
                        i = i+1;
                        
                        frek = 299792458/s;     %%%   ak je lambda v nm a frekvencia v GHz
                        switch get(handles.popuppermi,'value')
                            case 1
                                epsa = str2double(get(handles.editpermielementa,'string'));
                            case 2
                                epsa = 1 - fp^2/(frek*(frek+1i*G));
                            case 3
                                epsa = 1 - (fp^2/(frek^2+G^2))^2;
                            case 4
                                epsa = spline(wave,epsR,s) + 1i*spline(wave,epsI,s);
                        end
                        switch get(handles.popupperme,'value')
                            case 1
                                mua = str2double(get(handles.editpermeelementa,'string'));
                            case 2
                                mua = 1 - F*frek^2/(frek^2 - f0^2);
                            case 3
                                mua = spline(wave,muR,s) + 1i*spline(wave,muI,s);
                        end
                        
                        [Ate,Rte,Tte] = SoTE(NF,periodx,s,fi,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        [Atm,Rtm,Ttm] = SoTM(NF,periodx,s,fi,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        A =Ate*(cos(psi))^2 + Atm*(sin(psi))^2;
                        R = Rte*(cos(psi))^2 + Rtm*(sin(psi))^2;
                        T = Tte*(cos(psi))^2 + Ttm*(sin(psi))^2;
                        X(i,1) = s;
                        R1(i,:) = R;
                        T1(i,:) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                end
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R1(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T1(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Wavelength [a. u.]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Number of modes' %% Number of modes :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                if psio == 0
                    
                    for s = from:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        [A,R,T] = SoTE(s,periodx,lambda,fi,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        X(i,1) = s;
                        R0(i,1) = R(orderxo+1+s);
                        T0(i,1) = T(orderxo+1+s);
                        A0(i,1) = 1-A;
                        
                    end
                    
                elseif psio == 90
                    
                    for s = from:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        [A,R,T] = SoTM(s,periodx,lambda,fi,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        X(i,1) = s;
                        R0(i,1) = R(orderxo+1+s);
                        T0(i,1) = T(orderxo+1+s);
                        A0(i,1) = 1-A;
                        
                    end
                    
                else
                    
                    for s = from:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        
                        i = i+1;
                        
                        [Ate,Rte,Tte] = SoTE(s,periodx,lambda,fi,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        [Atm,Rtm,Ttm] = SoTM(s,periodx,lambda,fi,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        A =Ate*(cos(psi))^2 + Atm*(sin(psi))^2;
                        R = Rte*(cos(psi))^2 + Rtm*(sin(psi))^2;
                        T = Tte*(cos(psi))^2 + Ttm*(sin(psi))^2;
                        X(i,1) = s;
                        R0(i,1) = R(orderxo+s+1);
                        T0(i,1) = T(orderxo+1+s);
                        A0(i,1) = 1-A;
                        
                    end
                    
                end
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R0,'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R0],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T0,'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T0],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Number of modes');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Angle of polarization'   %%   Angle of polarization ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    
                    i = i+1;
                    
                    [Ate,Rte,Tte] = SoTE(NF,periodx,lambda,fi,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                    [Atm,Rtm,Ttm] = SoTM(NF,periodx,lambda,fi,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                    A =Ate*(cos(degtorad(s)))^2 + Atm*(sin(degtorad(s)))^2;
                    R = Rte*(cos(degtorad(s)))^2 + Rtm*(sin(degtorad(s)))^2;
                    T = Tte*(cos(degtorad(s)))^2 + Ttm*(sin(degtorad(s)))^2;
                    X(i,1) = s;
                    R1(i,:) = R;
                    T1(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R1(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T1(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Angle of polarization [degree]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Angle of incidence'   %% Angle of incidence ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                if psio == 0
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        [A,R,T] = SoTE(NF,periodx,lambda,degtorad(s),eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        X(i,1) = s;
                        R1(i,:) = R;
                        T1(i,:) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                elseif psio == 90
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        [A,R,T] = SoTM(NF,periodx,lambda,degtorad(s),eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        X(i,1) = s;
                        R1(i,:) = R;
                        T1(i,:) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                else
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        
                        i = i+1;
                        
                        [Ate,Rte,Tte] = SoTE(NF,periodx,lambda,degtorad(s),eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        [Atm,Rtm,Ttm] = SoTM(NF,periodx,lambda,degtorad(s),eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        A =Ate*(cos(psi))^2 + Atm*(sin(psi))^2;
                        R = Rte*(cos(psi))^2 + Rtm*(sin(psi))^2;
                        T = Tte*(cos(psi))^2 + Ttm*(sin(psi))^2;
                        X(i,1) = s;
                        R1(i,:) = R;
                        T1(i,:) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                end
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R1(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T1(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Angle of incidence [degree]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Filling factor A'  %% Filling faktor :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                if psio == 0
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        [A,R,T] = SoTE(NF,periodx,lambda,fi,eps1,mu1,d1,s,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        X(i,1) = s;
                        R1(i,:) = R;
                        T1(i,:) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                elseif psio == 90
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        [A,R,T] = SoTM(NF,periodx,lambda,fi,eps1,mu1,d1,s,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        X(i,1) = s;
                        R1(i,:) = R;
                        T1(i,:) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                else
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        
                        i = i+1;
                        
                        [Ate,Rte,Tte] = SoTE(NF,periodx,lambda,fi,eps1,mu1,d1,s,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        [Atm,Rtm,Ttm] = SoTM(NF,periodx,lambda,fi,eps1,mu1,d1,s,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        A =Ate*(cos(psi))^2 + Atm*(sin(psi))^2;
                        R = Rte*(cos(psi))^2 + Rtm*(sin(psi))^2;
                        T = Tte*(cos(psi))^2 + Ttm*(sin(psi))^2;
                        X(i,1) = s;
                        R1(i,:) = R;
                        T1(i,:) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                end
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R1(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T1(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Filling factor');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Thickness of Layer 1'    %%  Layer 1 thickness ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                if psio == 0
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        [A,R,T] = SoTE(NF,periodx,lambda,fi,eps1,mu1,s,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        X(i,1) = s;
                        R1(i,:) = R;
                        T1(i,:) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                elseif psio == 90
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        [A,R,T] = SoTM(NF,periodx,lambda,fi,eps1,mu1,s,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        X(i,1) = s;
                        R1(i,:) = R;
                        T1(i,:) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                else
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        
                        i = i+1;
                        
                        [Ate,Rte,Tte] = SoTE(NF,periodx,lambda,fi,eps1,mu1,s,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        [Atm,Rtm,Ttm] = SoTM(NF,periodx,lambda,fi,eps1,mu1,d1,s,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                        A =Ate*(cos(psi))^2 + Atm*(sin(psi))^2;
                        R = Rte*(cos(psi))^2 + Rtm*(sin(psi))^2;
                        T = Tte*(cos(psi))^2 + Ttm*(sin(psi))^2;
                        X(i,1) = s;
                        R1(i,:) = R;
                        T1(i,:) = T;
                        A0(i,1) = 1-A;
                        
                    end
                    
                end
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R1(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T1(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Thickness of layer 1 [a. u.]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Frequency vs. angle of inc.' %%   Frequency vs. inc. :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                R0 = zeros(points,91);
                T0 = zeros(points,91);
                A0 = zeros(points,91);
                X = zeros(points,1);
                
                if psio == 0
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        frek = 299792458*s/periodx;     %%%   ak je lambda v nm a frekvencia v GHz
                        switch get(handles.popuppermi,'value')
                            case 1
                                epsa = str2double(get(handles.editpermielementa,'string'));
                            case 2
                                epsa = 1 - fp^2/(frek*(frek+1i*G));
                            case 3
                                epsa = 1 - (fp^2/(frek^2+G^2))^2;
                            case 4
                                epsa = spline(wave,epsR,periodx/s) + 1i*spline(wave,epsI,periodx/s);
                        end
                        switch get(handles.popupperme,'value')
                            case 1
                                mua = str2double(get(handles.editpermeelementa,'string'));
                            case 2
                                mua = 1 - F*frek^2/(frek^2 - f0^2);
                            case 3
                                mua = spline(wave,muR,periodx/s) + 1i*spline(wave,muI,periodx/s);
                        end
                        
                        j = 1;
                        for t = 0:0.999999:90       %%% angle loop
                            
                            [A,R,T] = SoTE(NF,periodx,periodx/s,t*pi/180,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                            X(i,1) = s;
                            R0(i,j) = R(orderx);
                            T0(i,j) = T(orderx);
                            A0(i,j) = 1-A;
                            j = j+1;
                        end
                        
                    end
                    
                elseif psio == 90
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        frek = 299792458*s/periodx;     %%%   ak je lambda v nm a frekvencia v GHz
                        switch get(handles.popuppermi,'value')
                            case 1
                                epsa = str2double(get(handles.editpermielementa,'string'));
                            case 2
                                epsa = 1 - fp^2/(frek*(frek+1i*G));
                            case 3
                                epsa = 1 - (fp^2/(frek^2+G^2))^2;
                            case 4
                                epsa = spline(wave,epsR,periodx/s) + 1i*spline(wave,epsI,periodx/s);
                        end
                        switch get(handles.popupperme,'value')
                            case 1
                                mua = str2double(get(handles.editpermeelementa,'string'));
                            case 2
                                mua = 1 - F*frek^2/(frek^2 - f0^2);
                            case 3
                                mua = spline(wave,muR,periodx/s) + 1i*spline(wave,muI,periodx/s);
                        end
                        
                        j = 1;
                        for t = 0:0.999999:90       %%% angle loop
                            
                            [A,R,T] = SoTM(NF,periodx,periodx/s,t*pi/180,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                            X(i,1) = s;
                            R0(i,j) = R(orderx);
                            T0(i,j) = T(orderx);
                            A0(i,j) = 1-A;
                            j = j+1;
                        end
                        
                    end
                    
                else
                    
                    for s = from:(to-from)/points:to
                        
                        if getappdata(hwait,'canceling')
                            set(hObject,'enable','on');
                            break
                        end
                        waitbar(i/points,hwait);
                        i = i+1;
                        
                        frek = 299792458*s/periodx;    %%%   ak je lambda v nm a frekvencia v GHz
                        switch get(handles.popuppermi,'value')
                            case 1
                                epsa = str2double(get(handles.editpermielementa,'string'));
                            case 2
                                epsa = 1 - fp^2/(frek*(frek+1i*G));
                            case 3
                                epsa = 1 - (fp^2/(frek^2+G^2))^2;
                            case 4
                                epsa = spline(wave,epsR,periodx/s) + 1i*spline(wave,epsI,periodx/s);
                        end
                        switch get(handles.popupperme,'value')
                            case 1
                                mua = str2double(get(handles.editpermeelementa,'string'));
                            case 2
                                mua = 1 - F*frek^2/(frek^2 - f0^2);
                            case 3
                                mua = spline(wave,muR,periodx/s) + 1i*spline(wave,muI,periodx/s);
                        end
                        
                        j = 1;
                        for t = 0:0.999999:90       %%% angle loop
                            
                            [Ate,Rte,Tte] = SoTE(NF,periodx,periodx/s,t*pi/180,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                            [Atm,Rtm,Ttm] = SoTM(NF,periodx,periodx/s,t*pi/180,eps1,mu1,d1,fillax,epsb,epsa,mub,mua,d2,epsl2,mul2,eps2,mu2,reps1,reps2,def);
                            A =Ate*(cos(psi))^2 + Atm*(sin(psi))^2;
                            R = Rte*(cos(psi))^2 + Rtm*(sin(psi))^2;
                            T = Tte*(cos(psi))^2 + Ttm*(sin(psi))^2;
                            
                            X(i,1) = s;
                            R0(i,j) = R(orderx);
                            T0(i,j) = T(orderx);
                            A0(i,j) = 1-A;
                            j = j+1;
                        end
                        
                    end
                    
                end
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    [~,n] = contourf(0:0.999999:90,X,R0,300);
                    set(n, 'LineStyle', 'none');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],R0,'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    [~,n] = contourf(0:0.999999:90,X,T0,300);
                    set(n, 'LineStyle', 'none');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],T0,'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    [~,n] = contourf(0:0.999999:90,X,A0,300);
                    set(n, 'LineStyle', 'none');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],A0,'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Angle of incidence [deg]');
                ylabel('Normalized frequency');
                colormap pink;
                colorbar;
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            otherwise
                set(handles.textoutput,'string','Selected variable is not applicable, please choose a different versus.');
                delete(hwait);
        end
        
    case 3   %%%   1D CONICAL ====================================================================
        R1 = zeros(points,2*NF+1);
        T1 = zeros(points,2*NF+1);
        A0 = zeros(points,1);
        R0 = zeros(points,1);
        T0 = zeros(points,1);
        X = zeros(points,1);
        
        switch versusstring{get(handles.popupversus,'value')}
            
            case 'Single value'   %% Single ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                
                [A,R,T] = Scon(NF,periodx,lambda,fi,psi,tet,d1,fillax,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                
                
                if get(handles.checkrefl,'value')==1
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],R(1,orderx),'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],T(1,orderx),'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],1-A,'delimiter','\t','precision',12);
                    end
                end
                delete(hwait);
                
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{['R_0 = ' num2str(R(NF+1))];['T_0 = ' num2str(T(NF+1))];['A = ' num2str(1-A) '       Results of all orders are automatically saved to file ' get(handles.editoutput,'string')]})
                else
                    set(handles.textoutput,'string',{['R_0 = ' num2str(R(NF+1))];['T_0 = ' num2str(T(NF+1))];['A = ' num2str(1-A) '       Automatic saves are available in the full version only.']})
                end
                
            case 'Normalized frequency'    %% Normalized frequency ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    i = i+1;
                    
                    frek = 299792458*s/periodx;     %%%   ak je lambda v nm a frekvencia v GHz
                    switch get(handles.popuppermi,'value')
                        case 1
                            epsa = str2double(get(handles.editpermielementa,'string'));
                        case 2
                            epsa = 1 - fp^2/(frek*(frek+1i*G));
                        case 3
                            epsa = 1 - (fp^2/(frek^2+G^2))^2;
                        case 4
                            epsa = spline(wave,epsR,periodx/s) + 1i*spline(wave,epsI,periodx/s);
                    end
                    switch get(handles.popupperme,'value')
                        case 1
                            mua = str2double(get(handles.editpermeelementa,'string'));
                        case 2
                            mua = 1 - F*frek^2/(frek^2 - f0^2);
                        case 3
                            mua = spline(wave,muR,periodx/s) + 1i*spline(wave,muI,periodx/s);
                    end
                    
                    [A,R,T] = Scon(NF,periodx,periodx/s,fi,psi,tet,d1,fillax,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R1(i,:) = R;
                    T1(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R1(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T1(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Period / Wavelength');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Wavelength'   %% Wavelength :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    i = i+1;
                    
                    frek = 299792458/s;     %%%   ak je lambda v nm a frekvencia v GHz
                    switch get(handles.popuppermi,'value')
                        case 1
                            epsa = str2double(get(handles.editpermielementa,'string'));
                        case 2
                            epsa = 1 - fp^2/(frek*(frek+1i*G));
                        case 3
                            epsa = 1 - (fp^2/(frek^2+G^2))^2;
                        case 4
                            epsa = spline(wave,epsR,s) + 1i*spline(wave,epsI,s);
                    end
                    switch get(handles.popupperme,'value')
                        case 1
                            mua = str2double(get(handles.editpermeelementa,'string'));
                        case 2
                            mua = 1 - F*frek^2/(frek^2 - f0^2);
                        case 3
                            mua = spline(wave,muR,s) + 1i*spline(wave,muI,s);
                    end
                    
                    [A,R,T] = Scon(NF,periodx,s,fi,psi,tet,d1,fillax,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R1(i,:) = R;
                    T1(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R1(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T1(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Wavelength [a. u.]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Number of modes' %% Number of modes :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                
                for s = from:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    i = i+1;
                    
                    [A,R,T] = Scon(s,periodx,lambda,fi,psi,tet,d1,fillax,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R0(i,1) = R(orderxo+1+s);
                    T0(i,1) = T(orderxo+1+s);
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R0,'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R0],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T0,'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T0],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Number of modes');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Angle of polarization'   %%   Angle of polarization ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    
                    i = i+1;
                    
                    [A,R,T] = Scon(NF,periodx,lambda,fi,s*pi/180,tet,d1,fillax,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    
                    X(i,1) = s;
                    R1(i,:) = R;
                    T1(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R1(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T1(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Angle of polarization [degree]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Angle of incidence'   %% Angle of incidence ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    i = i+1;
                    
                    [A,R,T] = Scon(NF,periodx,lambda,degtorad(s),psi,tet,d1,fillax,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R1(i,:) = R;
                    T1(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R1(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T1(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Angle of incidence [degree]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Angle of plane of inc.'  %% Angle of plane of inc. :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    i = i+1;
                    
                    [A,R,T] = Scon(NF,periodx,lambda,fi,psi,degtorad(s),d1,fillax,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R1(i,:) = R;
                    T1(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R1(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T1(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Angle of plane of incidence [degree]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Filling factor A'  %% Filling faktor :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    i = i+1;
                    
                    [A,R,T] = Scon(NF,periodx,lambda,fi,psi,tet,d1,s,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R1(i,:) = R;
                    T1(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R1(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T1(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Filling factor');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Thickness of Layer 1'    %%  Layer 1 thickness ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    i = i+1;
                    
                    [A,R,T] = Scon(NF,periodx,lambda,fi,psi,tet,s,fillax,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R1(i,:) = R;
                    T1(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R1(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T1(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Thickness of layer 1 [a. u.]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            otherwise
                set(handles.textoutput,'string','Selected variable is not applicable, please choose a different versus.');
                delete(hwait);
        end
        
    case 4   %%%   2D ONE ROD ===================================================================
        R2 = zeros(points,(2*NF+1)^2);
        T2 = zeros(points,(2*NF+1)^2);
        A0 = zeros(points,1);
        R0 = zeros(points,1);
        T0 = zeros(points,1);
        X = zeros(points,1);
        
        switch versusstring{get(handles.popupversus,'value')}
            
            case 'Single value'   %% Single ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                [A, R, T] = Doub(NF,periodx,periody,lambda,fi,psi,tet,d1,fillax,fillay,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                
                if get(handles.checkrefl,'value')==1
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],R(1,orderx),'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],T(1,orderx),'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],1-A,'delimiter','\t','precision',12);
                    end
                end
                delete(hwait);
                
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{['R_0 = ' num2str(R((NF+1)^2 + NF^2))];['T_0 = ' num2str(T((NF+1)^2 + NF^2))];['A = ' num2str(1-A) '       Results of all orders are automatically saved to file ' get(handles.editoutput,'string')]})
                else
                    set(handles.textoutput,'string',{['R_0 = ' num2str(R((NF+1)^2 + NF^2))];['T_0 = ' num2str(T((NF+1)^2 + NF^2))];['A = ' num2str(1-A) '       Automatic saves are available in the full version only.']})
                end
                
            case 'Normalized frequency'    %% Normalized frequency ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    i = i+1;
                    
                    frek = 299792458*s/periodx;     %%%   ak je lambda v nm a frekvencia v GHz
                    switch get(handles.popuppermi,'value')
                        case 1
                            epsa = str2double(get(handles.editpermielementa,'string'));
                        case 2
                            epsa = 1 - fp^2/(frek*(frek+1i*G));
                        case 3
                            epsa = 1 - (fp^2/(frek^2+G^2))^2;
                        case 4
                            epsa = spline(wave,epsR,periodx/s) + 1i*spline(wave,epsI,periodx/s);
                    end
                    switch get(handles.popupperme,'value')
                        case 1
                            mua = str2double(get(handles.editpermeelementa,'string'));
                        case 2
                            mua = 1 - F*frek^2/(frek^2 - f0^2);
                        case 3
                            mua = spline(wave,muR,periodx/s) + 1i*spline(wave,muI,periodx/s);
                    end
                    
                    [A, R, T] = Doub(NF,periodx,periody,periodx/s,fi,psi,tet,d1,fillax,fillay,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R2(i,:) = R;
                    T2(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R2(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T2(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Period X / Wavelength');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Wavelength'   %% Wavelength :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    i = i+1;
                    
                    frek = 299792458/s;     %%%   ak je lambda v nm a frekvencia v GHz
                    switch get(handles.popuppermi,'value')
                        case 1
                            epsa = str2double(get(handles.editpermielementa,'string'));
                        case 2
                            epsa = 1 - fp^2/(frek*(frek+1i*G));
                        case 3
                            epsa = 1 - (fp^2/(frek^2+G^2))^2;
                        case 4
                            epsa = spline(wave,epsR,s) + 1i*spline(wave,epsI,s);
                    end
                    switch get(handles.popupperme,'value')
                        case 1
                            mua = str2double(get(handles.editpermeelementa,'string'));
                        case 2
                            mua = 1 - F*frek^2/(frek^2 - f0^2);
                        case 3
                            mua = spline(wave,muR,s) + 1i*spline(wave,muI,s);
                    end
                    
                    [A, R, T] = Doub(NF,periodx,periody,s,fi,psi,tet,d1,fillax,fillay,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R2(i,:) = R;
                    T2(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R2(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T2(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Wavelength [a. u.]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Number of modes' %% Number of modes :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                
                for s = from:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    i = i+1;
                    
                    [A, R, T] = Doub(s,periodx,periody,lambda,fi,psi,tet,d1,fillax,fillay,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R0(i,1) = R((2*s+1)*(orderxo+s) + orderyo + s +1);
                    T0(i,1) = T((2*s+1)*(orderxo+s) + orderyo + s+1);
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R0,'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R0],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T0,'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T0],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Number of modes');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Angle of polarization'   %%   Angle of polarization ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    
                    i = i+1;
                    
                    [A, R, T] = Doub(NF,periodx,periody,lambda,fi,degtorad(s),tet,d1,fillax,fillay,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R2(i,:) = R;
                    T2(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R2(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T2(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Angle of polarization [degree]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Angle of incidence'   %% Angle of incidence ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    
                    i = i+1;
                    
                    [A, R, T] = Doub(NF,periodx,periody,lambda,degtorad(s),psi,tet,d1,fillax,fillay,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R2(i,:) = R;
                    T2(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R2(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T2(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Angle of incidence [degree]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Angle of plane of inc.' %%% Mount angle ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    
                    i = i+1;
                    
                    [A, R, T] = Doub(NF,periodx,periody,lambda,fi,psi,degtorad(s),d1,fillax,fillay,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R2(i,:) = R;
                    T2(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R2(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T2(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Angle of plane of incidence [degree]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Filling factor A'  %% Filling faktor :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    
                    i = i+1;
                    
                    [A, R, T] = Doub(NF,periodx,periody,lambda,fi,psi,tet,d1,s,s,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R2(i,:) = R;
                    T2(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R2(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T2(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Filling factor A');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Thickness of Layer 1'    %%  Layer 1 thickness ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    
                    i = i+1;
                    
                    [A, R, T] = Doub(NF,periodx,periody,lambda,fi,psi,tet,s,fillax,fillay,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R2(i,:) = R;
                    T2(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R2(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T2(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Thickness of Layer 1');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Frequency vs. angle of inc.'   %% Frequancy vs. inc. angle ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                R0 = zeros(points,91);
                T0 = zeros(points,91);
                A0 = zeros(points,91);
                X = zeros(points,1);
                
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    i = i+1;
                    
                    frek = 299792458*s/periodx;     %%%   ak je lambda v nm a frekvencia v GHz
                    switch get(handles.popuppermi,'value')
                        case 1
                            epsa = str2double(get(handles.editpermielementa,'string'));
                        case 2
                            epsa = 1 - fp^2/(frek*(frek+1i*G));
                        case 3
                            epsa = 1 - (fp^2/(frek^2+G^2))^2;
                        case 4
                            epsa = spline(wave,epsR,periodx/s) + 1i*spline(wave,epsI,periodx/s);
                    end
                    switch get(handles.popupperme,'value')
                        case 1
                            mua = str2double(get(handles.editpermeelementa,'string'));
                        case 2
                            mua = 1 - F*frek^2/(frek^2 - f0^2);
                        case 3
                            mua = spline(wave,muR,s) + 1i*spline(wave,muI,s);
                    end
                    
                    j = 1;
                    for t = 0:0.999999:90       %%% angle loop
                        
                        [A,R,T] =  Doub(NF,periodx,periody,periodx/s,t*pi/180,psi,tet,d1,fillax,fillay,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                        X(i,1) = s;
                        R0(i,j) = R(orderx);
                        T0(i,j) = T(orderx);
                        A0(i,j) = 1-A;
                        j = j+1;
                    end
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    [~,n] = contourf(0:0.999999:90,X,R0,300);
                    set(n, 'LineStyle', 'none');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],R0,'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    [~,n] = contourf(0:0.999999:90,X,T0,300);
                    set(n, 'LineStyle', 'none');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],T0,'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    [~,n] = contourf(0:0.999999:90,X,A0,300);
                    set(n, 'LineStyle', 'none');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],A0,'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Angle of incidence [deg]');
                ylabel('Normalized frequency');
                colormap pink;
                colorbar;
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            otherwise
                set(handles.textoutput,'string','Selected variable is not applicable, please choose a different versus.');
                delete(hwait);
        end
        
    case 5   %%%   2D TWO RODS ==================================================================
        R2 = zeros(points,(2*NF+1)^2);
        T2 = zeros(points,(2*NF+1)^2);
        A0 = zeros(points,1);
        R0 = zeros(points,1);
        T0 = zeros(points,1);
        X = zeros(points,1);
        
        switch versusstring{get(handles.popupversus,'value')}
            
            case 'Single value'   %% Single ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                [A, R, T] = DHex(NF,periodx,periody,lambda,fi,psi,tet,d1,fillax,fillay,fillaax,fillaay,posax,posay,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                
                if get(handles.checkrefl,'value')==1
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],R(1,orderx),'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],T(1,orderx),'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],1-A,'delimiter','\t','precision',12);
                    end
                end
                delete(hwait);
                
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{['R_0 = ' num2str(R((NF+1)^2 + NF^2))];['T_0 = ' num2str(T((NF+1)^2 + NF^2))];['A = ' num2str(1-A) '       Results of all orders are automatically saved to file ' get(handles.editoutput,'string')]})
                else
                    set(handles.textoutput,'string',{['R_0 = ' num2str(R((NF+1)^2 + NF^2))];['T_0 = ' num2str(T((NF+1)^2 + NF^2))];['A = ' num2str(1-A) '       Automatic saves are available in the full version only.']})
                end
                
            case 'Normalized frequency'    %% Normalized frequency ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    i = i+1;
                    
                    frek = 299792458*s/periodx;     %%%   ak je lambda v nm a frekvencia v GHz
                    switch get(handles.popuppermi,'value')
                        case 1
                            epsa = str2double(get(handles.editpermielementa,'string'));
                        case 2
                            epsa = 1 - fp^2/(frek*(frek+1i*G));
                        case 3
                            epsa = 1 - (fp^2/(frek^2+G^2))^2;
                        case 4
                            epsa = spline(wave,epsR,periodx/s) + 1i*spline(wave,epsI,periodx/s);
                    end
                    switch get(handles.popupperme,'value')
                        case 1
                            mua = str2double(get(handles.editpermeelementa,'string'));
                        case 2
                            mua = 1 - F*frek^2/(frek^2 - f0^2);
                        case 3
                            mua = spline(wave,muR,periodx/s) + 1i*spline(wave,muI,periodx/s);
                    end
                    
                    [A, R, T] = DHex(NF,periodx,periody,periodx/s,fi,psi,tet,d1,fillax,fillay,fillaax,fillaay,posax,posay,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R2(i,:) = R;
                    T2(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R2(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T2(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Period X / Wavelength');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Wavelength'   %% Wavelength :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    i = i+1;
                    
                    frek = 299792458/s;     %%%   ak je lambda v nm a frekvencia v GHz
                    switch get(handles.popuppermi,'value')
                        case 1
                            epsa = str2double(get(handles.editpermielementa,'string'));
                        case 2
                            epsa = 1 - fp^2/(frek*(frek+1i*G));
                        case 3
                            epsa = 1 - (fp^2/(frek^2+G^2))^2;
                    end
                    switch get(handles.popupperme,'value')
                        case 1
                            mua = str2double(get(handles.editpermeelementa,'string'));
                        case 2
                            mua = 1 - F*frek^2/(frek^2 - f0^2);
                        case 3
                            mua = spline(wave,muR,s) + 1i*spline(wave,muI,s);
                    end
                    
                    [A, R, T] = DHex(NF,periodx,periody,s,fi,psi,tet,d1,fillax,fillay,fillaax,fillaay,posax,posay,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R2(i,:) = R;
                    T2(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R2(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T2(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Wavelength [a. u.]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Number of modes' %% Number of modes :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                
                for s = from:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    i = i+1;
                    
                    [A, R, T] = DHex(s,periodx,periody,lambda,fi,psi,tet,d1,fillax,fillay,fillaax,fillaay,posax,posay,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R0(i,1) = R((2*s+1)*(orderxo+s) + orderyo + s + 1);
                    T0(i,1) = T((2*s+1)*(orderxo+s) + orderyo + s+1);
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R0,'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R0],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T0,'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T0],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Number of modes');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Angle of polarization'   %%   Angle of polarization ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    
                    i = i+1;
                    
                    [A, R, T] = DHex(NF,periodx,periody,lambda,fi,degtorad(s),tet,d1,fillax,fillay,fillaax,fillaay,posax,posay,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R2(i,:) = R;
                    T2(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R2(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T2(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Angle of polarization [degree]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Angle of incidence'   %% Angle of incidence ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    
                    i = i+1;
                    
                    [A, R, T] = DHex(NF,periodx,periody,lambda,degtorad(s),psi,tet,d1,fillax,fillay,fillaax,fillaay,posax,posay,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R2(i,:) = R;
                    T2(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R2(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T2(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Angle of incidence [degree]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Angle of plane of inc.' %%% Mount angle ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    
                    i = i+1;
                    
                    [A, R, T] = DHex(NF,periodx,periody,lambda,fi,psi,degtorad(s),d1,fillax,fillay,fillaax,fillaay,posax,posay,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R2(i,:) = R;
                    T2(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R2(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T2(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Angle of plane of incidence [degree]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Filling factors'  %% Filling faktor :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    
                    i = i+1;
                    
                    [A, R, T] = DHex(NF,periodx,periody,lambda,fi,psi,tet,d1,s,s,s,s,posax,posay,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R2(i,:) = R;
                    T2(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R2(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T2(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Filling factor A');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Thickness of Layer 1'    %%  Layer 1 thickness ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    
                    i = i+1;
                    
                    [A, R, T] = DHex(NF,periodx,periody,lambda,fi,psi,tet,s,fillax,fillay,fillaax,fillaay,posax,posay,eps1,epsb,epsa,eps2,mu1,mub,mua,mu2,epsl2,mul2,d2,reps1);
                    X(i,1) = s;
                    R2(i,:) = R;
                    T2(i,:) = T;
                    A0(i,1) = 1-A;
                    
                end
                
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R2(:,orderx),'DisplayName','Reflectance');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T2(:,orderx),'DisplayName','Transmittance');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T2(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Thickness of Layer 1');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            otherwise
                set(handles.textoutput,'string','Selected variable is not applicable, please choose a different versus.');
                delete(hwait);
        end
        
    case 6   %%%   Anizotropic  ====================================================================
        X = zeros(points,1);
        R1 = zeros(points,2*NF+1);
        T1 = zeros(points,2*NF+1);
        Rte1 = zeros(points,2*NF+1);
        Tte1 = zeros(points,2*NF+1);
        Rtm1 = zeros(points,2*NF+1);
        Ttm1 = zeros(points,2*NF+1);
        A0 = zeros(points,1);
        R0 = zeros(points,1);
        T0 = zeros(points,1);
        Exx = zeros(2*NF+1,2*NF+1,reps1);
        Exy = zeros(2*NF+1,2*NF+1,reps1);
        Eyy = zeros(2*NF+1,2*NF+1,reps1);
        
        switch versusstring{get(handles.popupversus,'value')}
            
            case 'Single value'
                
                Exx = outEA(epsxx,epsxxm,epsxx2,fillax,mrods,NF);
                Exy = outEA(epsxy,epsxym,epsxy2,fillax,mrods,NF);
                Eyy = outEA(epsyy,epsyym,epsyy2,fillax,mrods,NF);
                
                [A, R, T, RTE, RTM, TTE, TTM] = AnizE(NF,periodx,lambda,fi,psi,d1,mrods,d2,reps1,Exx,Exy,Eyy,epszz);
                
                if get(handles.checkrefl,'value')==1
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[R(1,orderx) RTE(1,orderx) RTM(1,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[T(1,orderx) TTE(1,orderx) TTM(1,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],1-A,'delimiter','\t','precision',12);
                    end
                end
                delete(hwait);
                
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{['R_0 = ' num2str(R(NF+1)) '   Rte_0 = ' num2str(RTE(NF+1)) '   Rtm_0 = ' num2str(RTM(NF+1))];['T_0 = ' num2str(T(NF+1)) '   Tte_0 = ' num2str(TTE(NF+1)) '   Ttm_0 = ' num2str(TTM(NF+1))];['A = ' num2str(1-A) '       Results of all orders are automatically saved to file ' get(handles.editoutput,'string')]})
                else
                    set(handles.textoutput,'string',{['R_0 = ' num2str(R(NF+1)) '   Rte_0 = ' num2str(RTE(NF+1)) '   Rtm_0 = ' num2str(RTM(NF+1))];['T_0 = ' num2str(T(NF+1)) '   Tte_0 = ' num2str(TTE(NF+1)) '   Ttm_0 = ' num2str(TTM(NF+1))];['A = ' num2str(1-A) '       Automatic saves are available in the full version only.']})
                end
                
            case 'Normalized frequency'
                
                for j = 1:reps1
                    Exx(:,:,j) = outEA(epsxx,epsxxm,epsxx2,fillax,mrods,NF);
                end
                for j = 1:reps1
                    Exy(:,:,j) = outEA(epsxy,epsxym,epsxy2,fillax,mrods,NF);
                end
                for j = 1:reps1
                    Eyy(:,:,j) = outEA(epsyy,epsyym,epsyy2,fillax,mrods,NF);
                end
                
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    i = i+1;
                    
                    [A, R, T, RTE, RTM, TTE, TTM] = AnizE(NF,periodx,periodx/s,fi,psi,d1,mrods,d2,reps1,Exx,Exy,Eyy,epszz);
                    X(i,1) = s;
                    R1(i,:) = R;
                    T1(i,:) = T;
                    Rte1(i,:) = RTE;
                    Tte1(i,:) = TTE;
                    Rtm1(i,:) = RTM;
                    Ttm1(i,:) = TTM;
                    A0(i,1) = 1-A;
                    
                end
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R1(:,orderx),'DisplayName','Reflectance TE+TM');
                    plot(X,Rte1(:,orderx),'DisplayName','Reflectance TE');
                    plot(X,Rtm1(:,orderx),'DisplayName','Reflectance TM');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R1(:,orderx) Rte1(:,orderx) Rtm1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T1(:,orderx),'DisplayName','Transmittance TE+TM');
                    plot(X,Tte1(:,orderx),'DisplayName','Transmittance TE');
                    plot(X,Ttm1(:,orderx),'DisplayName','Transmittance TM');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T1(:,orderx) Tte1(:,orderx) Ttm1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Period / Wavelength');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Wavelength'
                
                for j = 1:reps1
                    Exx(:,:,j) = outEA(epsxx,epsxxm,epsxx2,fillax,mrods,NF);
                end
                for j = 1:reps1
                    Exy(:,:,j) = outEA(epsxy,epsxym,epsxy2,fillax,mrods,NF);
                end
                for j = 1:reps1
                    Eyy(:,:,j) = outEA(epsyy,epsyym,epsyy2,fillax,mrods,NF);
                end
                
                for s = from:(to-from)/points:to
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    i = i+1;
                    
                    [A, R, T, RTE, RTM, TTE, TTM] = AnizE(NF,periodx,s,fi,psi,d1,mrods,d2,reps1,Exx,Exy,Eyy,epszz);
                    X(i,1) = s;
                    R1(i,:) = R;
                    T1(i,:) = T;
                    Rte1(i,:) = RTE;
                    Tte1(i,:) = TTE;
                    Rtm1(i,:) = RTM;
                    Ttm1(i,:) = TTM;
                    A0(i,1) = 1-A;
                    
                end
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R1(:,orderx),'DisplayName','Reflectance TE+TM');
                    plot(X,Rte1(:,orderx),'DisplayName','Reflectance TE');
                    plot(X,Rtm1(:,orderx),'DisplayName','Reflectance TM');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R1(:,orderx) Rte1(:,orderx) Rtm1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T1(:,orderx),'DisplayName','Transmittance TE+TM');
                    plot(X,Tte1(:,orderx),'DisplayName','Transmittance TE');
                    plot(X,Ttm1(:,orderx),'DisplayName','Transmittance TM');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T1(:,orderx) Tte1(:,orderx) Ttm1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Wavelength [a. u.]');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Different structures'
                
                for s = from:(to-from)/points:to
                    
                    for j = 1:reps1
                        Exx(:,:,j) = outEA(epsxx,epsxxm,epsxx2,fillax,mrods,NF);
                    end
                    for j = 1:reps1
                        Exy(:,:,j) = outEA(epsxy,epsxym,epsxy2,fillax,mrods,NF);
                    end
                    for j = 1:reps1
                        Eyy(:,:,j) = outEA(epsyy,epsyym,epsyy2,fillax,mrods,NF);
                    end
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    i = i+1;
                    
                    [A, R, T, RTE, RTM, TTE, TTM] = AnizE(NF,periodx,lambda,fi,psi,d1,mrods,d2,reps1,Exx,Exy,Eyy,epszz);
                    X(i,1) = s;
                    R1(i,:) = R;
                    T1(i,:) = T;
                    Rte1(i,:) = RTE;
                    Tte1(i,:) = TTE;
                    Rtm1(i,:) = RTM;
                    Ttm1(i,:) = TTM;
                    A0(i,1) = 1-A;
                    
                end
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R1(:,orderx),'DisplayName','Reflectance TE+TM');
                    plot(X,Rte1(:,orderx),'DisplayName','Reflectance TE');
                    plot(X,Rtm1(:,orderx),'DisplayName','Reflectance TM');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R1(:,orderx) Rte1(:,orderx) Rtm1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T1(:,orderx),'DisplayName','Transmittance TE+TM');
                    plot(X,Tte1(:,orderx),'DisplayName','Transmittance TE');
                    plot(X,Ttm1(:,orderx),'DisplayName','Transmittance TM');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T1(:,orderx) Tte1(:,orderx) Ttm1(:,orderx)],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Structures');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            case 'Number of modes'
                
                for s = from:to
                    
                    Exx = zeros(2*s+1,2*s+1,reps1);
                    Exy = zeros(2*s+1,2*s+1,reps1);
                    Eyy = zeros(2*s+1,2*s+1,reps1);
                    
                    for j = 1:reps1
                        Exx(:,:,j) = outEA(epsxx,epsxxm,epsxx2,fillax,mrods,s);
                    end
                    for j = 1:reps1
                        Exy(:,:,j) = outEA(epsxy,epsxym,epsxy2,fillax,mrods,s);
                    end
                    for j = 1:reps1
                        Eyy(:,:,j) = outEA(epsyy,epsyym,epsyy2,fillax,mrods,s);
                    end
                    
                    if getappdata(hwait,'canceling')
                        set(hObject,'enable','on');
                        break
                    end
                    waitbar(i/points,hwait);
                    i = i+1;
                    
                    [A, R, T, ~, ~, ~, ~] = AnizE(s,periodx,lambda,fi,psi,d1,mrods,d2,reps1,Exx,Exy,Eyy,epszz);
                    X(i,1) = s;
                    R0(i,1) = R(orderxo+1+s);
                    T0(i,1) = T(orderxo+1+s);
                    A0(i,1) = 1-A;
                    
                end
                delete(hwait);
                
                if get(handles.togglehold,'value') == 1
                    hold on
                else
                    figure
                    hold on
                end
                
                if get(handles.checkrefl,'value')==1
                    plot(X,R0,'DisplayName','Reflectance TE+TM');
                    if handles.fullversion == 1
                        dlmwrite(['Reflectance ' get(handles.editoutput,'string')],[X R0],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checktrans,'value')==1
                    plot(X,T0,'DisplayName','Transmittance TE+TM');
                    if handles.fullversion == 1
                        dlmwrite(['Transmittance ' get(handles.editoutput,'string')],[X T0],'delimiter','\t','precision',12);
                    end
                end
                if get(handles.checkabsorption,'value')==1
                    plot(X,A0,'DisplayName','Absorptance');
                    if handles.fullversion == 1
                        dlmwrite(['Absorptance ' get(handles.editoutput,'string')],[X A0],'delimiter','\t','precision',12);
                    end
                end
                
                xlabel('Number of modes');
                ylabel('Diffraction efficiency');
                legend('-DynamicLegend');
                if handles.fullversion == 1
                    set(handles.textoutput,'string',{'Calculation is finished.',['Results are automatically saved to file: ' get(handles.editoutput,'string')]});
                else
                    set(handles.textoutput,'string',{'Calculation is finished.','Automatic saves are available in the full version only.'});
                end
                
            otherwise
                set(handles.textoutput,'string','Selected variable is not applicable, please choose a different versus.');
                delete(hwait);
                
        end
        
    otherwise
        set(handles.textoutput,'string','Selected variable is not applicable, please choose a different grating structure.');
        delete(hwait);
        
end

toc
beep;
set(hObject,'enable','on');
if handles.fullversion == 0
    msgbox({'This is the free version of RawDog. Automatic saves do not work. Please consider a donation for the full version. :)';['Visit ' handles.web ' for more info.'];'';...
        ['This is your hardware identity: ' handles.hardwarekey];'';...
        'After you have donated, please send your hardware identity with your request for the full version to gregmaster777@gmail.com'},'RawDog Free','modal')
end

%%%%%%%%%%%%%%%%%%%%  MENU  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function menuload_ClickedCallback(~, ~, handles)

[filename,pathname] = uigetfile('*.txt','Load saved parameters');
if isequal(filename,0)
    set(handles.textoutput,'string','No parameters are loaded.');
    beep
else
    set(handles.textoutput,'string',['Parameters are loaded from file: ' filename]);
    parametersl = dlmread(fullfile(pathname,filename));
    
    set(handles.editwave,'string',parametersl(1,1));
    set(handles.editFourier,'string',parametersl(2,1));
    set(handles.radioTE,'value',parametersl(3,1));
    set(handles.radioTM,'value',parametersl(4,1));
    set(handles.editanglepol,'string',parametersl(5,1));
    set(handles.editanglei,'string',parametersl(6,1));
    set(handles.editanglemount,'string',parametersl(7,1));
    set(handles.editPeriodx,'string',parametersl(9,1));
    set(handles.editPeriody,'string',parametersl(10,1));
    set(handles.editFillAx,'string',parametersl(11,1));
    set(handles.editFillAy,'string',parametersl(12,1));
    set(handles.editFillAAx,'string',parametersl(13,1));
    set(handles.editFillAAy,'string',parametersl(14,1));
    set(handles.editPosAx,'string',parametersl(15,1));
    set(handles.editPosAy,'string',parametersl(16,1));
    set(handles.editpermisup,'string',parametersl(19,1));
    set(handles.editpermielementa,'string',parametersl(20,1));
    set(handles.editpermielementb,'string',parametersl(21,1));
    set(handles.editpermilayer2,'string',parametersl(22,1));
    set(handles.editpermisub,'string',parametersl(23,1));
    set(handles.editpermesup,'string',parametersl(24,1));
    set(handles.editpermeelementa,'string',parametersl(25,1));
    set(handles.editpermeelementb,'string',parametersl(26,1));
    set(handles.editpermelayer2,'string',parametersl(27,1));
    set(handles.editpermesub,'string',parametersl(28,1));
    set(handles.editReps,'string',parametersl(29,1));
    set(handles.editthick1,'string',parametersl(30,1));
    set(handles.editthick2,'string',parametersl(31,1));
    set(handles.editdefect,'string',parametersl(32,1));
    set(handles.editReps2,'string',parametersl(33,1));
    set(handles.editfrom,'string',parametersl(34,1));
    set(handles.editto,'string',parametersl(35,1));
    set(handles.editfp,'string',parametersl(36,1));
    set(handles.editG,'string',parametersl(37,1));
    set(handles.editf0,'string',parametersl(38,1));
    set(handles.editF,'string',parametersl(39,1));
    set(handles.checkrefl,'value',parametersl(41,1));
    set(handles.checktrans,'value',parametersl(42,1));
    set(handles.checkabsorption,'value',parametersl(43,1));
    set(handles.editpoints,'string',parametersl(45,1));
    set(handles.editorder,'string',parametersl(46,1));
    set(handles.editorder2,'string',parametersl(47,1));
    set(handles.editnumberofrods,'string',parametersl(48,1))
    set(handles.editepszz,'string',parametersl(49,1))
    set(handles.editepsxx,'string',parametersl(50,1))
    set(handles.editepsxxm,'string',parametersl(51,1))
    set(handles.editepsxx2,'string',parametersl(52,1))
    set(handles.editepsxy,'string',parametersl(53,1))
    set(handles.editepsxym,'string',parametersl(54,1))
    set(handles.editepsxy2,'string',parametersl(55,1))
    set(handles.editepsyy,'string',parametersl(56,1))
    set(handles.editepsyym,'string',parametersl(57,1))
    set(handles.editepsyy2,'string',parametersl(58,1))
    
    
    beep
    
end

function menusave_ClickedCallback(~, ~, handles)

parameters = zeros(47,1);

parameters(1,1) = str2double(get(handles.editwave,'string'));
parameters(2,1) = str2double(get(handles.editFourier,'string'));
parameters(3,1) = get(handles.radioTE,'value');
parameters(4,1) = get(handles.radioTM,'value');
parameters(5,1) = str2double(get(handles.editanglepol,'string'));
parameters(6,1) = str2double(get(handles.editanglei,'string'));
parameters(7,1) = str2double(get(handles.editanglemount,'string'));
parameters(9,1) = str2double(get(handles.editPeriodx,'string'));
parameters(10,1) = str2double(get(handles.editPeriody,'string'));
parameters(11,1) = str2double(get(handles.editFillAx,'string'));
parameters(12,1) = str2double(get(handles.editFillAy,'string'));
parameters(13,1) = str2double(get(handles.editFillAAx,'string'));
parameters(14,1) = str2double(get(handles.editFillAAy,'string'));
parameters(15,1) = str2double(get(handles.editPosAx,'string'));
parameters(16,1) = str2double(get(handles.editPosAy,'string'));
parameters(19,1) = str2double(get(handles.editpermisup,'string'));
parameters(20,1) = str2double(get(handles.editpermielementa,'string'));
parameters(21,1) = str2double(get(handles.editpermielementb,'string'));
parameters(22,1) = str2double(get(handles.editpermilayer2,'string'));
parameters(23,1) = str2double(get(handles.editpermisub,'string'));
parameters(24,1) = str2double(get(handles.editpermesup,'string'));
parameters(25,1) = str2double(get(handles.editpermeelementa,'string'));
parameters(26,1) = str2double(get(handles.editpermeelementb,'string'));
parameters(27,1) = str2double(get(handles.editpermelayer2,'string'));
parameters(28,1) = str2double(get(handles.editpermesub,'string'));
parameters(29,1) = str2double(get(handles.editReps,'string'));
parameters(30,1) = str2double(get(handles.editthick1,'string'));
parameters(31,1) = str2double(get(handles.editthick2,'string'));
parameters(32,1) = str2double(get(handles.editdefect,'string'));
parameters(33,1) = str2double(get(handles.editReps2,'string'));
parameters(34,1) = str2double(get(handles.editfrom,'string'));
parameters(35,1) = str2double(get(handles.editto,'string'));
parameters(36,1) = str2double(get(handles.editfp,'string'));
parameters(37,1) = str2double(get(handles.editG,'string'));
parameters(38,1) = str2double(get(handles.editf0,'string'));
parameters(39,1) = str2double(get(handles.editF,'string'));
parameters(41,1) = get(handles.checkrefl,'value');
parameters(42,1) = get(handles.checktrans,'value');
parameters(43,1) = get(handles.checkabsorption,'value');
parameters(45,1) = str2double(get(handles.editpoints,'string'));
parameters(46,1) = str2double(get(handles.editorder,'string'));
parameters(47,1) = str2double(get(handles.editorder2,'string'));
parameters(48,1) = str2double(get(handles.editnumberofrods,'string'));
parameters(49,1) = str2double(get(handles.editepszz,'string'));
parameters(50,1) = str2double(get(handles.editepsxx,'string'));
parameters(51,1) = str2double(get(handles.editepsxxm,'string'));
parameters(52,1) = str2double(get(handles.editepsxx2,'string'));
parameters(53,1) = str2double(get(handles.editepsxy,'string'));
parameters(54,1) = str2double(get(handles.editepsxym,'string'));
parameters(55,1) = str2double(get(handles.editepsxy2,'string'));
parameters(56,1) = str2double(get(handles.editepsyy,'string'));
parameters(57,1) = str2double(get(handles.editepsyym,'string'));
parameters(58,1) = str2double(get(handles.editepsyy2,'string'));

[filename,pathname] = uiputfile('parameters.txt','Save parameters');
if isequal(filename,0)
    set(handles.textoutput,'string','No parameters are saved.');
    beep
else
    set(handles.textoutput,'string',['Parameters are saved to file: ' filename]);
    dlmwrite(fullfile(pathname,filename),parameters,'precision',12);
    beep
end

function menuhelp_ClickedCallback(~, ~, ~)
open('Manual.pdf')

function menupremium_ClickedCallback(~, ~, handles)

if handles.fullversion == 1
    msgbox({'Congratulations! You have the full version of RawDog. Thank you! :)';'';...
        ['User: ' handles.username];...
        },'RawDog Full')
else
    msgbox({'This is the free version of RawDog. Automatic saves do not work. Please consider a donation for the full version. :)';['Visit ' handles.web ' for more info.'];'';...
        ['This is your hardware identity: ' handles.hardwarekey];'';...
        'After you have donated, please send your hardware identity with your request for the full version to gregmaster777@gmail.com';'';'Your hardware identity is now copied to the clipboard, you can paste it.'},'RawDog Free')
    clipboard('copy',handles.hardwarekey)
end

function menuinfo_ClickedCallback(~, ~, handles)

if handles.fullversion == 1
    msgbox({['Version: ' handles.version ' - Full'];'';...
        'In case of questions, bugs, tips or suggestions please contact by';'e-mail: gregmaster777@gmail.com';'';...
        ['Website: ' handles.web2];'';...
        ['All rights reserved. Copyright ' char(169) ' Gergely Kajtar']},'RawDog')
else
    msgbox({['Version: ' handles.version ' - Free'];'';...
        'In case of questions, bugs, tips or suggestions please contact by';'e-mail: gregmaster777@gmail.com';'';...
        ['Website: ' handles.web2];'';...
        ['All rights reserved. Copyright ' char(169) ' Gergely Kajtar']},'RawDog')
end

function menuini_ClickedCallback(~, ~, handles)

set(handles.editwave,'string','666')
set(handles.editFourier,'string','13')
set(handles.radioTE,'value',1)
set(handles.radioTM,'value',0)
set(handles.editanglepol,'string','0')
set(handles.editanglei,'string','0')
set(handles.editanglemount,'string','0')
set(handles.editPeriodx,'string','1000')
set(handles.editPeriody,'string','1000')
set(handles.editFillAx,'string','0.42')
set(handles.editFillAy,'string','0.42')
set(handles.editFillAAx,'string','0.42')
set(handles.editFillAAy,'string','0.42')
set(handles.editPosAx,'string','0.5')
set(handles.editPosAy,'string','0.5')
set(handles.editpermisup,'string','1 + 0i')
set(handles.editpermielementa,'string','7 + 0i')
set(handles.editpermielementb,'string','1 + 0i')
set(handles.editpermilayer2,'string','2 + 0i')
set(handles.editpermisub,'string','1 + 0i')
set(handles.editpermesup,'string','1 + 0i')
set(handles.editpermeelementa,'string','1 + 0i')
set(handles.editpermeelementb,'string','1 + 0i')
set(handles.editpermelayer2,'string','1 + 0i')
set(handles.editpermesub,'string','1 + 0i')
set(handles.editReps,'string','1')
set(handles.editthick1,'string','1000')
set(handles.editthick2,'string','0')
set(handles.editdefect,'string','0')
set(handles.editReps2,'string','0')
set(handles.editfrom,'string','0')
set(handles.editto,'string','1')
set(handles.editfp,'string','2147000')
set(handles.editG,'string','5000')
set(handles.editf0,'string','4')
set(handles.editF,'string','0.56')
set(handles.popupversus,'value',1)
set(handles.textfrom,'visible','off')
set(handles.editfrom,'visible','off')
set(handles.textto,'visible','off')
set(handles.editto,'visible','off')
set(handles.editpoints,'enable','off')
set(handles.editpoints,'string','1')
set(handles.editorder2,'string','0')
set(handles.editorder,'string','0')
set(handles.editwave,'enable','on')
set(handles.editanglei,'enable','on')
set(handles.editanglepol,'enable','on')
set(handles.editanglemount,'enable','on')
set(handles.editFourier,'enable','on')
set(handles.editthick1,'enable','on')
set(handles.editFillAx,'enable','on')
set(handles.editFillAy,'enable','on')
% set(handles.editorder2,'enable','off')
% set(handles.editorder,'enable','on')
set(handles.checkrefl,'value',1)
set(handles.checktrans,'value',1)
set(handles.checkabsorption,'value',0)
set(handles.editnumberofrods,'string',10)
set(handles.editepszz,'string',1)
set(handles.editepsxx,'string',12)
set(handles.editepsxxm,'string',4)
set(handles.editepsxx2,'string',1)
set(handles.editepsxy,'string',4)
set(handles.editepsxym,'string',0)
set(handles.editepsxy2,'string',1)
set(handles.editepsyy,'string',12)
set(handles.editepsyym,'string',4)
set(handles.editepsyy2,'string',1)

function menuclear_ClickedCallback(~, ~, handles)
set(handles.textoutput,'string','')
clear all
clc

function menuplasmon_ClickedCallback(~, ~, ~)

function menuindex_ClickedCallback(~, ~, handles)

eps =  str2double(get(handles.editpermielementa,'string'));
mu =  str2double(get(handles.editpermeelementa,'string'));

nR = real(sqrt(eps)*sqrt(mu));
nI = imag(sqrt(eps)*sqrt(mu));

set(handles.textoutput,'string',['The index of refraction is: n = '  num2str(nR) ' - ' num2str(nI) 'i'])
beep

function pushQH6_Callback(~, ~, ~)
open('Quick help 1.pdf')

function menubrowser_ClickedCallback(~, ~, ~)
web('http://rawdogapp.weebly.com','-browser')

function menumail_ClickedCallback(~, ~, ~)
web('mailto:gregmaster777@gmail.com','-browser')

function menufolder_ClickedCallback(~, ~, ~)
if ispc
    winopen(pwd)
else
    filebrowser
end